/*   

	Copyright (c) 2001 - 2004. All Rights Reserved.
	:  ..
*/
#pragma once

#include "System/Connection.h"

//  
const int PULSE_TIME = 100;   //  = 100 

//  
//#define GAME_LOG
//#define LOG_TYPE LGT_DET

//  
class CApp
{

public: //   

	_KERNEL CApp();
	_KERNEL ~CApp();

public: // 

	// 
	_KERNEL void Init();

	//  
	_KERNEL bool OpenSockets();

	// 
	_KERNEL void Shutdown();

	// 
	_KERNEL void Exit( int status );

	//  
	_KERNEL bool GameLoop();

	//      
	_KERNEL bool PlayerLoop();

	//  
	_KERNEL void PerformPulse();

	//   (64 )
	_KERNEL int64 GetTickCount( int type );

	//   
	_KERNEL void SetTimeMark();

public:

	// 
	int Version() const { return APP_VERSION; }

public: //  

	//   
	_KERNEL bool NewConnection( CSocket& motherSocket );

	//  
	_KERNEL void CloseConnection( CConnection* c, bool noLog );

	//    
	_KERNEL bool NewPlayerConnection( CSocket& motherSocket );

	//   
	_KERNEL void ClosePlayerConnection( CConnection* c );

public: //  

	CSocket m_motherSockets[MAX_PORTS]; //  

	CSocket m_extraSocket;         //  
	CConnection* m_extConnections; //   

	CConnection* m_connections;    //  
	CConnection* m_pConnections;   //   

	PArray<CConnection*> m_execConns; //     

	bool m_shutdown;               //  
	bool m_ctrlBreak;              //   Ctrl+break

	int64 m_curTime;   //  
	int64 m_pulseTime; //  

	SYSTEMTIME m_prevLocalTime; //   
	int64 m_prevSystemTime;     //   

};
