/*  

	Copyright (c) 2001 - 2004. All Rights Reserved.
	:  ..
*/
#pragma once
#include "DB/DBObject.h"
#include "DB/Color.h"
#include "DB/Char/BotData.h"

// 
const int MAX_ACCOUNT_NAME = 20;     //   
const int MAX_PASSWORD = 20;         //  

//    
class CColorData
{

public: // 

	CColorData() {}
	CColorData( int id ) : m_id( id ) {}
	CColorData( short id, byte tColor, byte bColor ) : m_id( id ), m_tColor( tColor ), m_bColor( bColor ) {}

public: // 

	bool operator==( const CColorData& d ) const { return m_id == d.m_id; }
	bool operator>=( const CColorData& d ) const { return m_id >= d.m_id; }

public: //   

	//   
	_KERNEL void Serialize( CFileStore& fs );

public: // 

	short m_id;    //  
	byte m_tColor; //   
	byte m_bColor; //   

};

//  
/*
class CHandCmdFormInfo
{

public: // 

	CHandCmdFormInfo() : m_len( 0 ), m_reg( 0 ), m_num( 0 )
	{}

	CHandCmdFormInfo( char* cmd )
	{
		//  
		m_len = strlen( cmd );
		//  
		int i;
		for( i = 0, m_reg = 0; i < m_len; i++ )
		{
			m_reg <<= 1;
			if( ( cmd[i] >= 'A' && cmd[i] <= 'Z' ) || ( cmd[i] >= '' && cmd[i] <= '' ) || cmd[i] == '' )
				m_reg |= 1;
		}
		//  
		m_num = 1;
	}

public: // 

	byte m_len; //  
	short m_reg; //  
	int m_num; //  

};*/

//   
class CHandWritingInfo
{

public: //   

	_KERNEL CHandWritingInfo();
	_KERNEL ~CHandWritingInfo();

public: // 

	//  
	_KERNEL static int Compare( CHandWritingInfo* hw1, CHandWritingInfo* hw2 );

public: // 

	//    
	//   
	int** m_cmdForms;

};

/*
//   
class CHandCmdInfo
{

public: // 

	CHandCmdInfo() : m_cmdInfo( NULL )
	{}

	CHandCmdInfo( CCommandInfo* ci ) : m_cmdInfo( ci )
	{}

public: // 

	CCommandInfo* m_cmdInfo; // 
	PArray< CHandCmdFormInfo* > m_cmdForms; // 

};

//  
class CHandSpellFormInfo
{

public: // 

	CHandSpellFormInfo() : m_delim( '.' ), m_len1( 0 ), m_len2( 0 ), m_len3( 0 ), m_num( 0 )
	{}

	CHandSpellFormInfo( char* cmd )
	{
		int i;
		int tNum = 0; //  
		int tLen = strlen( cmd ); //  
		m_num = 1; m_len1 = 0; m_len2 = 0; m_len3 = 0;
		for( i = 0; i < tLen; i++ )
		{
			if( cmd[i] == '.' || cmd[i] == '-' || cmd[i] == '_' )
				{ m_delim = cmd[i]; tNum++; }
			else if( tNum == 0 ) m_len1++;
			else if( tNum == 1 ) m_len2++;
			else if( tNum == 2 ) m_len3++;
		}
	}

public: // 

	byte m_delim; // 
	byte m_len1;
	byte m_len2;  //  
	byte m_len3;
	int m_num;    //  

};

//   
class CHandSpellInfo
{

public: // 

	CHandSpellInfo() : m_spellInfo( NULL )
	{}

	CHandSpellInfo( CSpell* spl ) : m_spellInfo( spl )
	{}

public: // 

	CSpell *m_spellInfo; // 
	PArray< CHandSpellFormInfo* > m_spellForms; // 

};

//   
class CHandWritingInfo
{

public: //   

	~CHandWritingInfo();

public: // 

	//  
	_KERNEL static int Compare( CHandWritingInfo* hw1, CHandWritingInfo* hw2 );

public: // 

	//  
	PArray< CHandCmdInfo* > m_cmdForms;

	//  
	PArray< char* > m_phraseForms;

	//  
	PArray< CHandSpellInfo* > m_spellForms;

	//    
	//   
	//  int** m_cmdForms;

};*/

//    
class NoBotData
{

public: // 

	NoBotData() :
		m_noBotMode( 0 ), m_noBotTime( 0 ), m_noBotPulse( 0 ), m_checkPulse( 0 )
	{}

public: // 

	byte m_noBotMode;  // 
	byte m_noBotTime;  //  
	uint m_noBotPulse; //  
	uint m_checkPulse; //  

};

// 
class CAccount : public CDBObject
{

public: // 

	~CAccount() { if(m_handInfo) delete m_handInfo; }

public: // 

	bool operator==( const CAccount& a ) const { return strcmp( m_name, a.m_name ) == 0; }
	bool operator>=( const CAccount& a ) const { return strcmp( m_name, a.m_name ) >= 0; }

public: //   

	//   
	_KERNEL void InitNew();

	//   
	_KERNEL void Serialize( CFileStore& fs );

	//  
	_KERNEL void Link();

public: // 

	//  
	_KERNEL void Login( CConnection* con );

	//  
	_KERNEL void Logout( bool noLog );

	//  
	_KERNEL bool CanAccess( AccessFlags flag );

	//  
	_KERNEL void PerformPulse();

	//    
	_KERNEL bool HasChars();

	//      
	_KERNEL void HandWriting( const char* text );

	//   
	_KERNEL void MultChanged();

	//    
	_KERNEL byte getNoBotMode() { return m_noBotData ? m_noBotData->m_noBotMode : 0; }
	_KERNEL void setNoBotMode( byte val );

	//    
	_KERNEL byte getNoBotTime() { return m_noBotData ? m_noBotData->m_noBotTime : 0; }
	_KERNEL void setNoBotTime( byte val );
	_KERNEL uint getNoBotPulse() { return m_noBotData ? m_noBotData->m_noBotPulse : 0; }
	_KERNEL void setNoBotPulse( uint val );
	_KERNEL uint getNoBotCheckPulse() { return m_noBotData ? m_noBotData->m_checkPulse : 0; }

	//     
	_KERNEL char* GetNoBotTime();

	//     
	_KERNEL void NoBotTurnOff();

public: // CDBObject

	//   
	_KERNEL bool GetField( char* field, char* param, CCharPlayer* cp );

	//   
	_KERNEL bool SetField( char* field, char* param, const char* text );

public: // 

	int  m_id;                         // 
	char m_name[MAX_ACCOUNT_NAME+1];   //  
	char m_mask[MAX_ACCOUNT_NAME+1];   //  
	char m_pass[MAX_PASSWORD+1];       // 
	bool m_hide;                       // 

	//  
	CString m_mail;  //  
	CString m_fio;   // 
	CString m_age;   // 
	CString m_city;  //  
	CString m_place; //  
	CString m_immNote;  //   

	int m_donateMoney;      //  

	int m_access;           //  
	uint m_awayPulse;       // ,    

	uint m_mute;            // ,    
	CCharPlayer* m_muteImm; //   
	CString m_reason;       // 
	uint m_lastAutoMute;    //   
	int m_botHellCount;     //    

	uint m_ripPulse;        //       

	CCharPlayer* m_char;   //  

	time_t m_created;      //  
	time_t m_lastLogin;    //   
	time_t m_lastLogout;   //   
	uint   m_lastPulse;    //   
	uint   m_logoutPulse;  //   
	IpAddr m_ips[10];     // IP  10 

	time_t m_lastNews;     //    

	int  m_oldVars[MV_COUNT_OLD]; //    ( )
	byte m_aVars[AMV_COUNT];      //   
	Set<CColorData> m_colors;     //  

	byte m_accType;        //  

	CConnection* m_conn;   //  
	CConnection* m_owner;  // ,    

	NoBotData* m_noBotData; //    
    CBotCheckFailed m_botFailData; //  

	CHandWritingInfo* m_handInfo; //   

};

//    
class CAccount2 : public CAccount
{

public: // 

	bool operator==( const CAccount2& a ) const { return m_id == a.m_id; }
	bool operator>=( const CAccount2& a ) const { return m_id >= a.m_id; }

};

