/*  

	Copyright (c) 2001 - 2004. All Rights Reserved.
	:  ..
*/
#pragma once
#include "DB/Subject/PriceBase.h"

//  
class CAffectGrade
{

public: // 

	CAffectGrade( const char* name, byte id, byte val ) : m_affID( (AffectID)id ), m_affValue( val )
	{
		int len = strlen( name );
		m_affectName = new char[len+1];
		memcpy( m_affectName, name, len+1 );
	}

public: // 

	char *m_affectName; //  
	byte m_affID;       // 
	byte m_affValue;    // 

};

// 
class CAffect
{

public: // 

    _KERNEL CAffect();

public: // 

	//  
	_KERNEL static void InitTable( CAffect* affects[] );

	//     
	_KERNEL virtual void Apply( CChar* c, PkFlag pkFlag = APF_NOPK, int value = 0 ) {}

	//     
	_KERNEL virtual void Show( CChar* c, bool on, PkFlag pkFlag, bool halfPk = false );

	//   
	_KERNEL virtual char* ShowString( bool toMe, int value ) { return m_smallName; }

	//   
	_KERNEL virtual void PerformDispel( CChar* c, PkFlag pkFlag, bool halfPk = false );

	//   
	_KERNEL virtual short UniqPerc( int profID ) { return 0; }

	//   
	_KERNEL short price( byte type ) { return m_price->price( type ); }

	//  
	_KERNEL virtual bool negative( int value ) { return m_negative; }

public: // 

	byte m_id;                 // 
	byte m_affectType;         //  

	char* m_name;              // 
	char* m_mask;              // 
	char* m_smallName;         //    
	char* m_bigName;           //   

	char* m_title;             //  
	char* m_form;              //   ()

	byte m_sphere;             //   (    )

	ColorItemID m_clrOn;       // Id   
	const char* m_msgOnSelf;   //  
	byte m_typeOnSelf;         //   
	const char* m_msgOnOther;  //  
	byte m_typeOnOther;        //   
	byte* m_argsOnOther;       //   

	ColorItemID m_clrOff;      // Id   
	const char* m_msgOffSelf;  //  
	byte m_typeOffSelf;        //   
	const char* m_msgOffOther; //  
	byte m_typeOffOther;       //   
	byte* m_argsOffOther;      //   

	bool m_dispel;             //  
	bool m_noRent;             //       
	bool m_noArena;            //       
	bool m_negative;           //  
	bool m_pkAffect;           //    -

	byte m_uniqLev;            //         

	CBonusParam* m_price;      //  

    ushort m_aiFlag;           //   
};
