/*    

	Copyright (c) 2016. All Rights Reserved.
	:  ..
*/
#pragma once

class COblivionNode;

//     
struct CShelterZoneInfo
{
    CShelterZoneInfo( int zoneId, uint pulse ) :
        m_zoneId( zoneId ), m_pulse( pulse )
    {}

    // 
    bool Compare( int value, uint uType )
    {
        if( uType == SCT_ID )
            return m_zoneId == value;
        return false;
    }

    int m_zoneId; // 
    uint m_pulse; //  
};


//     
struct CShelterZonesData
{
    void CheckZones();

    PArray<CShelterZoneInfo*> m_zones;
};


//    
class CCharExtDataNode
{

public: // 

    enum ThrowType { ttNone, ttEdge, ttHandle };

    CCharExtDataNode( int id ) :
        m_id( id )
    {}

public: // 

    //  
    static CCharExtDataNode* CreateNode( int id );

    //  
    virtual bool IsEmpty() { return true; }

    //   
    virtual bool IsStoring() { return false; }

    // 
    virtual void Serialize( CFileStore& fs ) {}

    //  
    virtual CMobPrototype* turnProt() { return NULL; }
    virtual void setTurnProt( CMobPrototype* prot ) {}

    //  
    virtual int turnPower() { return 0; }
    virtual void setTurnPower( int power ) {}

    // - 
    virtual int turnPowerPk() { return 0; }
    virtual void setTurnPowerPk( int power ) {}

    //  
    virtual byte drainLevel() { return 0; }
    virtual void setDrainLevel( byte power ) {}

    //  
    virtual CChar* cryChar() { return NULL; }
    virtual void setCryChar( CChar* c ) {}

    // 
    virtual PArray<COblivionNode*>* oblivion() { return NULL; }
    virtual void setOblivion( PArray<COblivionNode*>* oblivion ) {}

    // 
    virtual CChar* anger() { return NULL; }
    virtual void setAnger( CChar* c ) {}

    //  
    virtual CChar* holyCaster() { return NULL; }
    virtual void setHolyCaster( CChar* c ) {}

    // 
    virtual PArray<CChar*>* aims() { return NULL; }
    virtual void setAims( PArray<CChar*>* aims ) {}

    // - 
    virtual CMobPrototype* charmPk() { return NULL; }
    virtual void setCharmPk( CMobPrototype* prot ) {}

    //   
    virtual CShelterZonesData* shelterZones() { return NULL; }
    virtual void setShelterZones( CShelterZonesData* zonesData ) {}

    //  
    virtual CCharExtDataNode::ThrowType throwType() { return ttNone; }
    virtual void setThrowType( CCharExtDataNode::ThrowType type ) {}

    //  
    virtual int bonusReagent() { return 0; }
    virtual void setBonusReagent( int bonus ) {}

    //  
    virtual int bonusExp() { return 0; }
    virtual void setBonusExp( int bonus ) {}

    //  
    virtual int bonusAbility() { return 0; }
    virtual void setBonusAbility( int bonus ) {}

public: // 

    int m_id;      // 

};

//   :  
class CTurnProtCharExtDataNode : public CCharExtDataNode
{

public: // 

    CTurnProtCharExtDataNode( CMobPrototype* prot = NULL ) :
        CCharExtDataNode( CEDT_TURNPROT ),
        m_prot( prot )
    {}

public: // 

    //  
    bool IsEmpty() { return m_prot == NULL; }

    //  
    CMobPrototype* turnProt() { return m_prot; }
    void setTurnProt( CMobPrototype* prot ) { m_prot = prot; }

public: // 

    CMobPrototype* m_prot;   //  

};

//   :  
class CTurnPowerCharExtDataNode : public CCharExtDataNode
{

public: // 

    CTurnPowerCharExtDataNode( int power = 0 ) :
        CCharExtDataNode( CEDT_TURNPOWER ),
        m_power( power )
    {}

public: // 

    //  
    bool IsEmpty() { return m_power == 0; }

    //  
    int turnPower() { return m_power; }
    void setTurnPower( int power ) { m_power = power; }

public: // 

    int m_power;   //  

};

//   : - 
class CTurnPowerPkCharExtDataNode : public CCharExtDataNode
{

public: // 

    CTurnPowerPkCharExtDataNode( int power = 0 ) :
        CCharExtDataNode( CEDT_TURNPOWERPK ),
        m_power( power )
    {}

public: // 

    //  
    bool IsEmpty() { return m_power == 0; }

    // - 
    int turnPowerPk() { return m_power; }
    void setTurnPowerPk( int power ) { m_power = power; }

public: // 

    int m_power;   // - 

};

//   :  
class CDrainLevelCharExtDataNode : public CCharExtDataNode
{

public: // 

    CDrainLevelCharExtDataNode( byte level = 0 ) :
        CCharExtDataNode( CEDT_DRAINLEVEL ),
        m_level( level )
    {}

public: // 

    //  
    bool IsEmpty() { return m_level == NULL; }

    //  
    byte drainLevel() { return m_level; }
    void setDrainLevel( byte level ) { m_level = level; }

public: // 

    byte m_level;   //  

};

//   :  
class CCryCharCharExtDataNode : public CCharExtDataNode
{

public: // 

    CCryCharCharExtDataNode( CChar* c = NULL ) :
        CCharExtDataNode( CEDT_CRYCHAR ),
        m_char( c )
    {}

public: // 

    //  
    bool IsEmpty() { return m_char == NULL; }

    //  
    CChar* cryChar() { return m_char; }
    void setCryChar( CChar* c ) { m_char = c; }

public: // 

    CChar* m_char;   //  

};

//   : 
class COblivionCharExtDataNode : public CCharExtDataNode
{

public: // 

    COblivionCharExtDataNode( PArray<COblivionNode*>* oblivion = NULL ) :
        CCharExtDataNode( CEDT_OBLIVION ),
        m_oblivion( oblivion )
    {}

public: // 

    //  
    bool IsEmpty() { return m_oblivion == NULL; }

    // 
    PArray<COblivionNode*>* oblivion() { return m_oblivion; }
    void setOblivion( PArray<COblivionNode*>* oblivion );

public: // 

    PArray<COblivionNode*>* m_oblivion;   // 

};

//   : 
class CAngerCharExtDataNode : public CCharExtDataNode
{

public: // 

    CAngerCharExtDataNode( CChar* c = NULL ) :
        CCharExtDataNode( CEDT_ANGER ),
        m_char( c )
    {}

public: // 

    //  
    bool IsEmpty() { return m_char == NULL; }

    // 
    CChar* anger() { return m_char; }
    void setAnger( CChar* c ) { m_char = c; }

public: // 

    CChar* m_char;   // 

};

//   :  
class CHolyCasterCharExtDataNode : public CCharExtDataNode
{

public: // 

    CHolyCasterCharExtDataNode( CChar* c = NULL ) :
        CCharExtDataNode( CEDT_HOLYCASTER ),
        m_char( c )
    {}

public: // 

    //  
    bool IsEmpty() { return m_char == NULL; }

    //  
    CChar* holyCaster() { return m_char; }
    void setHolyCaster( CChar* c ) { m_char = c; }

public: // 

    CChar* m_char;   //  

};

//   : 
class CAimsCharExtDataNode : public CCharExtDataNode
{

public: // 

    CAimsCharExtDataNode( PArray<CChar*>* aims = NULL ) :
        CCharExtDataNode( CEDT_AIMS ),
        m_aims( aims )
    {}

public: // 

    //  
    bool IsEmpty() { return m_aims == NULL; }

    // 
    PArray<CChar*>* aims() { return m_aims; }
    void setAims( PArray<CChar*>* aims );

public: // 

    PArray<CChar*>* m_aims;   // 

};

//   : - 
class CCharmPkCharExtDataNode : public CCharExtDataNode
{

public: // 

    CCharmPkCharExtDataNode( CMobPrototype* prot = NULL ) :
        CCharExtDataNode( CEDT_CHARMPK ),
        m_prot( prot )
    {}

public: // 

    //  
    bool IsEmpty() { return m_prot == NULL; }

    // - 
    CMobPrototype* charmPk() { return m_prot; }
    void setCharmPk( CMobPrototype* prot ) { m_prot = prot; }

public: // 

    CMobPrototype* m_prot;   // - 

};


//   :   
class CShelterZoneCharExtDataNode : public CCharExtDataNode
{

public: // 

    CShelterZoneCharExtDataNode( CShelterZonesData* zonesData = NULL ) :
        CCharExtDataNode( CEDT_SHELTERZONE ),
        m_zonesData( zonesData )
    {}

public: // 

    //  
    bool IsEmpty() { return m_zonesData == NULL; }

    //   
    CShelterZonesData* shelterZones() { return m_zonesData; }
    void setShelterZones( CShelterZonesData* zonesData ) { m_zonesData = zonesData; }

public: // 

    CShelterZonesData* m_zonesData;   //   

};


//   :  
class CThrowTypeCharExtDataNode : public CCharExtDataNode
{

public: // 

    CThrowTypeCharExtDataNode( ThrowType type = ttNone ) :
        CCharExtDataNode( CEDT_THROWTYPE ),
        m_type( type )
    {}

public: // 

    //  
    bool IsEmpty() { return m_type == ttNone; }

    //   
    virtual bool IsStoring() { return true; }

    // 
    virtual void Serialize( CFileStore& fs );

    //  
    ThrowType throwType() { return m_type; }
    void setThrowType( ThrowType type ) { m_type = type; }

public: // 

    ThrowType m_type; //  

};


//   :  
class CZoneDataCharExtDataNode : public CCharExtDataNode
{

public: // 

    CZoneDataCharExtDataNode( int zoneId = 0, void* data = NULL ) :
        CCharExtDataNode( CEDT_ZONEDATA ),
        m_zoneId( zoneId ),
        m_data( data )
    {}

public: // 

    //  
    bool IsEmpty() { return m_data == nullptr; }

public: // 

    int m_zoneId;   // 
    void* m_data;   // 

};


//   :  
class CBonusReagentCharExtDataNode : public CCharExtDataNode
{

public: // 

    CBonusReagentCharExtDataNode( int bonus = 0 ) :
        CCharExtDataNode( CEDT_REAGENT ),
        m_bonus( bonus )
    {}

public: // 

    //  
    bool IsEmpty() { return m_bonus == 0; }

    //  
    int bonusReagent() { return m_bonus; }
    void setBonusReagent( int bonus ) { m_bonus = bonus; }

public: // 

    int m_bonus;   //  

};


//   :  
class CBonusExpCharExtDataNode : public CCharExtDataNode
{

public: // 

    CBonusExpCharExtDataNode( int bonus = 0 ) :
        CCharExtDataNode( CEDT_EXP ),
        m_bonus( bonus )
    {}

public: // 

    //  
    bool IsEmpty() { return m_bonus == 0; }

    //  
    int bonusExp() { return m_bonus; }
    void setBonusExp( int bonus ) { m_bonus = bonus; }

public: // 

    int m_bonus;   //  

};


//   :  
class CBonusAbilityCharExtDataNode : public CCharExtDataNode
{

public: // 

    CBonusAbilityCharExtDataNode( int bonus = 0 ) :
        CCharExtDataNode( CEDT_ABILITY ),
        m_bonus( bonus )
    {}

public: // 

    //  
    bool IsEmpty() { return m_bonus == 0; }

    //  
    int bonusAbility() { return m_bonus; }
    void setBonusAbility( int bonus ) { m_bonus = bonus; }

public: // 

    int m_bonus;   //  

};


//   
class CCharExtData
{

public: // 

    ~CCharExtData()
    {
        m_nodes.Delete();
    }

public: // 

    //  
    CMobPrototype* turnProt();
    void setTurnProt( CMobPrototype* prot );

    //  
    int turnPower();
    void setTurnPower( int power );

    // - 
    int turnPowerPk();
    void setTurnPowerPk( int power );

    //  
    byte drainLevel();
    void setDrainLevel( byte power );

    //  
    CChar* cryChar();
    void setCryChar( CChar* c );

    // 
    PArray<COblivionNode*>* oblivion();
    void setOblivion( PArray<COblivionNode*>* oblivion );

    // 
    CChar* anger();
    void setAnger( CChar* c );

    //  
    CChar* holyCaster();
    void setHolyCaster( CChar* c );

    // 
    PArray<CChar*>* aims();
    void setAims( PArray<CChar*>* aims );

    // - 
    CMobPrototype* charmPk();
    void setCharmPk( CMobPrototype* prot );

    //   
    CShelterZonesData* shelterZones();
    void setShelterZones( CShelterZonesData* zonesData );

    //  
    CCharExtDataNode::ThrowType throwType();
    void setThrowType( CCharExtDataNode::ThrowType type );

    //  
    void* getZoneData( int zoneId );
    void setZoneData( int zoneId, void* pData );

    //  
    int bonusReagent();
    void setBonusReagent( int bonus );

    //  
    int bonusExp();
    void setBonusExp( int bonus );

    //  
    int bonusAbility();
    void setBonusAbility( int bonus );

    //  
    CCharExtDataNode* FindNode( int id );

    //  
    CCharExtDataNode* GetNode( int id );

    //  
    bool IsEmpty();

    //   
    int SaveCount();

    // 
    void Serialize( CFileStore& fs );

public: // 

    PArray<CCharExtDataNode*> m_nodes; // 

};
