/*  -

    Copyright (c) 2001 - 2004. All Rights Reserved.
    :  ..
*/
#pragma once
#include "DB/Char/Char.h"
#include "DB/Char/MobPrototype.h"

// 
class FightSituation;

//   
class CCharMobStats : public CCharStats
{

public: // 

    _KERNEL CCharMobStats();

};

//  
class CVisitedInst
{

public: //   

    CVisitedInst( CZone* zone = NULL, int instIdx = 0 /*CZoneInstance* inst = NULL*/ ) :
        m_zone( zone ), m_instIdx( instIdx )
    {}

    ~CVisitedInst() {}

public: // 

    CZone* m_zone;         // 
    int m_instIdx;         // 
    //CZoneInstance* m_inst; // 

};

// -
class CCharMob : public CChar
{

public: // 

    _KERNEL CCharMob( CMobPrototype* prot, CZoneInstance* zoneInst = NULL, CMobPopData* popData = NULL );

public: // 

    _KERNEL ~CCharMob();

public:

    // 
    _KERNEL void InitNew();

public: // CChar

    //  
    _KERNEL CBaseMobPrototype* prot() { return m_prot; }

    //   
    _KERNEL CMobPrototype* baseProt() { return m_prot->prot(); }

    //    -
    _KERNEL CBaseMobPrototype* protPkFlag( PkFlag pkFlag );

    //     -
    _KERNEL CMobPrototype* baseProtPkFlag( PkFlag pkFlag );

    // Id 
    _KERNEL int id() { return baseProt()->m_id; }

    //  
    _KERNEL bool isMob() { return true; }

    //   
    _KERNEL bool isPlayerOrCharm() { return m_mentalOwner != NULL; }

    // 
    _KERNEL int flags() { return m_flags ? *m_flags : prot()->flags(); }

    //  
    _KERNEL bool isHotelOwner() { return (flags() & MF_RENTER) != 0; }

    // 
    _KERNEL bool isBanker() { return (flags() & MF_BANKER) != 0; }

    // 
    _KERNEL bool isStorer() { return (flags() & MF_STORER) != 0; }

    // 
    _KERNEL bool isSeller() { return (flags() & MF_SELLER) != 0; }

    //   
    _KERNEL CShop* shop();

    //  
    _KERNEL bool isRepairman() { return (flags() & MF_REPAIR) != 0; }

    // 
    _KERNEL bool isPeaceful() { return (flags() & MF_PEACEFUL) != 0; }

    //   
    _KERNEL bool isAssist( CCharMob* m ) { return ( isFriend( m ) && ( ( flags() & MF_ASSIST ) || ( m->groupLeader() == groupLeader() ) ) ); }

    //  
    _KERNEL bool isLooter() { return (flags() & MF_LOOTER) != 0; }

    //  
    _KERNEL bool noCorpse() { return (flags() & MF_NO_CORPSE) != 0; }

    //    
    _KERNEL bool noCry() { return (flags() & MF_NO_CRY) != 0; }

    // 
    _KERNEL bool noLegs() { return (flags() & MF_NO_LEGS) != 0; }

    //   
    _KERNEL bool isEnemy( CChar* c );

    //   
    _KERNEL bool isFriend( CChar* c );

    //    
    _KERNEL bool isAgro( CCharPlayer* cp );

    //  -
    _KERNEL bool CheckAgro( CChar* c, bool noMsg = false );

    //   -
    _KERNEL void AddAgroMemory( CCharPlayer* cp ) { m_agroMemory.add( cp ); }

    //  -
    _KERNEL void FlushAgroMemory() { m_agroMemory.flush(); }

    //   
    _KERNEL bool inGame() { return m_room != NULL; }

    //  
    _KERNEL virtual int resistMax( int type );

    // 
    _KERNEL byte complex() { return zoneInst() ? zoneInst()->m_complex : 0; }

    //   6 
    _KERNEL const char* realName( int i = 0 ) { return baseProt()->m_name[i]; }

    // 
    _KERNEL const char* realMask() { return baseProt()->m_mask; }

    // 
    _KERNEL const char* realText() { return m_text ? *m_text : baseProt()->m_text; }

    // 
    _KERNEL const char* realDesc() { return baseProt()->m_desc; }

    // 
    _KERNEL Gender realGender() { return (Gender)baseProt()->m_gender; }

    //   (  )
    _KERNEL int realLevel() { return prot()->level(); }

    // 
    _KERNEL CProfession* prof() { return baseProt()->m_prof; }

    // 
    _KERNEL CRace* race() { return baseProt()->m_race; }

    //  
    _KERNEL CCharPlayer* mentalOwner() { return m_mentalOwner; }

    //  ,      (    )
    _KERNEL CCharPlayer* playerContext() { return m_mentalOwner; }

    //   -
    _KERNEL bool isPK() { return playerContext() != NULL || (flags() & MF_ARENA); }

    // - 
    _KERNEL PkFlag mobPkFlag() { return isPK() ? APF_PK : APF_NOPK; }

    // 
    _KERNEL int poltroon( PkFlag pkFlag = APF_NOPK );

    //   
    _KERNEL bool realHasWeaponSkill( int id ) { return true; }

    //   
    _KERNEL bool realHasSkill( int id ) { return prot()->hasSkill( id ); }

    //  
    _KERNEL bool realHasSpell( int id ) { return prot()->hasSpell( id ); }

    //    
    _KERNEL bool realHasAnyWeaponSkill() { return true; }

    //    
    _KERNEL bool realHasAnySkill() { return m_prot->realHasAnySkill(); }

    //   
    _KERNEL bool realHasAnySpell() { return m_prot->realHasAnySpell(); }

    //  
    _KERNEL int weaponSkill( int id, PkFlag pkFlag = APF_NOPK ) { return 0; }

    // 
    _KERNEL int skill( int id, PkFlag pkFlag = APF_NOPK );

    //  
    _KERNEL int skillGrade( int skillId, PkFlag pkFlag = APF_NOPK );

    // 
    _KERNEL int spell( int id, PkFlag pkFlag = APF_NOPK );

    //    
    _KERNEL virtual int skillHitroll( int i, PkFlag pkFlag = APF_NOPK ) { return 0; }

    //  
    _KERNEL int specRes( int sr ) { return prot()->specRes( sr ); }

    //   
    _KERNEL double specResK( int sr ) { return ( 100 - prot()->specRes( sr ) )/100.0; }

    //   
    _KERNEL double specResistsK( int r1, int r2 = SR_NONE, int r3 = SR_NONE );

    //    
    _KERNEL double levelK( CChar* target );

    //   
    _KERNEL uint64 money() { return m_money; }
    _KERNEL void setMoney( uint64 m ) { m_money = (uint)m; }

    //  -  
    _KERNEL CObjPrototype* corpseProt() { return baseProt()->corpseProt(); }

    //  -  
    _KERNEL CObjPrototype* statueProt() { return baseProt()->statueProt(); }

    //   
    _KERNEL CDamageType* handDamType() { return baseProt()->m_damType; }

    //   
    _KERNEL CDamageStr* handDamStr() { return baseProt()->m_damStr; }

    //  
    _KERNEL CWalkMethod* realWalkMethod();

    //   - /
    _KERNEL bool attackIsNear();

    //   - /
    _KERNEL bool weaponIsNear();

    //   
    _KERNEL bool canFear();

    //      
    _KERNEL bool letToMove( RoomExit exit );

    //   
    _KERNEL int primeHitNumb( bool& shot, PkFlag pkFlag = APF_NOPK );

    //   
    _KERNEL int offHitNumb( PkFlag pkFlag = APF_NOPK ) { return 0; }

    //    
    _KERNEL int staffHitNumb( PkFlag pkFlag = APF_NOPK ) { return 0; }

    //  
    _KERNEL int stunPerc( PkFlag pkFlag = APF_NOPK );

    //      
    _KERNEL bool CheckHeavyHand( PkFlag pkFlag = APF_NOPK ) { return false; }

    //    
    _KERNEL bool ThrowBlockDice( int hitroll, CChar* hiter, PkFlag pkFlag = APF_NOPK );

    //    
    _KERNEL bool ThrowParryDice( int hitroll, CChar* hiter, PkFlag pkFlag = APF_NOPK );

    //    
    _KERNEL bool ThrowEvadeDice( int hitroll, CChar* hiter, PkFlag pkFlag = APF_NOPK );

    //    
    _KERNEL int ThrowDamageDice( CWeaponSkill* wSkill, PkFlag pkFlag = APF_NOPK );

    //   
    _KERNEL bool PerformCustomHit( CChar* c, int knockNum, bool nearFight );

    //   
    _KERNEL bool takeObjects() { return !(flags() & MF_NOTAKEOBJS); }

    //      ''
    _KERNEL bool visibleWho( CCharPlayer* player ) { return false; }

    //   
    _KERNEL int handlerFlags() { return baseProt()->m_handlerFlags; }

    // - 
    _KERNEL int handler( CMobTriggerData* data ) { return baseProt()->handler( data ); }

    //  
    _KERNEL bool CanTrigger( int flag, void* param = NULL, BOOL bSkipExec = FALSE ) { return baseProt()->m_trgs->CanTrigger( flag, this, param, bSkipExec ); }

    //  
    _KERNEL int ProcessTrigger( CMobTriggerData* data ) { return baseProt()->m_trgs->ProcessTrigger( data ); }

    //   
    _KERNEL void Send( const char* text ) {}

    //    
    _KERNEL void SendWithPages( char* text, bool autoDelete, bool color = true ) {}

    //   
    _KERNEL void SendFormat( const char* text, ... ) {}

    //     
    _KERNEL void SendFormatDmg( int damage, const char* text, ... ) {}

    //    ( ) (  )
    _KERNEL void SendFormatU( const char* text, ... ) {}

    //    ( ) (  )
    _KERNEL void SendFormatUDmg( int damage, const char* text, ... ) {}

    //  ,    
    _KERNEL void SendCharView( CChar* c ) {}

    //    
    _KERNEL void SendStatus() {}

    //    
    _KERNEL void SendMissStr( int hitType, HitCheck check, CChar* hiter, CChar* target, char* warCryName, CDamageStr* damStr, CWeaponSubject* weapon = 0 ) {}

    //    
    _KERNEL void SendHitStr( int hitType, CChar* hiter, CChar* target, char* warCryName, CDamageStr* damStr, int damage, int causedDamage, bool critical, CWeaponSubject* weapon = NULL ) {}

    //   
    _KERNEL void SendFightMsg( byte msgType, CChar* hiter, CChar* target, int nCausedDamage = 0, CDamageStr* damStr = NULL ) {}

    //  
    _KERNEL void UpdateStats( PkFlag pkFlag = APF_NOPK );

    //    
    _KERNEL void ApplyEquipMod( int type, CModifier* mod, int value, PkFlag pkFlag, bool fullPk = false );

    //  
    _KERNEL void Force( CChar* who, const char* cmd );

    //  
    _KERNEL void RandomMove();

    //  
    _KERNEL void RIP( CChar* who = NULL, bool toStone = false, bool noSignsOfDeath = false, PkFlag pkFlag = APF_NOPK, bool dtRip = false );

    //         
    _KERNEL void ClearRIP();

    //    
    _KERNEL void LoadOnCorpse( CSubject* corpse, CChar *who );

    //  
    _KERNEL void LoadMoney();

    //  
    _KERNEL void Repop( bool init = false );

    //  
    _KERNEL void LoadObjs( bool repop = false, bool init = false );

    //     
    _KERNEL void ClearFromMobMemory( CCharPlayer* cp );

    // 
    _KERNEL void Drink( const char* args );

    //   
    //_KERNEL void CalcFightPoints( CChar* who );

    // 
    _KERNEL virtual void Shelter( const char* args ) {}

    //  
    _KERNEL void updateFlags( int newFlags, bool set = true );

public: //  

    //   
    _KERNEL void SetMentalOwner( CCharPlayer* cp, int mobPkProtId = 0 );

    //   
    _KERNEL void ClearMentalOwner();

public: //   

    //     
    _KERNEL bool isRepopLeader();

    //     
    _KERNEL bool isRepopFollower();

    //  ,     
    _KERNEL CCharMob* repopLeader();

public: //  

    //  
    _KERNEL void PerformPulse( PkFlag pkFlag = APF_NOPK );

public: // AI

    //  
    _KERNEL virtual void GetAISettings( CProfession*& prof, CProfAI*& profAI, CMobSkillData*& skillData, CMobSpellData*& spellData );
    _KERNEL virtual void SetAISettings( CProfession* prof, CProfAI* profAI, CMobSkillData* skillData, CMobSpellData* spellData );

    //  
    _KERNEL virtual bool LookAI( FightSituation& fs );

    //   
    _KERNEL bool LookBasicAI( FightSituation& fs );

    //  
    _KERNEL virtual bool StandAI( FightSituation& fs );

    //   
    _KERNEL bool StandBasicAI( FightSituation& fs );

    //  
    _KERNEL virtual bool FightAI( FightSituation& fs );

    //   
    _KERNEL bool FightBasicAI( FightSituation& fs );

    //    
    _KERNEL virtual void AttackTarget( CChar* target );

    //    
    _KERNEL void AttackBasicTarget( CChar* target );

    //   
    _KERNEL virtual void AssistFriend( CCharMob* mob );

    //   
    _KERNEL bool CustomAbilityAI( FightSituation& fs, CCustomAbility* ability );

    //   
    _KERNEL ushort protAIFlags() { return m_prot->aiFlags(); }

public: //  

    //     
    _KERNEL CChar* SelectDamageTarget( FightSituation& fs, bool magic );

    //    
    _KERNEL CChar* SelectStabTarget( FightSituation& fs );

    //    
    _KERNEL CChar* SelectPushTarget( FightSituation& fs );

    //    
    _KERNEL CChar* SelectBashTarget( FightSituation& fs, bool canKick );

    //    
    _KERNEL CChar* SelectTripTarget( FightSituation& fs );

    //    
    _KERNEL CChar* SelectSwitchTarget( FightSituation& fs );

    //    
    _KERNEL CChar* SelectDisarmTarget( FightSituation& fs );

    //    
    _KERNEL CChar* SelectSilenceTarget( FightSituation& fs );

    //    
    _KERNEL CChar* SelectHoldTarget( SpellID spellID, FightSituation& fs );

    //    
    _KERNEL CChar* SelectPoisonTarget( FightSituation& fs );

    //    
    _KERNEL CChar* SelectCurseTarget( FightSituation& fs );

    //    
    _KERNEL CChar* SelectWeaknessTarget( FightSituation& fs );

    //    
    _KERNEL CChar* SelectBlindTarget( FightSituation& fs );

    _KERNEL CChar* SelectDemenTarget( FightSituation& fs );

    //     
    _KERNEL CChar* SelectDarkWordTarget( FightSituation& fs );

    //    
    _KERNEL CChar* SelectFearTarget( FightSituation& fs );

    //     
    _KERNEL CChar* SelectDrainManaTarget( FightSituation& fs );

    //    
    _KERNEL void SelectThrowTargets( FightSituation& fs, CChar** targets, int num, int attackType );

    //     
    _KERNEL void SelectNeatTargets( FightSituation& fs, CChar** targets, int num );

public: //  

    //  ,   
    _KERNEL CFragSpell* SelectFragSpell( CChar* target );

    //  -,   
    _KERNEL CFragSpell* SelectHarmSpell( CChar* target );

    //   ,   
    _KERNEL CMassFragSpell* SelectMassFragSpell();

public: // AI 

    // AI 
    _KERNEL bool RescueAI( FightSituation& fs );

    // AI 
    _KERNEL bool BashAI( FightSituation& fs );

    // AI   
    _KERNEL bool BashTargetAI( CChar* target );

    // AI      
    _KERNEL bool RetreatAI( FightSituation& fs );

    // AI    
    _KERNEL bool PushAI( FightSituation& fs );

    // AI 
    _KERNEL bool SwitchAI( FightSituation& fs );

    // AI 
    _KERNEL bool DisarmAI( FightSituation& fs );

    // AI   
    _KERNEL bool DisarmTargetAI( CChar* target );

    // AI   
    _KERNEL bool KickTargetAI( CChar* target );

    // AI 
    _KERNEL bool StealAI( FightSituation& fs );

    // AI 
    _KERNEL bool TripAI( FightSituation& fs );

    // AI 
    _KERNEL bool StabAI( FightSituation& fs );

    // AI   
    _KERNEL bool StabTargetAI( CChar* target );

    // AI  
    _KERNEL bool NeatShotAI( FightSituation& fs );

    // AI    
    _KERNEL bool NeatShotTargetAI( CChar* target );

    // AI  
    _KERNEL bool AreaShotAI( FightSituation& fs );

    // AI  
    _KERNEL bool WarCryAI( FightSituation& fs );

    // AI 
    _KERNEL bool LootAI( FightSituation& fs );

    // AI 
    _KERNEL bool ThrowAI( FightSituation& fs );

    //   
    _KERNEL CWeaponSubject* GetThrowWeapon();

    // AI 
    _KERNEL bool ThrowTargetAI( CChar* target );

    // AI 
    _KERNEL bool TurnAI( FightSituation& fs );

    // AI 
    _KERNEL bool RageAI( FightSituation& fs );

    // AI  
    _KERNEL bool ClearingRitualAI( FightSituation& fs );

    //  
    _KERNEL bool LivingRootsAI( FightSituation& fs );

    // AI   
    _KERNEL bool TurnStandAI( FightSituation& fs );

    // AI   
    _KERNEL bool TurnFightAI( FightSituation& fs );

public: // AI 

    // AI 
    _KERNEL bool SilenceAI( FightSituation& fs );

    // AI   
    _KERNEL bool SilenceTargetAI( CChar* target );

    // AI 
    _KERNEL bool HoldAI( SpellID spellID, FightSituation& fs );

    // AI  
    _KERNEL bool HoldAnimalAI( FightSituation& fs ) { return HoldAI( SPELL_HOLD_ANIMAL, fs ); }
    // AI  
    _KERNEL bool HoldAnyAI( FightSituation& fs ) { return HoldAI( SPELL_HOLD_ANY, fs ); }
    // AI  
    _KERNEL bool HoldDragonAI( FightSituation& fs ) { return HoldAI( SPELL_HOLD_DRAGON, fs ); }
    // AI  
    _KERNEL bool HoldGolemAI( FightSituation& fs ) { return HoldAI( SPELL_HOLD_GOLEM, fs ); }
    // AI  
    _KERNEL bool HoldPersonAI( FightSituation& fs ) { return HoldAI( SPELL_HOLD_PERSON, fs ); }
    // AI  
    _KERNEL bool HoldUndeadAI( FightSituation& fs ) { return HoldAI( SPELL_HOLD_UNDEAD, fs ); }

    // AI   
    _KERNEL bool HoldTargetAI( SpellID spellID, CChar* target );

    // AI   
    _KERNEL bool HoldAnimalTargetAI( CChar* target ) { return HoldTargetAI( SPELL_HOLD_ANIMAL, target ); }
    // AI   
    _KERNEL bool HoldAnyTargetAI( CChar* target ) { return HoldTargetAI( SPELL_HOLD_ANY, target ); }
    // AI   
    _KERNEL bool HoldDragonTargetAI( CChar* target ) { return HoldTargetAI( SPELL_HOLD_DRAGON, target ); }
    // AI   
    _KERNEL bool HoldGolemTargetAI( CChar* target ) { return HoldTargetAI( SPELL_HOLD_GOLEM, target ); }
    // AI   
    _KERNEL bool HoldPersonTargetAI( CChar* target ) { return HoldTargetAI( SPELL_HOLD_PERSON, target ); }
    // AI   
    _KERNEL bool HoldUndeadTargetAI( CChar* target ) { return HoldTargetAI( SPELL_HOLD_UNDEAD, target ); }

    // AI  
    _KERNEL bool DrainLifeAI( FightSituation& fs );

    // AI  
    _KERNEL bool DrainManaAI( FightSituation& fs );

    // AI  
    _KERNEL bool DrainEnergyAI( FightSituation& fs );

    // AI  
    _KERNEL bool DrainLevelAI( FightSituation& fs );

    // AI    
    _KERNEL bool DrainLevelTargetAI( CChar* target );

    // AI 
    _KERNEL bool PoisonAI( FightSituation& fs );

    // AI 
    _KERNEL bool CurseAI( FightSituation& fs );

    // AI 
    _KERNEL bool WeaknessAI( FightSituation& fs );

    // AI 
    _KERNEL bool BlindAI( FightSituation& fs );

    // AI   
    _KERNEL bool BlindTargetAI( CChar* target );

    _KERNEL bool DemenAI( FightSituation& fs );

    _KERNEL bool DemenTargetAI( CChar* target );

    // AI  
    _KERNEL bool DarkWordAI( FightSituation& fs );

    // AI    
    _KERNEL bool DarkWordTargetAI( CChar* target );

    // AI 
    _KERNEL bool FearAI( FightSituation& fs );

    // AI 
    _KERNEL bool FragAI( FightSituation& fs );

    // AI   
    _KERNEL bool FragTargetAI( CChar* target );

    // AI -
    _KERNEL bool HarmAI( FightSituation& fs );

    // AI -  
    _KERNEL bool HarmTargetAI( CChar* target );

    // AI  
    _KERNEL bool MassFragAI( FightSituation& fs );

    // AI  
    _KERNEL bool ChainLightingAI( FightSituation& fs );

    // AI   
    _KERNEL bool MassNecroAI( FightSituation& fs );

    // AI  
    _KERNEL bool ColorRayAI( FightSituation& fs );

    // AI 
    _KERNEL bool PolymorphAI( FightSituation& fs );

    // AI   
    _KERNEL bool PolymorphTargetAI( CChar* target );

    // AI 
    _KERNEL bool AppealAI( FightSituation& fs );

    // AI  
    _KERNEL bool AppealStartAI( FightSituation& fs );

    // AI  
    _KERNEL bool StoneCurseAI( FightSituation& fs );

    // AI    
    _KERNEL bool StoneCurseTargetAI( CChar* target );

    // AI  
    _KERNEL bool OblivionAI( FightSituation& fs );

    // AI    
    _KERNEL bool OblivionTargetAI( CChar* target );

public: // AI 

    // AI 
    _KERNEL bool HealAI( FightSituation& fs );

    //      
    _KERNEL bool needHeal( CChar* target );

    //  
    _KERNEL CHealSpell* minHeal();

    //  ,   
    _KERNEL CHealSpell* SelectHealSpell( CChar* target );

    // AI  
    _KERNEL bool MassHealAI( FightSituation& fs );

    //   ,   
    _KERNEL CMassHealSpell* SelectMassHealSpell( int hp, PkFlag actFlag );

    // AI 
    _KERNEL bool BandagingAI( FightSituation& fs );

public: //  

    // AI  
    _KERNEL bool CureBlindnessAI( FightSituation& fs );

    // AI  
    _KERNEL bool CurePoisonAI( FightSituation& fs );

    // AI  
    _KERNEL bool RemoveCurseAI( FightSituation& fs );

    // AI  
    _KERNEL bool ReleaseMentalAI( FightSituation& fs );

    //     
    _KERNEL CChar* SelectCureBlindnessTarget( FightSituation& fs );

    //     
    _KERNEL CChar* SelectCurePoisonTarget( FightSituation& fs );

    //     
    _KERNEL CChar* SelectRemoveCurseTarget( FightSituation& fs );

    //     
    _KERNEL CChar* SelectReleaseMentalTarget( FightSituation& fs );

    // AI  
    _KERNEL bool FreeWillAI( FightSituation& fs );

    // AI  
    _KERNEL bool WordOfLightAI( FightSituation& fs );

    // AI  
    _KERNEL bool WordOfBalanceAI( FightSituation& fs );

    // AI  
    _KERNEL bool DispelFriendAI( FightSituation& fs );

    //     
    _KERNEL CChar* SelectDispelFriendTarget( FightSituation& fs );

    // AI  
    _KERNEL bool DispelEnemyAI( FightSituation& fs );

    //     
    _KERNEL CChar* SelectDispelEnemyTarget( FightSituation& fs );

    // AI  
    _KERNEL bool LifeTouchAI( FightSituation& fs );

    // AI  
    _KERNEL bool SealAI( FightSituation& fs );

    //     
    _KERNEL CChar* SelectSealTarget( FightSituation& fs );

    // AI  
    _KERNEL bool GetPainAI( FightSituation& fs );

public: // 

    //       (   )
    _KERNEL void GiveAwardMoney( uint m, CChar* c );

    //  
    _KERNEL CZoneInstance* zoneInst() { return m_zoneInst; }

    //  
    _KERNEL int instIdx() { return m_zoneInst ? m_zoneInst->m_idx : 0; }

    //   
    _KERNEL void AddVisit( CZone* zone, CZoneInstance* inst );

    //    
    _KERNEL void RemoveTracks();

public: // 

    CBaseMobPrototype* m_prot; //  

    uint m_money;           //   

    int* m_flags;          //  
    CString* m_text;       //  

    CMobPopData* m_popData; //   ,   NULL
    uint m_loadPulse;      //   
    uint m_repopPulse;     //  
    uint m_greetingPulse;  //      

    //  
    bool m_forceLookToRoom;   //   
    uint m_forceLookPulse;    //   
    uint m_thinkPulse;        //     
    CChar* m_aiTarget;        // ,      

    PArray<CCharPlayer*> m_agroMemory; //   

    CCharPlayer* m_mentalOwner;  //     
    CCharPlayer* m_postAgro;     //      
    int m_roundDamage;

    bool m_agro; //    -

    CZoneInstance* m_zoneInst; //  

    PArray<CVisitedInst*> m_visits; //  

    //    
    friend class CDB;

};

//   -  
class CInvisibleEyeMob : public CCharMob
{

protected: //  ,     

    CInvisibleEyeMob( CMobPrototype* prot ) :
        CCharMob( prot ),
        m_owner( NULL )
    {}

public: // 

    static CCharMob* Factory( CMobPrototype* prot, CZoneInstance* zoneInst, CMobPopData* popData ) { return new CInvisibleEyeMob( prot ); }

public: //   

    //   
    _KERNEL void ClearOwner();

    //    
    _KERNEL const char* clr( int itemID );

    //   
    _KERNEL void Send( const char* text );

    //   
    _KERNEL void SendFormat( const char* text, ... );

    //    ( ) (  )
    _KERNEL void SendFormatU( const char* text, ... );

public: // 

    CCharPlayer* m_owner; // 
    uint m_pulse;         // ,   
    int m_num;            // 

};

//       AI 
class FightSituation
{

public: // 

    //     
    _KERNEL void Analize( CCharMob* mob );

public: // 

    CChar* m_allEnemy[0xFF]; // 
    int m_allEnemyCount;
    bool m_hasPlayers;       //    

    CChar* m_enemy[0xFF]; //  ()
    int m_enemyCount;

    CChar* m_friend[0xFF]; //  ()
    int m_friendCount;

};

