/*     

	Copyright (c) 2015. All Rights Reserved.
	: 
*/
#pragma once
#include "DB/Char/MobPrototype.h"

//     
class CMobComplexAbility
{

public: // 

    CMobComplexAbility( int id, int value ) :
        m_id( id ), m_value( value )
    {}

public: // 

    int m_id;    // 
    int m_value; // 

};

//    
class CComplexMobPrototype : public CBaseMobPrototype
{

public: //   

    CComplexMobPrototype();

    CComplexMobPrototype( CMobPrototype* prot, CZoneInstance* zoneInst );

    ~CComplexMobPrototype();

public: // 

    // 
    void Init( CMobPrototype* prot, CZoneInstance* zoneInst );

    // 
    byte level() { return m_level; }

    // 
    byte complex() { return m_zoneInst->m_complex; }

	//  
	CMobPrototype* prot() { return m_prot; }

    // 
    int id() { return m_prot->id(); }

    //  
    double ComplexKoef( int type );

    // 
    int hp();

    // 
    int mana();

    // 
    int mv();

    // 
    byte StatStr();

    // 
    byte StatInt();

    // 
    byte StatWiz();

    // 
    byte StatDex();

    // 
    byte StatCon();

    // 
    int hitroll();

    // 
    int damroll() { return m_damroll; }

    //  
    byte hitNumb() { return m_hitNumb; }

    //  
    byte damDice() { return m_damDice; }

    // 
    int flags() { return m_flags; }

    //   
    int exp();

    //  
    double moneyK() { return ComplexKoef( CKT_MONEY ); }

    // 
    byte poison();

    //  
	byte oldBookPerc();

    //   
	int symbolPerc();

    //   
	int reagPerc();

    // 
    short resist( int type );

    //  
    bool hasSkill( int id );

	//    
	bool realHasAnySkill();

    //  
    int skill( int id );

    //   
    int CheckAddSkill( int id );

    //  
    bool hasSpell( int id );

	//   
	bool realHasAnySpell();

    //  
    int spell( int id );

    //   
    int CheckAddSpell( int id );

	//  
	int specRes( int sr ) { return m_prot->specRes( sr ); }

    //   
    bool hasAffects() { return m_prot->m_affects != 0 || m_affects != 0; }

    //  
	CMobAffectData* getAffect( int i );

    //   
	int getAffectPower( int i );

    //   
    bool hasRandAffects() { return m_prot->m_affectsRand != 0 || m_affectsRand != 0; }

    //  
	CMobAffectRandData* getRandAffect( int i );

    //   
	int getRandAffectPower( int i );

    //   AI
    ushort aiFlags() { return m_aiFlags; }

    //    AI
    void SetAIFlags();

    //    AI
    void RemoveAIFLags( int type, int id );

public: // 

    CMobPrototype* m_prot;      //  
    CZoneInstance* m_zoneInst;  // 

    byte           m_level;     // 

    int            m_damroll;   // 
	byte           m_hitNumb;   //  
	byte           m_damDice;   //  

    int            m_flags;     // 

    PArray<CMobComplexAbility*>* m_skills; // 
    PArray<CMobComplexAbility*>* m_spells; // 

    int                 m_protConstNum; //   
	CMobAffectData*     m_affects;      //  
    int                 m_protRandNum;  //   
	CMobAffectRandData* m_affectsRand;  //  

    ushort         m_aiFlags;   //   AI

};
