/*    

	Copyright (c) 2015. All Rights Reserved.
	: 
*/
#pragma once
#include "Tools/Formula.h"

//   
class CCustomMsg
{

public: // 

    _KERNEL CCustomMsg( int type, const char* text );

public: // 

    //  
    _KERNEL int getType();

    //  
    _KERNEL CString* getMsg();

private: // 

	int     m_type; // 
	CString m_msg;  // 

};

//    
class CCustomMsgSet
{

public:  // 

    //  
    _KERNEL CString* GetMessage( int type );

public: // 
//private: // 

	PArray<CCustomMsg*> m_msgs; // 

};



//    
class CCustomAbilityImpactSubdata
{

public: // 

};

//   
class CCustomAbilityImpact
{

public:  // 

    //  
    _KERNEL bool Perform( CCharMob* mob, CChar* target );

    // 
    _KERNEL void Apply( CCharMob* mob, CChar* target );

public: // 
//private: // 

    CImpactData   m_impact; // 
	CFormulaParam m_chance; // 
	CCustomMsgSet m_msgs;   // 

};



//   
class CCustomAbilityImpactChainNode
{

public:  // 

    _KERNEL CCustomAbilityImpactChainNode( int type = ICT_NONE, CImpactSubdata* subData = 0, const char* chanceVal = 0 );

public:  // 

    //  
    _KERNEL void Perform( CCharMob* mob, CChar* target );

public: // 
//private: // 

	CCustomAbilityImpact                   m_impact; // 
	PArray<CCustomAbilityImpactChainNode*> m_nodes;  //  

};



//  
class CCustomAbilityImpactSet
{

public:  // 

    //  
    _KERNEL void Perform( CCharMob* mob, CChar* target );

public: // 
//private: // 

    PArray<CCustomAbilityImpactChainNode*> m_impacts; // 

};



//    
class CCustomAbilityCooldown
{

public:  // 

    _KERNEL CCustomAbilityCooldown( CCharMob* mob = 0, uint pulse = 0 );

public:  // 

    //   
    _KERNEL int data();

    //  
    _KERNEL uint getPulse();

    //  
    _KERNEL void setPulse( uint pulse );

private: // 

	CCharMob* m_mob;   // 
	uint      m_pulse; // 

};



//   
class CCustomAbilityCondition
{

public: // 

    _KERNEL CCustomAbilityCondition();

public: // 

	//  
	_KERNEL bool CheckConditions( CCustomAbility* ability, CCharMob* mob, FightSituation& fs );

    //  
    _KERNEL bool CheckCooldown( CCharMob* mob );

    //  
    _KERNEL void SetUsage( CCharMob* mob );

public: // 
//private: // 

    int m_cooldown; // 
	PArray<CCustomAbilityCooldown*> m_pulses; //  

    Array<int> m_affects;    //  

	CFormulaBranch m_chance; // 
    Array<int> m_numChance;  //    

    bool m_reqFight;     //   
    bool m_checkNoMagic; //   !
	int m_lifePerc;      //   
	int m_maxMobs;       //     

    bool (*m_checkFunc)( CCustomAbility*, CCharMob*, FightSituation& ); //  

};



//  
class CCustomAbility
{

public: // 

    _KERNEL CCustomAbility();

public: // 

	//  
	_KERNEL bool CheckConditions( CCharMob* mob, FightSituation& fs );

    //  
    _KERNEL void Perform( CCharMob* mob );

public: // 
//private: // 

    int                     m_aiPerc;    //  
    int                     m_lag;       //  
	CCustomAbilityCondition m_condition; // 
    CCustomMsgSet           m_msgs;      // 
    CFormulaParam           m_chance;    //   
    CCustomAbilityImpactSet m_impacts;   // 

};
