/*    

	Copyright (c) 2011. All Rights Reserved.
	: 
*/
#pragma once
#include "Tools/Formula.h"

//  
class CFormulaParam
{

public: // 

    _KERNEL CFormulaParam( int source = IS_PURE );

public: // 

    // 
    _KERNEL double value( CChar* c1, CChar* c2 );

    //  
    _KERNEL CFormulaBranch* formula();

    //  
    _KERNEL void SetFormula( const char* txtVal, const char* txtCheck = 0 );

    //  
    _KERNEL void setSource( int source );

public:  // 
//private: // 

	int            m_source;  // 
	CFormulaBranch m_formula; // 

};

//   
class CActionMessage
{

public: // 

	CActionMessage() :
		m_type( CAMT_TARGET_SUCCESS )
	{}

public: // 

	//   
	_KERNEL void Serialize( CFileStore& fs );

public: // 

	byte m_type;   //  
	CString m_msg; // 

};

//   
class CImpactSubdata
{

public: // 

	//   
	_KERNEL virtual void Serialize( CFileStore& fs ) = 0;

    //   
    _KERNEL virtual void SetSource( int source ) {}

	//  
	_KERNEL virtual bool Perform( CChar* c1, CChar* c2 ) = 0;

};

//   
class CImpactDamageSubdata : public CImpactSubdata
{

public: // 

    _KERNEL CImpactDamageSubdata( const char* dmgVal = 0, int dmgSrc = IS_PURE, const char* drainVal = 0,
                                  int drainSrc = IS_PURE, const char* dmgCheck = 0, const char* drainCheck = 0 );

public: // 

	// 
	_KERNEL void Init();

	//   
	_KERNEL void Serialize( CFileStore& fs );

    //   
    _KERNEL void SetSource( int source );

	//  
	_KERNEL virtual bool Perform( CChar* c1, CChar* c2 ) = 0;

public: // 

    CFormulaParam m_damage; // 
    CFormulaParam m_drainK; //  

};

//   : 
class CImpactDamageHPSubdata : public CImpactDamageSubdata
{

public: // 

    _KERNEL CImpactDamageHPSubdata( const char* dmgVal = 0, int dmgSrc = IS_PURE, bool nearFight = false, const char* drainVal = 0,
                                    int drainSrc = IS_PURE, const char* dmgCheck = 0, const char* drainCheck = 0 );

public: // 

	//  
	_KERNEL bool Perform( CChar* c1, CChar* c2 );
	//_KERNEL bool Perform( CChar* c1, CChar* c2, ImpactSource source );

public: // 

    bool m_nearFight; //  

};

//   : 
class CImpactDamageManaSubdata : public CImpactDamageSubdata
{

public: // 

	_KERNEL CImpactDamageManaSubdata();

public: // 

	//  
	_KERNEL bool Perform( CChar* c1, CChar* c2 );
	//_KERNEL bool Perform( CChar* c1, CChar* c2, ImpactSource source );

};

//   : 
class CImpactDamageMVSubdata : public CImpactDamageSubdata
{

public: // 

	_KERNEL CImpactDamageMVSubdata();

public: // 

	//  
	_KERNEL bool Perform( CChar* c1, CChar* c2 );
	//_KERNEL bool Perform( CChar* c1, CChar* c2, ImpactSource source );

};

//   : 
class CImpactDamageMoneySubdata : public CImpactDamageSubdata
{

public: // 

	_KERNEL CImpactDamageMoneySubdata();

public: // 

	//  
	_KERNEL bool Perform( CChar* c1, CChar* c2 );
	//_KERNEL bool Perform( CChar* c1, CChar* c2, ImpactSource source );

};

//   : 
class CImpactDamageExpSubdata : public CImpactDamageSubdata
{

public: // 

	_KERNEL CImpactDamageExpSubdata();

public: // 

	//  
	_KERNEL bool Perform( CChar* c1, CChar* c2 );
	//_KERNEL bool Perform( CChar* c1, CChar* c2, ImpactSource source );

};

//   : 
class CImpactDamageFoodSubdata : public CImpactDamageSubdata
{

public: // 

	_KERNEL CImpactDamageFoodSubdata();

public: // 

	//  
	_KERNEL bool Perform( CChar* c1, CChar* c2 );
	//_KERNEL bool Perform( CChar* c1, CChar* c2, ImpactSource source );

};

//   : 
class CImpactDamageWaterSubdata : public CImpactDamageSubdata
{

public: // 

	_KERNEL CImpactDamageWaterSubdata();

public: // 

	//  
	_KERNEL bool Perform( CChar* c1, CChar* c2 );
	//_KERNEL bool Perform( CChar* c1, CChar* c2, ImpactSource source );

};

//     
class CImpactHoldLagSubdata : public CImpactSubdata
{

public: // 

	// 
	_KERNEL void Init();

	//   
	_KERNEL void Serialize( CFileStore& fs );

	//  
	_KERNEL virtual bool Perform( CChar* c1, CChar* c2 ) = 0;

public: // 

    CFormulaParam m_time; // 
	//CFormulaBranch* m_time; // 

};

//   
class CImpactHoldSubdata : public CImpactHoldLagSubdata
{

public: // 

    _KERNEL CImpactHoldSubdata( const char* timeVal = 0, const char* timeCheck = 0 );

public: // 

	//  
	_KERNEL bool Perform( CChar* c1, CChar* c2 );
	//_KERNEL bool Perform( CChar* c1, CChar* c2, ImpactSource source );

};

//   
class CImpactLagSubdata : public CImpactHoldLagSubdata
{

public: // 

	_KERNEL CImpactLagSubdata( const char* timeVal = 0, const char* timeCheck = 0 );

public: // 

	//  
	_KERNEL bool Perform( CChar* c1, CChar* c2 );
	//_KERNEL bool Perform( CChar* c1, CChar* c2, ImpactSource source );

};

//   
class CImpactAffectSubdata : public CImpactSubdata
{

public: // 

	_KERNEL CImpactAffectSubdata( byte affect = AFF_FLY, const char* gradeVal = 0, const char* timeVal = 0,
                                  const char* gradeCheck = 0, const char* timeCheck = 0 );

public: // 

	//   
	_KERNEL void Serialize( CFileStore& fs );

	//  
	_KERNEL bool Perform( CChar* c1, CChar* c2 );
	//_KERNEL bool Perform( CChar* c1, CChar* c2, ImpactSource source );

public: // 

	byte m_affect;         // 
	CFormulaParam m_grade; // 
    CFormulaParam m_time;  // 

};

//    
class CImpactDrainLevelSubdata : public CImpactSubdata
{

public: // 

	_KERNEL CImpactDrainLevelSubdata();

public: // 

	//   
	_KERNEL void Serialize( CFileStore& fs );

	//  
	_KERNEL bool Perform( CChar* c1, CChar* c2 );
	//_KERNEL bool Perform( CChar* c1, CChar* c2, ImpactSource source );

public: // 

	CFormulaParam m_level; // 
	CFormulaParam m_time;  // 

};

//    
class CImpactDispelSubdata : public CImpactSubdata
{

public: // 

	_KERNEL CImpactDispelSubdata();

public: // 

	//   
	_KERNEL void Serialize( CFileStore& fs );

    //   
    _KERNEL void SetSource( int source );

	//  
	_KERNEL bool Perform( CChar* c1, CChar* c2 );
	//_KERNEL bool Perform( CChar* c1, CChar* c2, ImpactSource source );

public: // 

	PArray<byte> m_affects; //   
	bool m_allNegate;       //   
	CFormulaParam m_perc;   //   

};

//    
class CImpactPosSubdata : public CImpactSubdata
{

public: // 

	_KERNEL CImpactPosSubdata( byte pos = POS_SITTING );

public: // 

	//   
	_KERNEL void Serialize( CFileStore& fs );

	//  
	_KERNEL bool Perform( CChar* c1, CChar* c2 );
	//_KERNEL bool Perform( CChar* c1, CChar* c2, ImpactSource source );

public: // 

	byte m_pos; // 

};

//    
class CImpactEquipDamageSubdata : public CImpactSubdata
{

public: // 

	_KERNEL CImpactEquipDamageSubdata();

public: // 

	//   
	_KERNEL void Serialize( CFileStore& fs );

    //   
    _KERNEL void SetSource( int source );

    //  
	_KERNEL bool Perform( CChar* c1, CChar* c2 );
	//_KERNEL bool Perform( CChar* c1, CChar* c2, ImpactSource source );

public: // 

	PArray<byte> m_slots;   //   
	bool m_allSlots;        //  
	CFormulaParam m_perc;   //   
	CFormulaParam m_damage; //  

};

//     
class CImpactPushSubdata : public CImpactSubdata
{

public: // 

	//   
	_KERNEL void Serialize( CFileStore& fs );

	//  
	_KERNEL bool Perform( CChar* c1, CChar* c2 );
	//_KERNEL bool Perform( CChar* c1, CChar* c2, ImpactSource source );

public: // 

	bool m_onlyNear;        //   

};

//   
class CImpactEmptySubdata : public CImpactSubdata
{

public: // 

	//   
	_KERNEL void Serialize( CFileStore& fs );

	//  
	_KERNEL bool Perform( CChar* c1, CChar* c2 );
	//_KERNEL bool Perform( CChar* c1, CChar* c2, ImpactSource source );

};

//   
class CImpactCustomSubdata : public CImpactSubdata
{

public: // 

	//   
	_KERNEL void Serialize( CFileStore& fs );

	//  
	_KERNEL bool Perform( CChar* c1, CChar* c2 );
	//_KERNEL bool Perform( CChar* c1, CChar* c2, ImpactSource source );

public: // 

    bool (*m_actFunc)( CChar*, CChar* ); //  

};

//  
class CImpactFearSubdata : public CImpactSubdata
{

public: // 

	//   
	_KERNEL void Serialize( CFileStore& fs );

	//  
	_KERNEL bool Perform( CChar* c1, CChar* c2 );
	//_KERNEL bool Perform( CChar* c1, CChar* c2, ImpactSource source );

};

//  
class CImpactData
{

public: // 

    _KERNEL CImpactData();

public: // 

    // 
    _KERNEL void Init( int type, CImpactSubdata* subData );

	//   
	_KERNEL void Serialize( CFileStore& fs );

	//  
	_KERNEL bool PerformImpact( CChar* c1, CChar* c2 );

	//      
	_KERNEL static double TypeModifier( double value, int source, CChar* hiter, CChar* target );

public: // 

	byte m_type;               //  
	byte m_source;             //  
	CImpactSubdata* m_subData; // 

};

//   
class CImpactPerc
{

public: // 

	_KERNEL CImpactPerc();

public: // 

	//   
	_KERNEL void Serialize( CFileStore& fs );

public: // 

	CFormulaBranch* m_chance; //  
	CImpactData* m_action;    //  

};

//   
class CActionSubdata
{

public: // 

	//   
	_KERNEL virtual void Serialize( CFileStore& fs ) = 0;

};

//   
class CHitSubdata : public CActionSubdata
{

public: // 

	_KERNEL CHitSubdata();

public: // 

	//   
	_KERNEL void Serialize( CFileStore& fs );

	//  
	_KERNEL bool PerformHit( CChar* c1, CChar* c2 );

	//  
	_KERNEL bool PerformImpact( CChar* c1, CChar* c2 );

public: // 

	CFormulaBranch* m_useChance;        //  
	int m_hitNumber;                    //  
	int m_max;                          //    
	bool m_instead;                     //    

	bool m_check[HC_COUNT];             //  
	CFormulaBranch* m_hitChance;        //  

	CActionMessage* m_msgs[CAMT_COUNT]; // 

	PArray<CImpactPerc*> m_actions;     //  

	int m_count;                        //   

};

//   
class CSkillSubdata : public CActionSubdata
{

public: // 

	//   
	_KERNEL void Serialize( CFileStore& fs ) {};

};

//   
class CSpellSubdata : public CActionSubdata
{

public: // 

	//   
	_KERNEL void Serialize( CFileStore& fs ) {};

};

//  
class CActionData
{

public: // 

	//   
	_KERNEL void Serialize( CFileStore& fs );

public: // 

	int m_id;                  // 
	CString m_name;            // 
	byte m_type;               // 
	CActionSubdata* m_subData; //  

};

//   
class CActionBase
{

public: // 

	//   
	_KERNEL void AddAction( CActionData* actData );

	//   
	_KERNEL CActionData* FindAction( int id );

public: // 

	//   
	PArray<CActionData*> m_actions;

};
