/*   

	Copyright (c) 2015. All Rights Reserved.
	: 
*/
#pragma once

//     
class CGloryBonusInfo
{

public: // 

	// 
	CGloryBonusInfo( int cost, int req, int max, int num, int summ ) :
		m_cost( cost ), m_req( req ), m_max( max ), m_num( num ), m_summ( summ )
	{}

public: // 

	//  
	_KERNEL CGloryBonusInfo* Copy();

	//  
	_KERNEL int CheckReqs( int val, int bonusType, int req, bool msg = false );

public: // 

	int m_cost; // 
	int m_req;  // 
	int m_max;  // 
	int m_num;  // 
	int m_summ; //  

};

//     
class CGloryAffectInfo
{

public: // 

    CGloryAffectInfo( ushort affId, byte grade, uint glory, byte reqGrade = 0 ) :
        m_affId( affId ), m_grade( grade ), m_glory( glory ), m_reqGrade( reqGrade )
    {}

public: // 

    ushort m_affId;  // 
    byte m_grade;    // 
    uint m_glory;    //  
    byte m_reqGrade; //  

};

//    
class CGloryLevelInfo
{

public: //   

	CGloryLevelInfo() :
		m_upCost( 0 ), m_up( NULL )
	{}

	// 
	~CGloryLevelInfo();

public: // 

	//  
	_KERNEL bool CheckReqs( CCharPlayer* cp );

	//  
	_KERNEL CGloryLevelInfo* CheckAvailable( CCharPlayer* cp );

	//  
	_KERNEL PArray<CGloryBonusInfo*>* GetBonus( int type );

public: // 

	PArray<CGloryBonusInfo*> m_abilities; //   

	PArray<CGloryBonusInfo*> m_resists;   //   
    PArray<CGloryBonusInfo*> m_resistMax; //   

	PArray<CGloryBonusInfo*> m_armor;     //   
	PArray<CGloryBonusInfo*> m_armorMax;  //   

	PArray<CGloryBonusInfo*> m_ac;        //   
	PArray<CGloryBonusInfo*> m_acMax;     //   

    PArray<CGloryAffectInfo*> m_affects;  //  

	int m_upCost;                         //   
	CGloryLevelInfo* m_up;                //   

};

//  
class CGloryBase
{

public: // 

	// 
	_KERNEL void Init();

	//  
	_KERNEL void InitAffects();

    //    
    _KERNEL static int PriceStore( byte storeRank );

    //    
    _KERNEL static int PriceClanStore( byte storeRank );

public: // 

	CGloryLevelInfo* m_levels[GL_COUNT]; //  

};