/*   

	Copyright (c) 2001 - 2004. All Rights Reserved.
	:  ..
*/
#pragma once
#include "DB/Account.h"
#include "DB/Char/Profession.h"
#include "DB/Char/ProfAI.h"
#include "DB/Char/Race.h"
#include "DB/Subject/Material.h"
#include "DB/Subject/Water.h"
#include "DB/Char/Skill.h"
#include "DB/Char/Spell.h"
#include "DB/Char/Affect.h"
#include "DB/Char/Column.h"
#include "DB/Color.h"
#include "DB/Flawer.h"
#include "DB/Subject/ObjFlag.h"
#include "DB/Subject/ObjType.h"
#include "DB/Subject/ObjSubType.h"
#include "DB/Char/WeaponSkill.h"
#include "DB/Subject/DamageStr.h"
#include "DB/Subject/DamageType.h"
#include "DB/Subject/IngrColor.h"
#include "DB/Subject/Slot.h"
#include "DB/ModeVar.h"
#include "DB/Tote.h"
#include "DB/Loto.h"
#include "DB/Char/GradeBase.h"
#include "DB/Subject/RuneBase.h"
#include "DB/QuestBase.h"
#include "DB/Char/CustomAction.h"
#include "DB/DailyTask.h"
#include "DB/Subject/PriceBase.h"
#include "DB/TournamentZone.h"
#include "DB/Interview.h"
#include "DB/Zone.h"
#include "DB/Char/GloryBase.h"
#include "DB/ComplexBase.h"
#include "DB/WeakenBase.h"
#include "DB/Char/GroupSearch.h"
#include "DB/Char/BotData.h"
#include "StatBase.h"
#include "DB/World/SpeedWalk.h"
#include "Triggers/CustomTriggers.h"

#define gnew( c ) (c*)g_db.New( sizeof(c) )

//     
class CDoorLinkBaseData
{

public: // 

	CDoorLinkBaseData() {}

	CDoorLinkBaseData( CRoomBaseData* room, RoomExit exit ) :
		m_room( room ),   // 
		m_exit( exit )    // 
	{}

public: // 

	CRoomBaseData* m_room; // 
	byte m_exit;           // 

};

//     
class CDoorLinkData
{

public: // 

	CDoorLinkData() {}

	CDoorLinkData( CRoom* room, RoomExit exit ) :
		m_room( room ),   // 
		m_exit( exit )    // 
	{}

public: // 

	CRoom* m_room; // 
	byte m_exit;   // 

};

//    
class CAffectUnit
{

public: // 

	_KERNEL CAffectUnit() {}

	_KERNEL CAffectUnit( byte affID, int value = 1, bool doubl = true ) :
        m_affId( affID ), m_value( value ), m_double( doubl )
    {}

public: // 

    //  
    _KERNEL CAffect* affect();

public: // 

	byte m_affId;  //  
	int m_value;   //  
	bool m_double; //  -
    int m_id;      // 

};

//  
class CAffectData
{

public: // 

	_KERNEL CAffectData() {}

	// ,   
	_KERNEL CAffectData( byte affID, uint life, PkFlag pkFlag = APF_NOPK, int value = 80, bool doubl = false ) : m_life( life )
	{
		m_affect.m_affId = affID;
		m_affect.m_value = value;
		m_affect.m_double = doubl;
		m_pkFlag = pkFlag;
	}

    _KERNEL ~CAffectData();

public:

    // 
    _KERNEL void Init( byte id, uint pulses, PkFlag pkFlag, int value, bool doubl );

	//   
	_KERNEL void Serialize( CFileStore& fs );

	//  
	_KERNEL bool CheckTimer();

	//   
	_KERNEL CAffect* affect();

	// ID 
	byte id() { return m_affect.m_affId; }

	// 
	int value() { return m_affect.m_value; }

public: // 

	//  
	CAffectUnit m_affect;
	// ,   
	uint m_life;
	// -
	byte m_pkFlag;
    //  
    int m_id;

};

//    AI
class CAIFlagData
{

public: // 

    int m_type; // 
    int m_id;   // 
    int m_flag; // 

};


//     
class CQuestionBotCheckData
{

public:

    // 
    CQuestionBotCheckData( int type = MBCT_TEXT, const char* question = NULL, const char* answer = NULL, int lines = 0, int waitTime = 0 )
    {
        Init( type, question, answer, lines, waitTime );
    }

    // 
    void Init( int type = MBCT_TEXT, const char* question = NULL, const char* answer = NULL, int lines = 0, int waitTime = 0 )
    {
        m_type = type;
        m_question = question;
        m_answer = answer;
        m_lines = lines;
        m_waitTime = waitTime;
    }

    // 
    void operator=( const CQuestionBotCheckData& other )
    {
        Init( other.m_type, other.m_question, other.m_answer, other.m_lines, other.m_waitTime );
    }

public:

    int m_type;         //  
    CString m_question; // 
    CString m_answer;   // 
    int m_lines;        //  
    int m_waitTime;     //  

};


//  
class CDB : public CDBObject
{

public: //   

	_KERNEL CDB();

public: //   

	//   
	_KERNEL void InitNew();

	// 
	_KERNEL void Load();

	//  
	_KERNEL void Link();

	//  
	_KERNEL void LoadZones();

	//  
	_KERNEL void LoadZone( const char* fileName );

	//  
	//_KERNEL void CreateDoors();

	//   
	_KERNEL void RentAllPlayers();

	//   
	_KERNEL void DeleteNotActiveCharPlayers();

	//   
	_KERNEL void DeleteNotActiveAccounts();

	//   
	_KERNEL void MailCheckTimers();

	//   
	_KERNEL void Prepare();

	// 
	_KERNEL void Save( int backupNum );

	//  
	_KERNEL void PerformPulse();

	//  
	_KERNEL void PerformDayPulse();

	//    
	_KERNEL void UpdateBotChecking( bool nightTime );

	//    
	_KERNEL void UpdateHour( SYSTEMTIME* time );

    //   
    _KERNEL void ChangeDayNight( bool day = true );

    //   
    _KERNEL void UpdateSysTime();

	//     
	_KERNEL void PerformNoBotCheck();

    //     
    _KERNEL double NobotBonus( int type, bool perc = false, bool money = false );

	//  
	_KERNEL void Repop( bool init = false );

	//  
	_KERNEL void LoadNews();

	//  
	_KERNEL void LoadLegend();

	//  
	_KERNEL void LoadHelp();

	//   
	_KERNEL void LoadHelpFolder( CFileStore& fs );

	//    
	_KERNEL void CreateTopicKeys();

	//  
	_KERNEL void LoadClasses();

	//  
	_KERNEL void LoadAnnounces();

public: //   

	//  
	_KERNEL bool AddAccount( CAccount* acc );

	//  
	_KERNEL void DeleteAccount( CAccount* acc, CCharPlayer* who );

	//  
	_KERNEL void RestoreAccount( const char* fileName, CCharPlayer* who );

	//    
	_KERNEL CAccount* FindAccount( int id );

	//    
	_KERNEL CAccount* FindAccount( const char* name );

	//    
	_KERNEL CAccount* FindAccount( CMaskManager& mm );

public: //   -

	//  
	_KERNEL bool AddCharPlayer( CCharPlayer* ch );

	//  
	_KERNEL void DeleteCharPlayer( CCharPlayer* ch, CCharPlayer* who );

	//  
	_KERNEL void RestoreCharPlayer( const char* name, const char* account, CCharPlayer* who );

	//    
	_KERNEL CCharPlayer* FindCharPlayer( CCharPlayer* cp );

	//    
	_KERNEL CCharPlayer* FindCharPlayer( int id );

	//    
	_KERNEL CCharPlayer* FindCharPlayer( const char* name );

	//    
	_KERNEL CCharPlayer* FindCharPlayer( CMaskManager& mm );

	//   
	_KERNEL bool CheckChar( CChar* c );

	//     
	_KERNEL int CalcLevelD( double exp );

    //    
    _KERNEL uint64 InventSumm( int inventNum );

	//     
	_KERNEL void ClearFromMobMemory( CCharPlayer* cp );

	//      
	_KERNEL void ClearCharReference( CCharPlayer* cp );

	//      
	_KERNEL void ClearInstReference( CZoneInstance* inst );

    //    
    _KERNEL void ClearMobReference( CCharMob* mob );

	//   
	_KERNEL bool CharNameFilter( const char* name, CConnection* conn );

public: //   

	//  
	_KERNEL void AddClan( CClan* clan );

	//  
	_KERNEL void DeleteClan( CClan* clan );

	//    
	_KERNEL CClan* FindClan( int id );

	//    
	_KERNEL CClan* FindClan( const char* name );

	//    
	_KERNEL CClan* FindClan( CMaskManager& mm );

public: //   

	//  
	_KERNEL void AddFraction( CFraction* fraction );

	//  
	_KERNEL void DeleteFraction( CFraction* fraction );

	//    
	_KERNEL CFraction* FindFraction( int id );

	//    
	_KERNEL CFraction* FindFraction( const char* name );

	//    
	_KERNEL CFraction* FindFraction( CMaskManager& mm );

public: //   

	//  
	_KERNEL void AddShop( CShop* shop );

	//  
	_KERNEL void DeleteShop( CShop* shop );

	//    
	_KERNEL CShop* FindShop( int id );

	//    
	_KERNEL CShop* FindShop( const char* name );

	//    
	_KERNEL CShop* FindShop( CMaskManager& mm );

public: //   

	//      
	_KERNEL void AddDeniedName( const char* name );

	//      
	_KERNEL void RemoveDeniedName( const char* name );

	//        
	_KERNEL bool IsDeniedName( const char* name );

public: //     IP

	//  
	_KERNEL void AddBan( CBan* b );

	//  
	_KERNEL void DeleteBan( CBan* b );

	//    IP
	_KERNEL CBan* FindBan( IpAddr ip );

	//    IP   
	_KERNEL CBan* FindBan( const char* ipText );

public: //   

	//    
	_KERNEL CWorld* FindWorld( const char* name );

public: //   

	//    
	_KERNEL CZone* FindZone( int id );

	//     
	_KERNEL CZoneInstance* FindZoneInst( int id, int instIdx = 0 );

public: //   

	//    
	_KERNEL CRoom* FindRoom( int id, int instIdx = 0 );

	//     
	_KERNEL CRoomBaseData* FindBaseRoom( int id );

public: //   

	//    
	_KERNEL CProfession* FindProfession( const char* name );

	//    
	_KERNEL CProfession* FindProfession( CMaskManager& mm );

	//    
	_KERNEL CProfAI* FindProfAI( int id );

public: //   

	//    
	_KERNEL CRace* FindRace( const char* name );

	//    
	_KERNEL CRace* FindRace( CMaskManager& mm );

public: //   

	//    
	_KERNEL CMaterial* FindMaterial( const char* name );

public: //   

	//    
	_KERNEL CWater* FindWater( const char* name );

public: //   

	//    
	_KERNEL CSkill* FindSkill( const char* name );

	//    
	_KERNEL CSkill* FindSkill( CMaskManager& mm );

public: //   

	//    
	_KERNEL CSpell* FindSpell( const char* name );

	//    
	_KERNEL CSpell* FindSpell( CMaskManager& mm );

public: //   

	//    
	_KERNEL CAffect* FindAffect( const char* name );

	//    
	_KERNEL CAffect* FindAffect( CMaskManager& mm );

public: //   

	//    
	_KERNEL CColumn* FindColumn( const char* name );

	//    
	_KERNEL CColumn* FindColumn( CMaskManager& mm );

public: //    

	//     
	_KERNEL CObjSubType* FindObjSubType( const char* name );

public: //    

	//     
	_KERNEL CWeaponSkill* FindWeaponSkill( const char* name );

	//     
	_KERNEL CWeaponSkill* FindWeaponSkill( CMaskManager& mm );

	//    
	_KERNEL void FindAbilityInfo( CMaskManager& mm, CAbilityInfo* info );

public: //    

	//     
	_KERNEL CDamageStr* FindDamageStr( const char* name );

public: //    

	//     
	_KERNEL CDamageType* FindDamageType( const char* name );

public: //    

	//     
	_KERNEL CWalkMethod* FindWalkMethod( const char* name );

public: //   

	//    
	_KERNEL CIngrColor* FindColor( const char* name );

public: //   

	//    
	_KERNEL CModifier* FindModifier( const char* name );

	//    
	_KERNEL void FindAffMod( char* args, CAffect** aff, CModifier** mod );

    //   
    _KERNEL uint FindModeVar( uint id, bool account = false );

public: //   

	//     
	_KERNEL CMobPrototype* FindMobPrototype( int id );

	//     
	_KERNEL CMobPrototype* FindMobPrototype( CMaskManager& mm );

	//     
	_KERNEL CObjPrototype* FindObjPrototype( int id );

	//     
	_KERNEL CObjPrototype* FindObjPrototype( CMaskManager& mm, bool full = false );

	//  ,      
	_KERNEL int UsedObjPrototypeCount();

	//     
	_KERNEL CSubject* FindObject( int id );

	//    
	_KERNEL void LoadObjPrototypeCheck( CFileStore& fs, int* protID );

public: //   

	//      (   )
	//       ,    ,    
	_KERNEL CCharMob* CreateMob( CMobPrototype* prot, CZoneInstance* zoneInst, CMobPopData* popData = NULL );

	//       (   )
	_KERNEL CCharMob* CreateMob( int id, CZoneInstance* zoneInst, CMobPopData* popData = NULL );

	//     
	_KERNEL CCharMob* FindMob( int id, int instIdx = 0 );

	//  ,    
	_KERNEL int UsedMobPrototypeCount();

	//   
	_KERNEL char* CreateMobRecords( bool forSelect = false );

	//    
	_KERNEL int CalcCharmLevel( int level, int power );

    //  -  
    _KERNEL int CalcCharmLevelPk( int level, int powerPk, bool ingrCall );

	//    
	_KERNEL int CalcCharmControl( int mobLevel, CCharPlayer* cp, const CSpell* spell );

public: //   

	//      (   )
	//       
	_KERNEL CSubject* CreateObj( CObjPrototype* prot, CZoneInstance* zoneInst = NULL, CObjPopInRoomData* popData = NULL );

	//       (   )
	//       
	_KERNEL CSubject* CreateObj( int id, CZoneInstance* zoneInst = NULL, CObjPopInRoomData* popData = NULL );

	//  
	_KERNEL void destroyObj( CSubject* obj );

    //     ( 0.1%)
    _KERNEL static int PercApplyMaxFactor( int percent, int maxFactor, double count, int numKoef = 1 );

	//     
	_KERNEL static bool ThrowDiceOnLoadObj( CObjPrototype* prot, int percent, CZoneInstance* zoneInst = NULL );

	//     
	_KERNEL static bool ThrowDiceOnLoadObj( int id, int percent, CZoneInstance* zoneInst = NULL );

	//        
	_KERNEL static bool ThrowDiceOnLoadObj( PArray<CObjPrototype*>* prots, int percent, CZoneInstance* zoneInst = NULL );

    //     
    _KERNEL static bool ThrowDiceOnLoadOldBook( int percent );

    //   
    _KERNEL static bool ThrowDiceOnLoadOldBook( int percent, COldBookItem*& pBookInfo, CProfession*& pProf );

    //  
    _KERNEL static void GenerateOldBook( COldBookItem*& pBookInfo, CProfession*& pProf );

    //     
    _KERNEL static bool ThrowDiceOnLoadReagent( int percent, int size, CObjPrototype* prot );

	//      
	_KERNEL void FillKeyLinksArray( Array<CDoorLinkData>& doorLinks, Array<CObjPopInRoomData*>& objLinks, CObjPrototype* keyProt );

	//      
	_KERNEL void FillKeyLinksBaseArray( Array<CDoorLinkBaseData>& doorLinks, Array<CObjPopInRoomBaseData*>& objLinks, CObjPrototype* keyProt );

public: //   

	//  
	_KERNEL void AddOffer( COffer* offer );

	//  
	_KERNEL void ExchangeMessage( COffer* offer, int msgType, CCharPlayer* c1, CCharPlayer* c2 );

public: //   

	//  
	_KERNEL void AddAuctionOffer( CAuctionOffer* offer );

	//  
	_KERNEL void AuctionMessage( CAuctionOffer* offer, int msgType, CCharPlayer* c1, CCharPlayer* c2 );

public: //   

	//    
	_KERNEL double CalcDonateBonus( int summ, int type );

public: // 

	//  
	_KERNEL void AllMessage( bool bToJrn, const char* text, ... );

	//  
	_KERNEL void ImmortalMessage( const char* text, ... );

public: //  

	//   
	_KERNEL void ResetCharTrains();

    //   
    _KERNEL void ResetCharDailyTasks();

    //       
    _KERNEL void WorldGetRoomBand( CRoom* pRoom, int distance, int bandFlags, PArray<CRoom*>& bandArray );

    //  : 
    _KERNEL CWorld* GlobalGetWorld( int& w, BOOL bNext = TRUE );

    //  : 
    _KERNEL CZone* GlobalGetZone( int& w, int& z, BOOL bNext = TRUE );

    //  :  
    _KERNEL CRoomBaseData* GlobalGetBaseRoom( int& w, int& z, int& r, BOOL bNext = TRUE );

    //  : 
    _KERNEL CRoom* GlobalGetRoom( int& w, int& z, int& r, int& i, BOOL bNext = TRUE );

    //  :   
    _KERNEL CChar* GlobalGetRoomChars( int& w, int& z, int& r, int& i, CChar*& c, BOOL bNext = TRUE );

    //  :  
    _KERNEL CObjPrototype* GlobalGetObjPrototype( int& w, int& z, int& o, BOOL bNext = TRUE );

    //  : 
    _KERNEL CTimerObj* GlobalGetSubject( int& w, int& z, int& o, int& i, BOOL bNext = TRUE );

    //  :  
    _KERNEL CMobPrototype* GlobalGetMobPrototype( int& w, int& z, int& m, BOOL bNext = TRUE );

    //  :  
    _KERNEL CMobPrototype* GlobalGetStaticShop( int& w, int& z, int& m, BOOL bNext = TRUE );

    //  :   
    _KERNEL CObjSellData* GlobalGetStaticShopGood( int& w, int& z, int& m, int& g, BOOL bNext = TRUE );

    //  
    _KERNEL CMobPopBaseData* GlobalGetMobPopBaseData( int& w, int& z, int& r, int& m, BOOL bNext = TRUE );

    //     
    _KERNEL void TaskCollectInfoMobLevels( Array<uint>& mobInfo, bool peaceful = false );

public: // CDBObject

	//   
	bool GetField( char* field, char* param, CCharPlayer* cp );

	//   
	bool SetField( char* field, char* param, const char* text );

	//_KERNEL bool CheckJournal( CJournal* journal );

	void PerformExtraPort();

    //   
    clock_t clockCount();

    _KERNEL NameStr* msgName( uint idx, CChar* c, CaseType cas = CT_IMEN, bool invis = true );
	_KERNEL GenderStr* msgGender( uint idx, CChar* c, char* male, char* female, char* neutral, char* multiple, bool invis = true );
	_KERNEL GenderStr* msgGender( uint idx, CChar* c, SwitchType type, bool invis = true );

    //   
    _KERNEL CAffectData* GetAffData( byte id = 0, uint pulses = 0, PkFlag pkFlag = APF_NOPK, int value = 80, bool doubl = false );
    _KERNEL void FreeAffData( CAffectData* data );

    //   
    _KERNEL CAffectUnit* GetAffUnitData( byte affID, int value = 1, bool doubl = true );
    _KERNEL void FreeAffUnitData( CAffectUnit* data );

    //  
    _KERNEL char* GetCharBuffer( int nSize ) { return new char[nSize]; }
    _KERNEL void* New( int nSize ) { return new byte[nSize]; }

public: // 

	_KERNEL static uint m_pulse;       //  
	_KERNEL static uint m_rebootPulse; //  
	_KERNEL static int  m_fightOrder;  //     
    _KERNEL static ULONGLONG m_sysTime; //  

	//   
	_KERNEL static bool m_repopDoorsPulse;         //  
	_KERNEL static bool m_changeDayTimePulse;      //   
	_KERNEL static bool m_weatherPulse;            //  
	_KERNEL static bool m_checkMuteTimersPulse;    //     
	_KERNEL static bool m_checkTimersPulse;        //   
	_KERNEL static bool m_checkAffectsPulse;       //   
	_KERNEL static bool m_checkDropLinksPulse;     //     
	_KERNEL static bool m_performRoundPulse;       //  
	_KERNEL static bool m_repopPulse;              //  
	_KERNEL static bool m_mobMovingPulse;          //  
	_KERNEL static bool m_lookPulse;               //    
	_KERNEL static bool m_foodPulse;               //     
	_KERNEL static bool m_clearMobMemoryPulse;     //   
	_KERNEL static bool m_checkMentalControlPulse; //    
	_KERNEL static bool m_poisonVisualPulse;       //    
	_KERNEL static bool m_flawerPulse;             //   
	_KERNEL static bool m_pkCheckPulse;            //   -
	_KERNEL static bool m_dtListCheckPulse;        //     
	_KERNEL static bool m_fightPulse;              //  
	_KERNEL static bool m_instCheckPulse;          //   

	_KERNEL static CCharPlayer* m_debugChar;       //  
	_KERNEL static CCharPlayer* m_immChar;         // 
	_KERNEL static bool m_canCrash;                //   
	_KERNEL static int m_logType;                  //  

	_KERNEL static CCharMob* m_moveMobs[100000]; //    
	_KERNEL static int m_moveMobsCount;

	_KERNEL static CChar* m_compareMob; //  : 
	_KERNEL static bool m_compareMagic; //  :  

	_KERNEL static time_t m_rebootTime; //  
	_KERNEL static bool m_afterCrash;   //   

	_KERNEL static bool m_deleteInst;   //   

	_KERNEL static char* m_news;      //   
	_KERNEL static time_t m_newsTime; //   

	_KERNEL static char* m_legendInfo; //   

	_KERNEL static SPSet<CAccount*>  m_accounts;  //  
	_KERNEL static SPSet<CAccount2*> m_accounts2; //  ,   

	_KERNEL static SPSet<CCharPlayer*> m_chars; //  - (    )
	_KERNEL static SPSet<CNameInfo*> m_names;   //   
	_KERNEL static StringSet m_deniedNames;     //   

	_KERNEL static SPSet<CClan*> m_clans;              //  
	_KERNEL static SPSet<CFraction*> m_fractions;      //  

	_KERNEL static double m_levExpD[MAX_MORTAL_LEVEL+1];      //    
	_KERNEL static double m_levExpLimitD[MAX_MORTAL_LEVEL+1]; //     

	_KERNEL static CProfession* m_profs[PROF_COUNT];   //  
	_KERNEL static CRace*       m_races[RACE_COUNT];   //  
	_KERNEL static CMaterial*   m_materials[MT_COUNT]; //  
	_KERNEL static CWater*      m_waters[WT_COUNT];    //  
	_KERNEL static CSkill*      m_skills[SKILL_COUNT]; //  
	_KERNEL static CSpell*      m_spells[SPELL_COUNT]; //  
	_KERNEL static CAffect*     m_affects[AFF_COUNT];  //  
	_KERNEL static CColumn*     m_columns[COL_COUNT];  //  
	_KERNEL static CResistInfo* m_resists[MS_COUNT];   //   

	_KERNEL static PArray<CProfAI*> m_profAI;          //  

	_KERNEL static CSkill*      m_skillsSorted[SKILL_COUNT]; //   (  )
	_KERNEL static CSpell*      m_spellsSorted[SPELL_COUNT]; //   (  )
	_KERNEL static CAffect*     m_affectsSorted[AFF_COUNT];  //   (  )

	_KERNEL static PArray<CAbilValue*> m_abilValues;         //   

	_KERNEL static PArray<COldBookItem*> m_oldBooks;         //  

	_KERNEL static CSlot*       m_slots[SLOT_COUNT];         //  
	_KERNEL static int          m_allSlotsArea;              //   

	_KERNEL static CObjFlag*     m_objFlags[OF_COUNT];        //   
	_KERNEL static CObjType*     m_objTypes[OT_COUNT];        //   
	_KERNEL static CObjSubType*  m_subTypes[OST_COUNT];       //   
	_KERNEL static CWeaponSkill* m_weaponSkills[WS_COUNT];    //   
	_KERNEL static CDamageStr*   m_damageStrs[DS_COUNT];      //   
	_KERNEL static CDamageType*  m_damageTypes[DT_COUNT];     //   
	_KERNEL static CWalkMethod*  m_walkMethods[WMETH_COUNT];  //   
	_KERNEL static CIngrColor*   m_iColors[INGR_COLOR_COUNT]; //  
	_KERNEL static CModeVar*     m_modeVars[MV_COUNT];        //   
	_KERNEL static CHotel*       m_hotels[HOTEL_COUNT];       //  
	_KERNEL static CModifier*    m_modifiers[MAX_MODIFIERS];  //  
	_KERNEL static CColor*       m_colors[COLOR_COUNT];       //    
	_KERNEL static CColorItem*   m_colorItems[CI_COUNT];      //    
	_KERNEL static CColorGroup*  m_colorGroups[CG_COUNT];     //    
	_KERNEL static CFlawer*      m_flawers[FLAWER_COUNT];     //  

	_KERNEL static SPSet<CDBClass*> m_classes; //   

	_KERNEL static CWorld* m_worlds[WORLD_COUNT]; //  
	_KERNEL static CRoom* m_arenaEnter;           //   

	_KERNEL static PArray<CDoorSubject*> m_doors; //  
	_KERNEL static CBoard* m_boards[BOARD_COUNT]; // 

	_KERNEL static SPSet<CBan*> m_bans;   //    

	_KERNEL static PArray<CAnnounce*> m_announces; //  

	_KERNEL static SPSet<COffer*> m_offers; //  
	_KERNEL static int m_lastOffer;  //   
	_KERNEL static int m_lastDemand; //   

	_KERNEL static SPSet<CAuctionOffer*> m_auctionOffers; //  

	_KERNEL static SPSet<CShop*> m_shops; // 

	_KERNEL static int m_decayObjID; //  ,   
	_KERNEL static PArray<CDeletedObj*> m_deletedObjs; //   

	//_KERNEL static bool m_autoBotChecking;                        //   
	_KERNEL static bool m_nightTime;                                //  
    _KERNEL static CTime m_curHour;                                 //  
	_KERNEL static uint m_noBotCheckPulse;                          //     
    _KERNEL static CQuestionBotCheckData m_questionBotCheckData;    //    

	_KERNEL static PArray<CTopic*>   m_topics;     //  
	_KERNEL static SPSet<CTopicKey*> m_topicKeys;  //  
	_KERNEL static CTopic* m_notFoundTopic;        //     

	_KERNEL static CTote m_tote; // 

	_KERNEL static CLoto m_loto; // 

	_KERNEL static CJournal m_journal;     //   
	_KERNEL static CJournal m_noobJournal; //   
	_KERNEL static CJournal m_immJournal;  //   
	_KERNEL static CJournal m_prayJournal; //   
	_KERNEL static CJournal m_botJournal;  //  

	_KERNEL static CTransportNet m_transport; //  

	_KERNEL static CGradeBase           m_gradeBase;        //  
	_KERNEL static CRuneBase            m_runeBase;         //  
	_KERNEL static CQuestBase           m_questBase;        //  
	_KERNEL static CActionBase          m_actBase;          //   
	_KERNEL static CInterviewBase       m_interviewBase;    //  
	_KERNEL static CCustomTriggerBase   m_triggerBase;      //   
	_KERNEL static CZoneBase            m_zoneBase;         //   
	_KERNEL static CPriceBase           m_priceBase;        //  
	_KERNEL static CTrnZoneBase         m_trnZoneBase;      //   
	_KERNEL static CDailyTaskBase       m_dailyBase;        //  
	_KERNEL static CGloryBase           m_gloryBase;        //  
    _KERNEL static CComplexBase         m_complexBase;      //    
    _KERNEL static CWeakenBase          m_weakenBase;       //   
    _KERNEL static CGroupSearchBase     m_groupSearchBase;  //   
    _KERNEL static CTempInfo            m_tempBase;         //  
    _KERNEL static CStatBase            m_statBase;         //  
    _KERNEL static CSWBase              m_swBase;           // 

    static const int MSG_MAX = 4;
    NameStr* m_msgNames[MSG_MAX];
    GenderStr* m_msgGenders[MSG_MAX];

	//  
	_KERNEL static const int m_rebirthMax;
	_KERNEL static const int m_inventMax[][IT_COUNT];

	//  
	_KERNEL static CCharPlayer* QUEST_ALL;

	//   
	int m_exchangeOffers;   //    
	bool m_tournMode;       //    
	bool m_aukMode;         //   
	bool m_lotoMode;        //   
	bool m_arcoMode;        //    

	char* m_mobRecords;     //   
	char* m_mobRecordsSel;  //     

    clock_t m_clock;        //  
    clock_t m_clockSumm[20]; //  

    _KERNEL static MemoryArray<CAffectData> m_affData;
    _KERNEL static MemoryArray<CAffectUnit> m_affUnitData;
    int m_roundDamage;

    //    AI
    _KERNEL const static int m_aiFlagDataSize;
    _KERNEL static CAIFlagData m_aiFlagData[];

	//       
	_KERNEL static int64 m_inPackets;   //  
	_KERNEL static int64 m_inBytes;     //  
	_KERNEL static int64 m_outPackets;  //  
	_KERNEL static int64 m_outBytes;    //  

	//   
	_KERNEL static char* m_policy;

};
