/*    

	Copyright (c) 2001 - 2004. All Rights Reserved.
	:  ..
*/
#pragma once

//   
class CDBClass
{

public: // 

	CDBClass( char* name, char* extra );

public: // 

	//    
	virtual CDBObject* Find( int id ) = 0;

	//    
	virtual CDBObject* Find( CMaskManager& mm ) = 0;

public: //  

	bool operator==( const CDBClass& c ) const { return strcmp( m_mask1, c.m_mask1 ) == 0; }
	bool operator!=( const CDBClass& c ) const { return strcmp( m_mask1, c.m_mask1 ) != 0; }
	bool operator>=( const CDBClass& c ) const { return strcmp( m_mask1, c.m_mask1 ) >= 0; }
	bool operator<=( const CDBClass& c ) const { return strcmp( m_mask1, c.m_mask1 ) <= 0; }
	bool operator> ( const CDBClass& c ) const { return strcmp( m_mask1, c.m_mask1 ) >  0; }
	bool operator< ( const CDBClass& c ) const { return strcmp( m_mask1, c.m_mask1 ) <  0; }

public: // 

	char* m_name;   //  
	char* m_mask1;  //  
	char* m_mask2;  //  

};

// 
class CAccountClass : public CDBClass
{

public: // 

	CAccountClass() : CDBClass( "Account", "" ) {}

public: // 

	//    
	CDBObject* Find( int id );

	//    
	CDBObject* Find( CMaskManager& mm );

};

// -
class CCharPlayerClass : public CDBClass
{

public: // 

	CCharPlayerClass() : CDBClass( "CharPlayer", "" ) {}

public: // 

	//    
	CDBObject* Find( int id );

	//    
	CDBObject* Find( CMaskManager& mm );

};

//  
class CDataBaseClass : public CDBClass
{

public: // 

	CDataBaseClass() : CDBClass( "DB", "" ) {}

public: // 

	//    
	CDBObject* Find( int id );

	//    
	CDBObject* Find( CMaskManager& mm );

};
