/*  

	Copyright (c) 2014. All Rights Reserved.
	: .
*/
#pragma once

//     
class CDailyTaskProgress
{

public: //   

	CDailyTaskProgress( int id = 0, int instIdx = 0, int nodeCount = 0 ) :
		m_id( id ), m_instIdx( instIdx ), m_count( 1 ), m_leader( 0 )
	{
		if( nodeCount ) { m_nodes = new bool[nodeCount]; ::memset( m_nodes, 0, nodeCount ); }
		else m_nodes = NULL;
	}

	~CDailyTaskProgress();

public: // 

    //    
    bool ShowInList();

public: // 

	int    m_id;      //  
	int    m_instIdx; //  
	double m_count;   //   (   0)
	bool*  m_nodes;   // 
    CChar* m_leader;  //  

};

//    
class CDailyTaskInfoNodeSubdata
{

public: // 

	// 
	virtual void Serialize( CFileStore& fs ) {}

	//  
	virtual void Deploy() {}

	// 
	virtual void Link() {}

	// 
	virtual void* Option() = 0;

	//  
	virtual void ShowNode( char* buf ) {}

};

//     - 
class CDailyTaskInfoNodeKillSubdata : public CDailyTaskInfoNodeSubdata
{

public: // 

	CDailyTaskInfoNodeKillSubdata() :
		m_roomId( 0 ), m_mobId( 0 ), m_num( 0 ), m_mobData( NULL )/*, m_room( NULL ), m_mobNum( 0 )*/
	{}

public: // 

	// 
	void Serialize( CFileStore& fs );

	//  
	void Deploy();

	// 
	void Link();

	// 
	void* Option() { return m_mobData; }

	//  
	void ShowNode( char* buf );

public: // 

	int m_roomId; // 
	int m_mobId;  // 
	int m_num;    // 

	CMobPopBaseData* m_mobData; // 
	//CRoomBaseData* m_room; // 
	//int m_mobNum; //  

};

//     - 
class CDailyTaskInfoNodeContSubdata : public CDailyTaskInfoNodeSubdata
{

public: // 

	CDailyTaskInfoNodeContSubdata() :
		m_roomId( 0 ), m_objId( 0 ), m_num( 0 ), m_objData( NULL )/*, m_room( NULL ), m_objNum( 0 )*/
	{}

public: // 

	// 
	void Serialize( CFileStore& fs );

	//  
	void Deploy();

	// 
	void Link();

	// 
	void* Option() { return m_objData; }

	//  
	void ShowNode( char* buf );

public: // 

	int m_roomId; // 
	int m_objId;  // 
	int m_num;    // 

	CObjPopInRoomBaseData* m_objData; // 
	//CRoomBaseData* m_room; // 
	//int m_objNum; //  

};

//     - 
class CDailyTaskInfoNodeTriggerSubdata : public CDailyTaskInfoNodeSubdata
{

public: // 

	CDailyTaskInfoNodeTriggerSubdata() :
		m_id( 0 )
	{}

public: // 

	// 
	void Serialize( CFileStore& fs );

	// 
	void* Option() { return (void*)m_id; }

	//  
	void ShowNode( char* buf );

public: // 

	int      m_id;    // 
	CString  m_desc;  // 

};

//   
class CDailyTaskInfoNode
{

public: // 

	CDailyTaskInfoNode( int type = DTNT_NONE );

public: // 

	// 
	void Init();

	// 
	void Serialize( CFileStore& fs );

public: // 

	int m_type; //  
	CDailyTaskInfoNodeSubdata* m_subData; //  

};

//  
class CDailyTaskInfo
{

public: // 

	CDailyTaskInfo();

public: // 

	// 
	void Serialize( CFileStore& fs );

	//  
	void Deploy();

	// 
	void Link();

	//  
	void CompleteNode( int idx, CCharPlayer* cp, CZoneInstance* zoneInst, int charCount );

	//  
	void ShowProgress( char* buffer, CDailyTaskProgress* progress );

    //    
    bool ShowInList();

public: // 

	int     m_id;        // 
	CString m_name;      // 
	int     m_money;     // 
	int     m_exp;       // 
	int     m_max;       // 
	int     m_glory;     // 

	int     m_nodeCount; //  
	CDailyTaskInfoNode* m_nodes; // 

};

//  
class CDailyTaskBase
{

public: // 

	//  
	void InitQuests();

	//  
	void LinkQuests();

	//  
	CDailyTaskInfo* FindTask( int id );

	//    
	CDailyTaskInfo* FindTaskByZone( int id );

    //  
	_KERNEL void CompleteNode( CRoom* room, int type, void* option );

	//   
	void CompleteTriggerNode( CRoom* room, int trigId );

	//  
	void ShowDailyTaskProgress( CCharPlayer* cp, CDailyTaskInfo* task, CDailyTaskProgress* progress, bool complete, int num );

public: // 

	PArray<CDailyTaskInfo*> m_tasks; // 

};
