/*  

	Copyright (c) 2012.
	: .
*/
#pragma once

//  
class CInterviewNode
{

public: // 

	CInterviewNode();

	CInterviewNode( const char* text );

public: // 

	//   
	_KERNEL void Serialize( CFileStore& fs );

	//   
	_KERNEL bool HasResponce( int id );

	//  
	_KERNEL void AddResponce( int id );

public: // 

	CString m_text;          //  

	PArray<int> m_responces; // 

};


// 
class CInterview
{

public: // 

	CInterview();

	CInterview( const char* desc );

public: // 

	//   
	_KERNEL void Serialize( CFileStore& fs );

	//  
	_KERNEL void AddNode( const char* text );

	//  
	_KERNEL void RemoveNode( CCharPlayer* cp, int answer );

	//  
	_KERNEL void SetActive( bool active );

	//   
	_KERNEL bool HasResponce( int id );

	//  
	_KERNEL void GiveAnswer( CCharPlayer* cp, int index );

	//  
	_KERNEL void ShowInterview( CCharPlayer* cp, bool responce = false );

public: // 

	int m_id;       // 

	bool m_active;  // 

	CString m_desc; // 

	int m_count;    //  
	PArray<CInterviewNode*> m_nodes; //  

};

//  
class CInterviewBase
{

public: // 

	//   
	_KERNEL void Serialize( CFileStore& fs );

	//  
	_KERNEL bool CheckCondition( CCharPlayer* cp, bool access = false, bool uniq = false, bool index = false, bool active = false, int ind = 0 );

	//  
	_KERNEL bool CheckAccess( CCharPlayer* cp );

	//   
	_KERNEL bool CheckUniq( CCharPlayer* cp );

	//   
	_KERNEL bool CheckIndex( CCharPlayer* cp, int index );

	//  
	_KERNEL void AddInterview( CCharPlayer* cp, const char* desc );

	//  
	_KERNEL void RemoveInterview( CCharPlayer* cp, int index );

	//   
	_KERNEL void AddInterviewNode( CCharPlayer* cp, int index, const char* text );

	//   
	_KERNEL void RemoveInterviewNode( CCharPlayer* cp, int index, int answer );

	//  
	_KERNEL void SetActive( CCharPlayer* cp, int index, bool active );

	//  
	_KERNEL void GiveAnswer( CCharPlayer* cp, int index, int answer );

	//  
	_KERNEL void ShowInterview( CCharPlayer* cp, int index );

	//  
	_KERNEL void ShowInterviews( CCharPlayer* cp );

public: // 

	PArray<CInterview*> m_interviews; // 

};
