/*    

	Copyright (c) 2011. All Rights Reserved.
	: .
*/
#pragma once

// 
class CQuestStatus;
class CQuestInfo;
class CQuestTrophyItemData;

//  
_KERNEL void EndMobTrigger( CMobTriggerData* data, int (*func)(CTriggerData*) = NULL );

//  
class CGeneratedTask
{

public: //   

	CGeneratedTask() :
		m_charId( 0 ), m_randomList( NULL ), m_randomValues( NULL )
	{}

	~CGeneratedTask();
	
public: // 

	int m_charId;                // 
	PArray<int>* m_randomList;   //  
	PArray<int>* m_randomValues; //  

};

//   
class CQuestMobPhrase
{

public: // 

	CQuestMobPhrase() :
		m_str( "", PST_ACTION )
	{}

public: // 

	_KERNEL void Serialize( CFileStore& fs );               //   
	_KERNEL void Perform( CCharMob* mob, CCharPlayer* cp ); //  

public: // 

	CParamStr m_str; // 

};

//   
class CQuestMobText
{

public: // 

	CQuestMobText() :
		m_pulse( 0 )
	{}

public: // 

	_KERNEL void Serialize( CFileStore& fs );               //   
	_KERNEL void Perform( CCharMob* mob, CCharPlayer* cp ); //  

public: // 

	PArray<CQuestMobPhrase*> m_phrases; //  
	int m_pulse;                        //  

};

//    
class CQuestMobMonologueFork
{

public: // 

	CQuestMobMonologueFork() :
		m_nextId( 0 )
	{}

public: // 

	_KERNEL void Serialize( CFileStore& fs ); //   

public: // 

	PArray<CString*> m_answers; //  
	int m_nextId;               // Id  

};

//   
class CQuestMobMonologue
{

public: // 

	CQuestMobMonologue() :
		m_id( 0 ), m_flags( 0 ), m_pulses( 0 )
	{}

public: // 

	_KERNEL void Serialize( CFileStore& fs ); //   

public: // 

	int m_id;                                // Id 
	uint m_flags;                            //  
	int m_pulses;                            //  
	PArray<CQuestMobText*> m_texts;          //  
	PArray<CQuestMobMonologueFork*> m_forks; //  

};

//  
class CQuestMobMonologueInstance
{

public: // 

	CQuestMobMonologueInstance( CQuestMobMonologue* monologue, CCharMob* mob );

public: // 

	_KERNEL int PerformPulse( CCharMob* mob, CCharPlayer* cp, int pulse ); //   

public: // 

	CQuestMobMonologue* m_monologue; // 
	int m_pulse;                     //  
	CCharMob* m_mob;                 // 
    int m_instIdx;                   //  

};

//       ''
class CQuestTrophyItemLoadData
{

public: // 

	CQuestTrophyItemLoadData() :
		m_mobId( 0 ), m_perc( 0 ), m_tip( false )
	{}

public: // 

	_KERNEL void Serialize( CFileStore& fs ); //   

public: // 

	CQuestTrophyItemData* m_itemData; //   

	int m_mobId; // Id 
	int m_perc;  //  
	bool m_tip;  // 

};

//      
class CQuestTriggerObject
{

public: // 

	CQuestTriggerObject() :
		m_id( 0 ), m_pulse( 0 )
	{}

public: // 

	_KERNEL void Serialize( CFileStore& fs ); //   

public: // 

	int m_id;     // Id 
	uint m_pulse; //  

};

//     
class CQuestTaskNode
{

public: // 

	CQuestTaskNode( int id = 0 ) :
		m_id( id )
	{}

public: // 

	//   
	_KERNEL virtual bool CheckQuestObject( int oType, int oId ) = 0;

public: // 

	int m_id; //   

};

//      
class CQuestHuntingTaskMobData : public CQuestTaskNode
{

public: // 

	CQuestHuntingTaskMobData( int id ) :
		CQuestTaskNode( id ), m_mobId( 0 ), m_count( 0 )
	{}

public: // 

	_KERNEL void Serialize( CFileStore& fs ); //   

	//   
	_KERNEL bool CheckQuestObject( int oType, int oId );

public: // 

	int m_mobId;          // Id 
	CRandomValue m_count; //  

};

//      ''
class CQuestTrophyItemData : public CQuestTaskNode
{

public: // 

	CQuestTrophyItemData( int id ) :
		CQuestTaskNode( id ), m_objId( 0 ), m_count( 0 ), m_giveStr( NULL ), m_funcId( -1 ), m_giveFuncId( -1 )
	{}

public: // 

	_KERNEL void Serialize( CFileStore& fs ); //   

	//   
	_KERNEL bool CheckQuestObject( int oType, int oId );

public: // 

	int m_objId;                              // Id 
	CRandomValue m_count;                     //  
	CParamStr* m_giveStr;                     //   
	PArray<CQuestTrophyItemLoadData*> m_load; //  
	CRandomList m_loadRandom;                 //  
	int m_funcId;                             //  
    int m_giveFuncId;                         //   

};

//    
class CQuestTriggerToolData
{

public: // 

	CQuestTriggerToolData() :
		m_id( 0 ), m_func( 0 ), m_destroy( false )
	{}

public: // 

	//   
	_KERNEL void Serialize( CFileStore& fs );

public:	// 

	int m_id;       // 
	byte m_func;    //  
	bool m_destroy; // 

	CString* m_msg[QTMT_COUNT];             // 

};

//      ''
class CQuestTriggerData
{

public: // 

	CQuestTriggerData() :
		m_type( QTOT_ROOM ), m_perc( 0 ), m_triggerTime( 0 ), m_repopTime( 0 )
	{
		::memset( m_msg, 0, sizeof(m_msg) );
	}

public: // 

	_KERNEL void Serialize( CFileStore& fs ); //   

public: // 

	PArray<CString*> m_cmds;                //  

	byte m_type;                            //  
	PArray<CQuestTriggerObject*> m_targets; //  

	PArray<CQuestTriggerToolData*> m_tools; //  

	int m_perc;                             // 
	int m_triggerTime;                      //   
	int m_repopTime;                        //   

	CString* m_msg[QTMT_COUNT];             // 

};

//       ''
class CQuestTriggerTaskTriggerData : public CQuestTaskNode
{

public: // 

	CQuestTriggerTaskTriggerData( int id ) :
		CQuestTaskNode( id )
	{ m_data = new CQuestTriggerData(); }

public: // 

	//   
	_KERNEL void Serialize( CFileStore& fs );

	//   
	_KERNEL bool CheckQuestObject( int oType, int oId );

public: // 

	CQuestTriggerData* m_data; // 
	CRandomValue m_count;   // 
	CString m_info;  //  

};

//       ''
class CQuestGatherTaskItemData : public CQuestTaskNode
{

public: // 

	CQuestGatherTaskItemData( int id ) :
		CQuestTaskNode( id ), m_objId( 0 ), m_count( 0 ), m_giveStr( NULL ), m_funcId( -1 )
	{}

public: // 

	//   
	_KERNEL void Serialize( CFileStore& fs );

	//   
	_KERNEL bool CheckQuestObject( int oType, int oId );

public: // 

	int m_objId;                       // Id 
	CRandomValue m_count;              // 
	CParamStr* m_giveStr;              //   
	PArray<CQuestTriggerData*> m_trgs; //  
	CRandomList m_trgsRandom;          //  
	int m_funcId;                      //  

};

//      ''
class CQuestAddressData : public CQuestTaskNode
{

public: // 

	CQuestAddressData( int id ) :
		CQuestTaskNode( id ), m_objId( 0 ), m_mobId( 0 ), m_funcId( -1 ), m_giveStr( NULL ), m_otherStr( NULL )
	{}

public: // 

	_KERNEL void Serialize( CFileStore& fs );               //   
	_KERNEL CQuestMobMonologue* GetMonologue( uint flags ); //   -

	//   
	_KERNEL bool CheckQuestObject( int oType, int oId );

public: // 

	int m_objId;                           // Id 
	int m_mobId;                           // Id 

	int m_funcId;                          // Id   
	//  : CSubject* (*makeFunc)( int -  , CCharPlayer* - , CCharMob* - - )

	CParamStr* m_giveStr;                  //   
	CParamStr* m_otherStr;                 //   
	PArray<CQuestMobMonologue*> m_speechs; // 

};

//      ''
class CQuestQuestTaskQuestData : public CQuestTaskNode
{

public: // 

	CQuestQuestTaskQuestData( int id ) :
		CQuestTaskNode( id ), m_info( "" )
	{}

public: // 

	//   
	_KERNEL void Serialize( CFileStore& fs );

	//   
	_KERNEL bool CheckQuestObject( int oType, int oId );

public: // 

	PArray<int> m_questId; //  
	CString m_info;        //  

};

//    
class CQuestTaskData
{

public: // 

	//   
	_KERNEL virtual void Serialize( CFileStore& fs ) {}

	//  
	_KERNEL virtual void Deploy( bool set = true, CQuestStatus* status = NULL ) {}

	//     
	//_KERNEL virtual bool IsHuntingMob( CCharMob* mob ) { return false; }

	//     
	_KERNEL virtual bool IsTrophyMob( CCharMob* mob ) { return false; }

};

//     ''
class CQuestHuntingTaskData : public CQuestTaskData
{

public: // 

	_KERNEL void Serialize( CFileStore& fs );                     //   
	_KERNEL void Deploy( bool set = true, CQuestStatus* status = NULL ); //  
	//_KERNEL bool IsHuntingMob( CCharMob* mob );                   //    

public: // 

	PArray<CQuestHuntingTaskMobData*> m_mobs; // 
	CRandomList m_mobsRandom;                 //  

};

//    ''
class CQuestTrophyTaskData : public CQuestTaskData
{

public: // 

	CQuestTrophyTaskData() :
		m_otherItemStr( NULL )
	{}

public: // 

	_KERNEL void Serialize( CFileStore& fs );                     //   
	_KERNEL void Deploy( bool set = true, CQuestStatus* status = NULL ); //  
	_KERNEL bool IsTrophyMob( CCharMob* mob );                    //    

public: // 

	CParamStr* m_otherItemStr;             //    
	PArray<CQuestTrophyItemData*> m_items; // 
	CRandomList m_itemsRandom;             //  

};

//     ''
class CQuestTriggerTaskData : public CQuestTaskData
{

public: // 

	CQuestTriggerTaskData() {}

public: // 

	_KERNEL void Serialize( CFileStore& fs );                     //   
	_KERNEL void Deploy( bool set = true, CQuestStatus* status = NULL ); //  

public: // 

	PArray<CQuestTriggerTaskTriggerData*> m_trgs; // 
	CRandomList m_trgsRandom;        //  

};

//     ''
class CQuestGatherTaskData : public CQuestTaskData
{

public: // 

	CQuestGatherTaskData() :
		m_otherItemStr( NULL )
	{}

public: // 

	_KERNEL void Serialize( CFileStore& fs );                     //   
	_KERNEL void Deploy( bool set = true, CQuestStatus* status = NULL ); //  

public: // 

	CParamStr* m_otherItemStr;                 //    
	PArray<CQuestGatherTaskItemData*> m_items; //  
	CRandomList m_itemsRandom;                 //  

};

//    ''
class CQuestParcelTaskData : public CQuestTaskData
{

public: // 

	CQuestParcelTaskData()
	{
		m_addresses.add( new CQuestAddressData( 0 ) );
	}

public: // 

	_KERNEL void Serialize( CFileStore& fs );                     //   
	_KERNEL void Deploy( bool set = true, CQuestStatus* status = NULL ); //  

public: // 

	PArray<CQuestAddressData*> m_addresses; // 

};

//    ''
class CQuestCourierTaskData : public CQuestTaskData
{

public: // 

	_KERNEL void Serialize( CFileStore& fs );                     //   
	_KERNEL void Deploy( bool set = true, CQuestStatus* status = NULL ); //  

public: // 

	PArray<CQuestAddressData*> m_addresses; // 

};

//    ''
class CQuestQuestTaskData : public CQuestTaskData
{

public: // 

	_KERNEL void Serialize( CFileStore& fs );                       //   
	_KERNEL void Deploy( bool set = true, CQuestStatus* status = NULL ) {} //  

public: // 

	PArray<CQuestQuestTaskQuestData*> m_quests; //  
	CRandomList m_questsRandom;                 //  

};

//  
class CQuestTask
{

public: // 

	CQuestTask() :
		m_type( QTT_HUNTING ), m_data( NULL )
	{}

public: // 

	//   
	_KERNEL void Serialize( CFileStore& fs );

	//  
	_KERNEL void Deploy( bool set = true, CQuestStatus* status = NULL ) { m_data->Deploy( set, status ); }

	//    
	//_KERNEL bool IsHuntingMob( CCharMob* mob ) { return m_data->IsHuntingMob( mob ); }

	//    
	_KERNEL bool IsTrophyMob( CCharMob* mob ) { return m_data->IsTrophyMob( mob ); }

	//  
	_KERNEL CGeneratedTask* GenerateTask();

	//    
	_KERNEL CParamStr* GetOtherStr();

	//  
	_KERNEL void ShowTask( CQuestInfo* quest, CGeneratedTask* task, char* buffer );

public: // 

	byte m_type;            //  
	CQuestTaskData* m_data; //  

};

//     
class CQuestTaskLoadNode
{

public: // 

	CQuestTaskLoadNode( int id = 0, int value = 0, int count = 0, bool complete = false ) :
		m_id( id ), m_value( value ), m_count( count ), m_complete( complete )
	{}

public: // 

	_KERNEL void Serialize( CFileStore& fs );

public: // 

	int m_id;        // 
	int m_value;     // 
	int m_count;     // 
	bool m_complete; //  

};

//     
class CQuestStartDelay
{

public: // 

	CQuestStartDelay( CCharPlayer* cp, CCharMob* mob, CQuestStatus* status, uint pulse, bool start = true ) :
		m_char( cp ), m_mob( mob ), m_status( status ), m_pulse( pulse )
	{}

public: // 

	CCharPlayer* m_char;    // 
	CCharMob* m_mob;        // 
	CQuestStatus* m_status; //  
	bool m_start;           //   
	uint m_pulse;           // 

};

//   
class CQuestTaskNodeInstance
{

public: // 

	CQuestTaskNodeInstance( CQuestTaskNode* node, QuestTaskType type, int count = -1 );

public: // 

	//  
	_KERNEL void ShowProgress( char* buffer, bool detail = true, CQuestInfo* quest = 0 );

	_KERNEL bool IsHuntingMob( CCharMob* mob ); //    
	_KERNEL bool IsTrophyMob( CCharMob* mob );  //    

	//   
	_KERNEL bool CheckQuestObject( int oType, int oId ) { return m_node->CheckQuestObject( oType, oId ); }

	//   
	_KERNEL int GetObjId();

	//    
	_KERNEL CParamStr* GetGiveStr();

    //    
    _KERNEL int giveFuncId();

	_KERNEL void Serialize( CFileStore& fs );

public: // 

	CQuestTaskNode* m_node; //  
	byte m_type;              //  
	int m_value;                 // 
	int m_count;                     // 
	bool m_complete;      //  

};

//  
class CQuestTaskInstance
{

public: //   

	CQuestTaskInstance( CQuestTask* task ) :
		m_task( task )
	{}
	~CQuestTaskInstance();

public: // 

	//  
	_KERNEL void GenerateTask();

	//  
	_KERNEL void CopyTask( CQuestTaskInstance* task );

	//   
	_KERNEL void AcceptTask( CGeneratedTask* task );

	//  
	_KERNEL void ShowProgress( char* buffer, TriggerObjectType oType = TOT_COUNT, int oId = 0 );

	//      
	_KERNEL void CreateTrophyItems( CCharMob* mob, PArray<CSubject*>& loadItems, CQuestStatus* status, double koef = 0 );

	//     
	_KERNEL void FindQuestTrigger( QuestTriggerObjectType objType, int objId, char* cmd, CQuestTaskNodeInstance** node, CQuestTriggerData** trigData, CQuestTriggerObject** object );

	//     
	_KERNEL void FindQuestGather( QuestTriggerObjectType objType, int objId, char* cmd, CQuestTaskNodeInstance** node, CQuestTriggerData** trigData, CQuestTriggerObject** object );

	//  
	_KERNEL void FindQuestAddress( CCharMob* mob, int objId, CQuestTaskNodeInstance** node );

	//  
	_KERNEL void PerformQuestComplete( int questId );

	//  
	_KERNEL bool IsCompleted();

	//  
	_KERNEL void ShowTask( CQuestInfo* quest, char* buffer );

public: // 

	CQuestTask* m_task;                            // 

	PArray<CQuestTaskNodeInstance*> m_nodes; //  

};

//   
class CAwardItem
{

public: // 

	CAwardItem() :
		m_id( 0 ), m_funcId( -1 ), m_stuff( false ), m_profFlags( 0 )
	{}

public: // 

	//   
	_KERNEL void Serialize( CFileStore& fs );

public: // 

	int m_id;        // 
	int m_funcId;    // 
	int m_profFlags; //  
	bool m_stuff;    //   

};

//   
class CQuestAwardNode
{

public: // 

	CQuestAwardNode() :
		m_monologueId( 0 ), m_exp( 0 ), m_max( 0 ), m_money( 0 )
	{}

public: // 

	_KERNEL void Serialize( CFileStore& fs ); //   

public: // 

	int m_monologueId;   // Id 

	CRandomValue m_exp;   // 
	int m_max;            // 
	CRandomValue m_money; // 
	PArray<CAwardItem*> m_items; // 
	CRandomList m_itemsRandom;   //  

};

//  
class CQuestAward
{

public: // 

	CQuestAward() { m_base = new CQuestAwardNode(); }

public: // 

	_KERNEL void Serialize( CFileStore& fs ); //   

public: // 

	CQuestAwardNode* m_base;           //  
	PArray<CQuestAwardNode*> m_awards; // 

};

//    
class CQuestStatusSubdata {};

//    
class CQuestStatusCommonSubdata : public CQuestStatusSubdata
{

public: // 

	CQuestStatusCommonSubdata( int instIdx ) :
		m_instIdx( instIdx )
	{}

public: // 

	int m_instIdx; //  

};

//   
class CQuestStatus
{							

public: //   

	_KERNEL CQuestStatus( CCharPlayer* cp, CQuestInfo* quest );
	_KERNEL ~CQuestStatus();

public: // 

	//   
	_KERNEL void Serialize( CFileStore& fs );

	//  
	_KERNEL bool CheckSave();

	//   
	_KERNEL int GetRepopPulse();

    //  
    _KERNEL byte GetStage( bool self = false );

	//   
	_KERNEL bool CheckStage( int stage, bool self = false );

	// 
	_KERNEL bool IsCommon() { return m_char == NULL; }

	//  
	_KERNEL void AcceptQuest();
	//   
	_KERNEL void AwardQuest( CCharMob* mob, int monologueId );

	//  
	_KERNEL void InitMonologue( CQuestMobMonologue* monologue, CCharMob* mob );
	//   
	_KERNEL void CheckMonologueForks();

	//   
	_KERNEL int instIdx();

	//   
	_KERNEL bool PerformGiveObj( CGiveObjMobTriggerData* giveData );

	//   
	_KERNEL bool CheckChar( CCharPlayer* cp, int instIdx = 0 );

	//  
	_KERNEL CQuestTaskInstance* GetCurrentTask( int instIdx = 0 );

	//  
	_KERNEL void CopyTask( CQuestTaskInstance* task );

	//     ""
	_KERNEL void CheckQuestQuestComplete();

    // 
    _KERNEL bool Compare( int value, uint uType );

public: // 

	CCharPlayer* m_char;                          // 
	bool m_linked;                        //  

	CQuestInfo* m_quest;                             // 
	byte m_stage;                          //  
	CQuestTaskInstance* m_task;                    // 

	PArray<CQuestTaskLoadNode*> m_load; //  
	int m_loadValue;                    //  
	int m_loadCount;                    //  
	int m_version;                          //  

	CQuestMobMonologueInstance* m_monologueInst; //  
	bool m_forkExist;                 //   
	uint m_returnPulse;                       //  
	uint m_completePulse;                 //  

	CQuestStatusSubdata* m_subData; //    

};

//   
class CQuestReqAbility
{

public: // 

	CQuestReqAbility::CQuestReqAbility( int abilId, int value ) :
		m_abilId( abilId ), m_value( value )
	{}

public: // 

	int m_abilId; //  
	int m_value;  // 

};

//   
class CQuestRequirement
{

public: // 

	CQuestRequirement() :
		m_type( QRQT_LEVEL ), m_data( NULL )
	{}

public: // 

	_KERNEL void Serialize( CFileStore& fs );  // 

	_KERNEL bool CheckChar( CCharPlayer* cp ); //  
	_KERNEL void ShowReq( char* buffer );      //   

public: // 

	byte m_type;  //  
	void* m_data; // 

};

//   
class CQuestStuff
{

public: // 

	CQuestStuff() :
		m_objId( 0 ), m_funcId( -1 )
	{}

public: // 

	_KERNEL void Serialize( CFileStore& fs );  // 

public: // 

	int m_objId;  //  
	bool m_limit; //  
	int m_funcId; // 

};

/*
//     
class CQuestSimpleChar
{

public: // 

	CCharPlayer* cp;  // 
	int m_instIdx; //  
	uint m_pulse;        // 

};
*/

//       
class CQuestInstStatus
{

public: // 

	CQuestInstStatus( CQuestInfo* quest, int instIdx = 0 ) :
		m_quest( quest ), m_instIdx( instIdx ), m_task( NULL ), m_startPulse( 0 ), m_endPulse( 0 ), m_stage( QST_NONE )
	{}

public: // 

	//  
	_KERNEL bool IsComplete();

	//   
	_KERNEL void CopyTask();

	//   
	_KERNEL void PerformKillMob( CRipMobTriggerData* data );
	//   
	//_KERNEL void PerformGiveObj( CSubject* obj );

    //  
    _KERNEL bool IsRepop();

    //  
    _KERNEL void RepopInst();

    //    
    _KERNEL void CheckRepop();

public: // 

	CQuestInfo* m_quest;               // 
	int m_instIdx;                      // 

	CQuestTaskInstance* m_task;      // 
	byte m_stage;            //  

	uint m_startPulse;   //   
	uint m_endPulse;      //   

	PArray<CQuestStatus*> m_chars; // 

};

//   
class CQuestInfoSubdata {};

//   
class CQuestInfoCommonSubdata : public CQuestInfoSubdata
{

public: // 

	CQuestInfoCommonSubdata( CQuestInfo* quest ) :
		m_repopMin( 0 )
	{
		m_status = new CQuestStatus( NULL, quest );
	}

public: // 

	//    
	_KERNEL CQuestInstStatus* GetInstStatus( int instIdx );

	//    
	//_KERNEL void DeleteInstStatus( int instIdx );

	//   
	_KERNEL void RepopInst( int instIdx );

public: // 

	int m_repopMin;                   //   
	CQuestStatus* m_status;                         // 
	PArray<CQuestInstStatus*> m_insts; //    

};

//   
class CQuestInfo
{

public: // 

	CQuestInfo() :
		m_id( 0 ), m_level( 1 ), m_mobId( 0 ), m_repopTime( 0 ),
		m_type( QT_NONE ), m_subData( NULL ), m_zone( NULL )
	{
		m_task = new CQuestTask();
		m_award = new CQuestAward();
	}

public: // 

	// 
	_KERNEL void Serialize( CFileStore& fs );

	//   
	_KERNEL bool CanAccept( CCharPlayer* cp );
	//   
	_KERNEL CQuestStatus* CreateStatus( CCharPlayer* cp, int instIdx );

	//    
	_KERNEL void CreateCommonStatus( CCharPlayer* cp, int instIdx );

	//  
	_KERNEL bool IsCommon() { return m_type == QT_COMMON; }
	//  
	_KERNEL bool IsPersonal() { return m_type == QT_PERSONAL; }

	//   
	_KERNEL CQuestStatus* GetSpecialStatus()
		{ return ((CQuestInfoCommonSubdata*)m_subData)->m_status; }
	//    
	_KERNEL CQuestInstStatus* GetInstStatus( int instIdx )
		{ return ((CQuestInfoCommonSubdata*)m_subData)->GetInstStatus( instIdx ); }

	//    
	_KERNEL void CreateInstStatus( int instIdx );

	//   -
	_KERNEL CQuestMobMonologue* GetMonologue( uint flags, int id = -1 );

	//  
	_KERNEL bool isContinue( int questId );

public: // 

	int m_type;                                       //  

	int m_id;                                          // Id 
	CString m_name;                              //  
	CString m_desc;                              //  

	int m_mobId;                                   // Id -

	int m_level;                        //  
	PArray<CQuestRequirement*> m_questReq; //   
	int m_repopTime;                                //  

	PArray<CQuestMobMonologue*> m_speechs;       //  

	CQuestTask* m_task;                        //  
	CQuestAward* m_award;                      //  
	PArray<CQuestStuff*> m_stuff;             //  

	PArray<void*> m_funcs;                               // 

	PArray<CGeneratedTask*> m_generated; //  

	CQuestInfoSubdata* m_subData;             //   

	CZone* m_zone;                                   //  

};

//  
class CQuestBase
{

public: // 

	//  
	_KERNEL void LoadQuestInfo( CQuestInfo* info );
	//    
	_KERNEL void InitQuests();
	//   
	_KERNEL void DeployQuest( CQuestInfo* quest, bool set = true, CQuestStatus* status = NULL );

	//   
	_KERNEL void DeployCommonQuest( CQuestInfo* quest );

	//   
	_KERNEL void LinkQuests();

	//   
	_KERNEL void LinkCharQuests( CCharPlayer* cp );

	//     -
	_KERNEL CQuestStatus* FindQuest( CCharPlayer* cp, CCharMob* questMob, bool req = true );
	//    
	_KERNEL CQuestInfo* FindQuest( int id );

	//  
	_KERNEL void AddFork( CQuestStatus* status );
	//  
	_KERNEL void RemoveFork( CQuestStatus* status, int num = -1, int instIdx = -1 );

	//   
	_KERNEL void ClearMobReference( CCharMob* mob );

	//    
	_KERNEL bool FindQuestRepop( CCharPlayer* cp, PArray<CQuestStatus*>& quests );

	//   
	_KERNEL void CheckQuestRepop( CCharPlayer* cp, bool noMsg = false );

public: // 

	PArray<CQuestStatus*> m_forks;            //   
	PArray<CQuestInfo*> m_quests;             // 
	PArray<CQuestStartDelay*> m_questDelays;  //  

};
