/*  

	Copyright (c) 2001 - 2004. All Rights Reserved.
	:  ..
*/
#pragma once
#include "DB/Subject/ObjPrototype.h"

// 
class CCommodity
{

public: // 

	CCommodity() {}

	CCommodity( CObjPrototype* prot, double price, double minPrice, int count ) :
		m_prot( prot ),
		m_price( price ),
		m_minPrice( minPrice ),
		m_count( count )
	{}

public: //   

	//   
	_KERNEL void Serialize( CFileStore& fs );

public: // 

	_KERNEL bool operator==( const CCommodity& o ) const { return m_prot == o.m_prot; }
	_KERNEL bool operator>=( const CCommodity& o ) const { return strcmp( m_prot->m_mask, o.m_prot->m_mask ) >= 0; }

public: // 

	CObjPrototype* m_prot; //  
	double m_price;        //  
	double m_minPrice;     //  
	int m_count;           //   

};

// 
class CShop
{

public: //   

	//  
	_KERNEL void InitNew();

	//   
	_KERNEL void Serialize( CFileStore& fs );

	//  
	_KERNEL void PerformPulse();

public: // 

	_KERNEL bool operator==( const CShop& s ) const { return strcmp( m_name, s.m_name ) == 0; }
	_KERNEL bool operator>=( const CShop& s ) const { return strcmp( m_name, s.m_name ) >= 0; }

public: // 

	int  m_id;                     // 
	char m_name[MAX_SHOP_NAME+1];  // 
	char m_mask[MAX_SHOP_NAME+1];  // 

	PSet<CCommodity> m_goods;          // 
	PArray<CMobPrototype*> m_sellers;  //  -

};
