/*  

	Copyright (c) 2001 - 2004. All Rights Reserved.
	:  ..
*/
#pragma once

// 
class CModifier
{

public: // 

	CModifier() {}

	CModifier( const char* name, byte uniqLev, PriceBonus pb, byte bonusComplex, ModifierCategory category = MC_OTHER );

public: // 

	//  
	_KERNEL static void InitTable( CModifier* modifiers[] );

public: // 

	//  
	_KERNEL virtual void Apply( PkFlag pkFlag, CChar* c, double value ) const = 0;

	//        
	_KERNEL virtual int UniqValueDice( int level ) const = 0;

	//   
	_KERNEL virtual short UniqPerc( int profID ) const = 0;

	//   
	_KERNEL short price( byte type ) { return m_price->price( type ); }

	//  
	_KERNEL virtual bool isAbilMod() { return false; }

	//  
	_KERNEL virtual int abilType() { return AT_NONE; }

	//  
	_KERNEL virtual int abilId() { return -1; }

public: // 

	int m_id;             //  
	byte m_type;          //  
	const char* m_name;   // 
	char* m_mask;         // 

	byte m_uniqLev;       //         
    byte m_bonusComplex;  //    

	CBonusParam* m_price; //  

};

//  
class CResistModifier : public CModifier
{

public: // 

	CResistModifier( const char* name, int idx, byte uniqLev, PriceBonus pb = PB_NONE );

public: // 

	//  
	//void Apply( PkFlag pkFlag, CChar* c, double value, double* max, bool fullPk = false, bool fullBonus = false ) const;
	void Apply( PkFlag pkFlag, CChar* c, double value ) const;

	//        
	int UniqValueDice( int level ) const;

	//   
	short UniqPerc( int profID ) const;

public: // 

	int m_idx; // 

};

//  
class CStrModifier : public CModifier
{

public: // 

	CStrModifier();

public: // 

	//  
	//void Apply( PkFlag pkFlag, CChar* c, double value, double* max, bool fullPk = false, bool fullBonus = false ) const;
	void Apply( PkFlag pkFlag, CChar* c, double value ) const;

	//        
	int UniqValueDice( int level ) const;

	//   
	short UniqPerc( int profID ) const;

};

//  
class CDexModifier : public CModifier
{

public: // 

	CDexModifier();

public: // 

	//  
	//void Apply( PkFlag pkFlag, CChar* c, double value, double* max, bool fullPk = false, bool fullBonus = false ) const;
	void Apply( PkFlag pkFlag, CChar* c, double value ) const;

	//        
	int UniqValueDice( int level ) const;

	//   
	short UniqPerc( int profID ) const;

};

//  
class CIntModifier : public CModifier
{

public: // 

	CIntModifier();

public: // 

	//  
	//void Apply( PkFlag pkFlag, CChar* c, double value, double* max, bool fullPk = false, bool fullBonus = false ) const;
	void Apply( PkFlag pkFlag, CChar* c, double value ) const;

	//        
	int UniqValueDice( int level ) const;

	//   
	short UniqPerc( int profID ) const;

};

//  
class CWizModifier : public CModifier
{

public: // 

	CWizModifier();

public: // 

	//  
	//void Apply( PkFlag pkFlag, CChar* c, double value, double* max, bool fullPk = false, bool fullBonus = false ) const;
	void Apply( PkFlag pkFlag, CChar* c, double value ) const;

	//        
	int UniqValueDice( int level ) const;

	//   
	short UniqPerc( int profID ) const;

};

//  
class CConModifier : public CModifier
{

public: // 

	CConModifier();

public: // 

	//  
	//void Apply( PkFlag pkFlag, CChar* c, double value, double* max, bool fullPk = false, bool fullBonus = false ) const;
	void Apply( PkFlag pkFlag, CChar* c, double value ) const;

	//        
	int UniqValueDice( int level ) const;

	//   
	short UniqPerc( int profID ) const;

};

//  
class CSizeModifier : public CModifier
{

public: // 

	CSizeModifier();

public: // 

	//  
	//void Apply( PkFlag pkFlag, CChar* c, double value, double* max, bool fullPk = false, bool fullBonus = false ) const;
	void Apply( PkFlag pkFlag, CChar* c, double value ) const;

	//        
	int UniqValueDice( int level ) const;

	//   
	short UniqPerc( int profID ) const;

};

//  HITROLL
class CHitrollModifier : public CModifier
{

public: // 

	CHitrollModifier();

public: // 

	//  
	//void Apply( PkFlag pkFlag, CChar* c, double value, double* max, bool fullPk = false, bool fullBonus = false ) const;
	void Apply( PkFlag pkFlag, CChar* c, double value ) const;

	//        
	int UniqValueDice( int level ) const;

	//   
	short UniqPerc( int profID ) const;

};

//  DAMROLL
class CDamrollModifier : public CModifier
{

public: // 

	CDamrollModifier();

public: // 

	//  
	//void Apply( PkFlag pkFlag, CChar* c, double value, double* max, bool fullPk = false, bool fullBonus = false ) const;
	void Apply( PkFlag pkFlag, CChar* c, double value ) const;

	//        
	int UniqValueDice( int level ) const;

	//   
	short UniqPerc( int profID ) const;

};

//  
class CHPModifier : public CModifier
{

public: // 

	CHPModifier();

public: // 

	//  
	//void Apply( PkFlag pkFlag, CChar* c, double value, double* max, bool fullPk = false, bool fullBonus = false ) const;
	void Apply( PkFlag pkFlag, CChar* c, double value ) const;

	//        
	int UniqValueDice( int level ) const;

	//   
	short UniqPerc( int profID ) const;

};

//  
class CManaModifier : public CModifier
{

public: // 

	CManaModifier();

public: // 

	//  
	//void Apply( PkFlag pkFlag, CChar* c, double value, double* max, bool fullPk = false, bool fullBonus = false ) const;
	void Apply( PkFlag pkFlag, CChar* c, double value ) const;

	//        
	int UniqValueDice( int level ) const;

	//   
	short UniqPerc( int profID ) const;

};

//  
class CMVModifier : public CModifier
{

public: // 

	CMVModifier();

public: // 

	//  
	//void Apply( PkFlag pkFlag, CChar* c, double value, double* max, bool fullPk = false, bool fullBonus = false ) const;
	void Apply( PkFlag pkFlag, CChar* c, double value ) const;

	//        
	int UniqValueDice( int level ) const;

	//   
	short UniqPerc( int profID ) const;

};

//  
class CHPRegModifier : public CModifier
{

public: // 

	CHPRegModifier();

public: // 

	//  
	//void Apply( PkFlag pkFlag, CChar* c, double value, double* max, bool fullPk = false, bool fullBonus = false ) const;
	void Apply( PkFlag pkFlag, CChar* c, double value ) const;

	//        
	int UniqValueDice( int level ) const;

	//   
	short UniqPerc( int profID ) const;

};

//  
class CManaRegModifier : public CModifier
{

public: // 

	CManaRegModifier();

public: // 

	//  
	//void Apply( PkFlag pkFlag, CChar* c, double value, double* max, bool fullPk = false, bool fullBonus = false ) const;
	void Apply( PkFlag pkFlag, CChar* c, double value ) const;

	//        
	int UniqValueDice( int level ) const;

	//   
	short UniqPerc( int profID ) const;

};

//  
class CMVRegModifier : public CModifier
{

public: // 

	CMVRegModifier();

public: // 

	//  
	//void Apply( PkFlag pkFlag, CChar* c, double value, double* max, bool fullPk = false, bool fullBonus = false ) const;
	void Apply( PkFlag pkFlag, CChar* c, double value ) const;

	//        
	int UniqValueDice( int level ) const;

	//   
	short UniqPerc( int profID ) const;

};

//   
class CWeaponModifier : public CModifier
{

public: // 

	CWeaponModifier( const char* name, int idx, PriceBonus pb = PB_NONE );

public: // 

	//  
	void Apply( PkFlag pkFlag, CChar* c, double value ) const;

	//        
	int UniqValueDice( int level ) const;

	//   
	short UniqPerc( int profID ) const;

	//  
	bool isAbilMod() { return true; }

	//  
	int abilType() { return AT_WEAPON; }

	//  
	int abilId() { return m_idx; }

public: // 

	int m_idx; // 

};

//  
class CSkillModifier : public CModifier
{

public: // 

	CSkillModifier( const char* name, int idx, PriceBonus pb = PB_NONE, bool enabled = true );

public: // 

	//  
	void Apply( PkFlag pkFlag, CChar* c, double value ) const;

	//        
	int UniqValueDice( int level ) const;

	//   
	short UniqPerc( int profID ) const;

	//  
	bool isAbilMod() { return true; }

	//  
	int abilType() { return AT_SKILL; }

	//  
	int abilId() { return m_idx; }

public: // 

	int m_idx; // 

	short m_percTable[UNIQ_MODE_NUM]; //  

};

//  
class CSpellModifier : public CModifier
{

public: // 

	CSpellModifier( const char* name, int idx, PriceBonus pb = PB_NONE, bool enabled = true );

public: // 

	//  
	void Apply( PkFlag pkFlag, CChar* c, double value ) const;

	//        
	int UniqValueDice( int level ) const;

	//   
	short UniqPerc( int profID ) const;

	//  
	bool isAbilMod() { return true; }

	//  
	int abilType() { return AT_SPELL; }

	//  
	int abilId() { return m_idx; }

public: // 

	int m_idx; // 

	short m_percTable[UNIQ_MODE_NUM]; //  

};
