/*    

	Copyright (c) 2015. All Rights Reserved.
	: 
*/
#pragma once

//    
class CObjExtDataNode
{

public: // 

    CObjExtDataNode( int id ) :
        m_id( id )
    {}

public: // 

    //  
    static CObjExtDataNode* CreateNode( int id );

    //  
    virtual bool IsEmpty() { return true; }

    // 
    virtual CString* desc() { return NULL; }
    virtual void setDesc( const char* desc ) {}

    //   
    virtual uint landLife() { return 0; }
    virtual void setLandLife( uint pulse ) {}

    //  
    virtual CSubject* contList() { return NULL; }
    virtual CSubject*& getContList();
    virtual void setContList( CSubject* obj ) {}

    //  
    virtual CCharPlayer* questOwner() { return NULL; }
    virtual void setQuestOwner( CCharPlayer* cp ) {}

    //  
    virtual CCharPlayer* owner() { return NULL; }
    virtual void setOwner( CCharPlayer* cp ) {}

    //  
    virtual uint ownerPulse() { return 0; }
    virtual void setOwnerPulse( uint pulse ) {}

    //  
    virtual bool groupOwner() { return false; }
    virtual void setGroupOwner( bool group ) {}

    //  
    virtual uint cooldownPulse() { return 0; }
    virtual void setCooldownPulse( uint pulse ) {}

    //   
    virtual CCharPlayer* ripReturnChar() { return NULL; }
    virtual void setRipReturnChar( CCharPlayer* cp ) {}

    //  
    virtual uint ripReturnPulse() { return 0; }
    virtual void setRipReturnPulse( uint pulse ) {}

    //  
    virtual CCharPlayer* personalOwner() { return NULL; }
    virtual void setPersonalOwner( CCharPlayer* cp ) {}

    //  
    virtual int specNumber() { return 0; }
    virtual void setSpecNumber( int nVal ) {}

    //  
    virtual void* customData() { return NULL; }
    virtual void setCustomData( void* pValue ) {}

    //  
    virtual int internalId() { return 0; }
    virtual void setInternalId( int nVal ) {}

public: // 

    int m_id;      // 

};

//   : 
class CDescObjExtDataNode : public CObjExtDataNode
{

public: //   

    CDescObjExtDataNode( const char* desc = NULL ) :
        CObjExtDataNode( OEDT_DESC ),
        m_desc( 0 )
    {
        setDesc( desc );
    }

    ~CDescObjExtDataNode()
    {
        if( m_desc )
            delete m_desc;
    }

public: // 

    //  
    bool IsEmpty() { return m_desc == NULL; }

    // 
    CString* desc() { return m_desc; }
    void setDesc( const char* desc );

public: // 

    CString* m_desc;       // 

};

//   :   
class CLandLifeObjExtDataNode : public CObjExtDataNode
{

public: // 

    CLandLifeObjExtDataNode( uint pulse = 0 ) :
        CObjExtDataNode( OEDT_LAND ),
        m_pulse( pulse )
    {}

public: // 

    //  
    bool IsEmpty() { return m_pulse == 0; }

    //   
    uint landLife() { return m_pulse; }
    void setLandLife( uint pulse ) { m_pulse = pulse; }

public: // 

    uint m_pulse;          //   

};

//   :  
class CContListObjExtDataNode : public CObjExtDataNode
{

public: // 

    CContListObjExtDataNode( CSubject* list = NULL ) :
        CObjExtDataNode( OEDT_CONT ),
        m_list( list )
    {}

public: // 

    //  
    bool IsEmpty() { return m_list == NULL; }

    //  
    CSubject* contList() { return m_list; }
    CSubject*& getContList() { return m_list; }
    void setContList( CSubject* obj ) { m_list = obj; }

public: // 

    CSubject* m_list;      //  

};

//   :  
class CQuestOwnerObjExtDataNode : public CObjExtDataNode
{

public: // 

    CQuestOwnerObjExtDataNode( CCharPlayer* c = NULL ) :
        CObjExtDataNode( OEDT_QUESTITEM ),
        m_char( c )
    {}

public: // 

    //  
    bool IsEmpty() { return m_char == NULL; }

    //  
    CCharPlayer* questOwner() { return m_char; }
    void setQuestOwner( CCharPlayer* cp ) { m_char = cp; }

public: // 

    CCharPlayer* m_char;   //  

};

//   :  
class COwnerObjExtDataNode : public CObjExtDataNode
{

public: // 

    COwnerObjExtDataNode( CCharPlayer* c = NULL, uint pulse = 0, bool group = false ) :
        CObjExtDataNode( OEDT_OWNER ),
        m_char( c ),
        m_pulse( pulse ),
        m_group( group )
    {}

public: // 

    //  
    bool IsEmpty() { return m_char == NULL && m_pulse == 0 && m_group == false; }

    //  
    CCharPlayer* owner() { return m_char; }
    void setOwner( CCharPlayer* cp ) { m_char = cp; }

    //  
    uint ownerPulse() { return m_pulse; }
    void setOwnerPulse( uint pulse ) { m_pulse = pulse; }

    //  
    bool groupOwner() { return m_group; }
    void setGroupOwner( bool group ) { m_group = group; }

public: // 

    CCharPlayer* m_char;   // 
    uint m_pulse;          //  
    bool m_group;          //  

};

//   :  
class CCooldownObjExtDataNode : public CObjExtDataNode
{

public: // 

    CCooldownObjExtDataNode( uint pulse = 0 ) :
        CObjExtDataNode( OEDT_COOLDOWN ),
        m_pulse( pulse )
    {}

public: // 

    //  
    bool IsEmpty() { return m_pulse == 0; }

    //  
    uint cooldownPulse() { return m_pulse; }
    void setCooldownPulse( uint pulse ) { m_pulse = pulse; }

public: // 

    uint m_pulse;          //  

};

//   :   
class CRipReturnObjExtDataNode : public CObjExtDataNode
{

public: // 

    CRipReturnObjExtDataNode( CCharPlayer* c = NULL, uint pulse = 0 ) :
        CObjExtDataNode( OEDT_RIPRETURN ),
        m_char( c ),
        m_pulse( pulse )
    {}

public: // 

    //  
    bool IsEmpty() { return m_char == NULL && m_pulse == 0; }

    //   
    CCharPlayer* ripReturnChar() { return m_char; }
    void setRipReturnChar( CCharPlayer* cp ) { m_char = cp; }

    //  
    uint ripReturnPulse() { return m_pulse; }
    void setRipReturnPulse( uint pulse ) { m_pulse = pulse; }

public: // 

    CCharPlayer* m_char;   //   
    uint m_pulse;          //  

};

//   :  
class CPersonalObjExtDataNode : public CObjExtDataNode
{

public: // 

    CPersonalObjExtDataNode( CCharPlayer* cp = NULL ) :
        CObjExtDataNode( OEDT_PERSONAL ),
        m_char( cp )
    {}

public: // 

    //  
    bool IsEmpty() { return m_char == NULL; }

    //  
    CCharPlayer* personalOwner() { return m_char; }
    void setPersonalOwner( CCharPlayer* cp ) { m_char = cp; }

public: // 

    CCharPlayer* m_char;   //  

};

//   :  
class CSpecNumberExtDataNode : public CObjExtDataNode
{

public: // 

    CSpecNumberExtDataNode( int nVal = 0 ) :
        CObjExtDataNode( OEDT_SPECNUMBER ),
        m_specNumber( nVal )
    {}

public: // 

    //  
    bool IsEmpty() { return m_specNumber == 0; }

    //  
    int specNumber() { return m_specNumber; }
    void setSpecNumber( int nVal ) { m_specNumber = nVal; }

public: // 

    int m_specNumber;   //  

};


//   :  
class CCustomDataExtDataNode : public CObjExtDataNode
{

public: // 

    CCustomDataExtDataNode( void* pValue = NULL ) :
        CObjExtDataNode( OEDT_CUSTOMDATA ),
        m_customData( pValue )
    {}

    ~CCustomDataExtDataNode()
    {
        if( m_customData == NULL )
            return;

        CSelfDeleting* pObj = (CSelfDeleting*)m_customData;
        pObj->Delete();
        m_customData = NULL;
    }

public: // 

    //  
    bool IsEmpty() { return m_customData == NULL; }

    //  
    void* customData() { return m_customData; }
    void setCustomData( void* pValue ) { m_customData = pValue; }

public: // 

    void* m_customData;   //  

};


//   :  
class CInternalIdExtDataNode : public CObjExtDataNode
{

public: // 

    CInternalIdExtDataNode( int nVal = 0 ) :
        CObjExtDataNode( OEDT_INTERNALID ),
        m_internalId( nVal )
    {}

public: // 

    //  
    bool IsEmpty() { return m_internalId == 0; }

    //  
    int internalId() { return m_internalId; }
    void setInternalId( int nVal ) { m_internalId = nVal; }

public: // 

    int m_internalId;   //  

};


//   
class CObjExtData
{

public: // 

    ~CObjExtData()
    {
        m_nodes.Delete();
    }

public: // 

    // 
    CString* desc();
    void setDesc( const char* desc );

    //   
    uint landLife();
    void setLandLife( uint pulse );

    //  
    CSubject* contList();
    CSubject*& getContList();
    void setContList( CSubject* obj );

    //  
    CCharPlayer* questOwner();
    void setQuestOwner( CCharPlayer* cp );

    //  
    void setOwnerData( CCharPlayer* cp, uint pulse, bool group );

    // 
    CCharPlayer* owner();
    void setOwner( CCharPlayer* cp );

    //  
    uint ownerPulse();
    void setOwnerPulse( uint pulse );

    //  
    bool groupOwner();
    void setGroupOwner( bool group );

    //  
    uint cooldownPulse();
    void setCooldownPulse( uint pulse );

    //   
    void setRipReturnData( CCharPlayer* cp, uint pulse );

    //   
    CCharPlayer* ripReturnChar();
    void setRipReturnChar( CCharPlayer* cp );

    //  
    uint ripReturnPulse();
    void setRipReturnPulse( uint pulse );

    //  
    CCharPlayer* personalOwner();
    void setPersonalOwner( CCharPlayer* cp );

    //  
    int specNumber();
    void setSpecNumber( int nVal );

    //  
    void* customData();
    void setCustomData( void* pValue );

    //  
    int internalId();
    void setInternalId( int id );

    //  
    CObjExtDataNode* FindNode( int id );

    //  
    CObjExtDataNode* GetNode( int id );

    //  
    bool IsEmpty();

public: // 

    PArray<CObjExtDataNode*> m_nodes; // 

};
