/*   

	Copyright (c) 2011. All Rights Reserved.
	: .
*/
#pragma once

#include "DB/Char/Clan.h"

class CStoreNode;
class CCharStoreNode;

//  
class CObjPlaceSubData
{

};

// : 
class CInvObjPlaceSubData : public CObjPlaceSubData
{

public: // 

	_KERNEL CInvObjPlaceSubData( CChar* ch );

	~CInvObjPlaceSubData() {}

public: // 

	CChar* m_char; //  

};

// : 
class CEquipObjPlaceSubData : public CObjPlaceSubData
{

public: // 

	_KERNEL CEquipObjPlaceSubData( CChar* ch, SlotID slot );

	~CEquipObjPlaceSubData() {}

public: // 

	CChar* m_char; //  
	byte m_slot;   //  

};

// : 
class CContObjPlaceSubData : public CObjPlaceSubData
{

public: // 

	_KERNEL CContObjPlaceSubData( CSubject* cont );

	~CContObjPlaceSubData() {}

public: // 

	CSubject* m_cont; // 

};

// : 
class CRoomObjPlaceSubData : public CObjPlaceSubData
{

public: // 

	_KERNEL CRoomObjPlaceSubData( CRoom* room );

	~CRoomObjPlaceSubData() {}

public: // 

	CRoom* m_room; // 

};

// :  
class CClanObjPlaceSubData : public CObjPlaceSubData
{

public: // 

	_KERNEL CClanObjPlaceSubData( CClan* clan, CStoreNode* node );

	~CClanObjPlaceSubData() {}

public: // 

	CClan* m_clan;      // 
	CStoreNode* m_node; //   

};

// : 
class CStoreObjPlaceSubData : public CObjPlaceSubData
{

public: // 

	_KERNEL CStoreObjPlaceSubData( CCharPlayer* ch, CCharStoreNode* node );

	~CStoreObjPlaceSubData() {}

public: // 

	CCharPlayer* m_char;    //  
	CCharStoreNode* m_node; //  

};

// : 
class CExchangeObjPlaceSubData : public CObjPlaceSubData
{

public: // 

	_KERNEL CExchangeObjPlaceSubData( COffer* offer );

	~CExchangeObjPlaceSubData() {}

public: // 

	COffer* m_offer; //  

};

// : 
class CAukObjPlaceSubData : public CObjPlaceSubData
{

public: // 

	_KERNEL CAukObjPlaceSubData( CAuctionOffer* offer );

	~CAukObjPlaceSubData() {}

public: // 

	CAuctionOffer* m_offer; //  

};

// : 
class CDTObjPlaceSubData : public CObjPlaceSubData
{

public: // 

	_KERNEL CDTObjPlaceSubData( CCharPlayer* ch );

	~CDTObjPlaceSubData() {}

public: // 

	CCharPlayer* m_char; //  

};

// :  
class CMailObjPlaceSubData : public CObjPlaceSubData
{

public: // 

	_KERNEL CMailObjPlaceSubData( CCharPlayer* ch );

	~CMailObjPlaceSubData() {}

public: // 

	CCharPlayer* m_char; //  

};

// : 
class CSpecialObjPlaceSubData : public CObjPlaceSubData
{

public: // 

	_KERNEL CSpecialObjPlaceSubData( void* data );

	~CSpecialObjPlaceSubData() {}

public: // 

	void* m_data; //  

};

//  
class CObjPlace
{

public: // 

	_KERNEL CObjPlace();

	~CObjPlace() {}

public: // 

	//  
	_KERNEL void clearPlace();

	//  
	_KERNEL void setPlace( ObjPlaceType type, CObjPlaceSubData* subData );

    //  
	_KERNEL void setPlace( ObjPlaceType type, void* pParam );

    //  
    _KERNEL const char* GetPlaceText() const;

    //  
    _KERNEL void LogPlace( uint logId ) const;

public: // 

	byte m_type;
	CObjPlaceSubData* m_subData;

};
