/*   

	Copyright (c) 2001 - 2004. All Rights Reserved.
	:  ..
*/
#pragma once

#include "DB/QuestBase.h"

//  
class CSubtypeData
{

public:

	//   
	_KERNEL virtual void Serialize( CFileStore& fs, int zoneID ) = 0;

	//  
	_KERNEL virtual void Link() {}

};

// 
class CType1Data : public CSubtypeData
{

public:

	//   
	_KERNEL void Serialize( CFileStore& fs, int zoneID );

	//  
	_KERNEL void Link();

public: // 

	byte m_containerCount;    //  
	byte m_waterCount;        //  

	CObjPrototype* m_key; // 
	CWater* m_water; // 

};

//   
class CObjAffectData
{

public: // 

	_KERNEL CObjAffectData( CAffect* affect = NULL, int grade = 0 ) :
		m_affect( affect ), m_grade( grade )
	{}

    _KERNEL ~CObjAffectData() {}

public: // CObject

	//   
	_KERNEL void Serialize( CFileStore& fs );

    // 
    _KERNEL bool Compare( int value, uint uType );

public: // 

	CAffect *m_affect; // 
	int m_grade;       //  ()

};

//   
class CObjModifierData
{

public: // 

	_KERNEL CObjModifierData( CModifier* mod = NULL, int value = 0 ) :
		m_modifier( mod ), m_value( value )
	{}

	~CObjModifierData() {}

public: // CObject

	//   
	_KERNEL void Serialize( CFileStore& fs );

    // 
    _KERNEL bool Compare( int value, uint uType );

public: // 

	CModifier* m_modifier; // 
	int m_value;           // 

};

//   
class CObjSkillData
{

public: // CObject

	//   
	_KERNEL void Serialize( CFileStore& fs, int zoneID );

public: // 

	byte m_skillID; //  
	byte m_value;   // 

};

//   
class CObjSpellData
{

public: // CObject

	//   
	_KERNEL void Serialize( CFileStore& fs, int zoneID );

public: // 

	byte m_spellID; //  
	byte m_value;   // 

};

// 
class CType2Data : public CSubtypeData
{

public:

	//   
	_KERNEL void Serialize( CFileStore& fs, int zoneID );

public: // 

	CObjSubType* m_subType;  // 

	CString m_slot;  // . 
	CString m_msg;   // 

	byte m_containerCount;    //  
	byte m_waterCount;        //  

};

// 
class CType3Data : public CSubtypeData
{

public:

	//   
	_KERNEL void Serialize( CFileStore& fs, int zoneID );

public: // 

	CWeaponSkill* m_weaponSkill; //  
	CDamageStr*   m_damStr;      //  
	CDamageType*  m_damType;     //  

	byte m_damDice[2];   //  
	byte m_weaponFlags;  //  

};

// 
class CType4Data : public CSubtypeData
{

public:

	//   
	_KERNEL void Serialize( CFileStore& fs, int zoneID );

public: // 

	CObjSpellData* m_spells;   // 
	int m_spellCount;

	byte m_count; //  

};

// 
class CType5Data : public CSubtypeData
{

public:

	//   
	_KERNEL void Serialize( CFileStore& fs, int zoneID );

public: // 

	CObjSpellData* m_spells;   // 
	int m_spellCount;

	byte m_count; //  

};

// 
class CType6Data : public CSubtypeData
{

public:

	//   
	_KERNEL void Serialize( CFileStore& fs, int zoneID );

public: // 

	//   
	_KERNEL const char* typeStr();

	//   
	_KERNEL const char* smallName();

public: // 

	byte m_type; //  
	union
	{
		CWeaponSkill* m_weapon; //  
		CSpell*       m_spell;  // 
		CSkill*       m_skill;  // 
	} m_item;

	int m_ancient;  //  

};

// 
class CType7Data : public CSubtypeData
{

public:

	//   
	_KERNEL void Serialize( CFileStore& fs, int zoneID );

public: // 

	CIngrColor* m_color;   // 
	byte m_power;          // 

};

// 
class CType8Data : public CSubtypeData
{

public:

	//   
	_KERNEL void Serialize( CFileStore& fs, int zoneID );

public: // 

	byte m_power;      // 

};

// 
class CType9Data : public CSubtypeData
{

public:

	//   
	_KERNEL void Serialize( CFileStore& fs, int zoneID );

public: // 

	bool m_oneTime; // 

};

// 
class CType10Data : public CSubtypeData
{

public:

	//   
	_KERNEL void Serialize( CFileStore& fs, int zoneID );

public: // 

	CWater* m_water; // 

};

// 
class CType11Data : public CSubtypeData
{

public:

	//   
	_KERNEL void Serialize( CFileStore& fs, int zoneID );

public: // 

};

// 
class CType12Data : public CSubtypeData
{

public:

	//   
	_KERNEL void Serialize( CFileStore& fs, int zoneID );

public: // 

	int m_boardID; //  

};

// 
class CType13Data : public CSubtypeData
{

public:

	//   
	_KERNEL void Serialize( CFileStore& fs, int zoneID );

	//  
	_KERNEL void Link();

};

// 
class CType14Data : public CSubtypeData
{

public:

	//   
	_KERNEL void Serialize( CFileStore& fs, int zoneID );

	//  
	_KERNEL void Link();

public: // 

	CRoomBaseData* m_room;  // -

};

// 
class CType15Data : public CSubtypeData
{

public:

	//   
	_KERNEL void Serialize( CFileStore& fs, int zoneID );

public: // 

	int m_money; // 

};

// 
class CType16Data : public CSubtypeData
{

public:

	//   
	_KERNEL void Serialize( CFileStore& fs, int zoneID );

public: // 

};

// 
class CType17Data : public CSubtypeData
{

public:

	//   
	_KERNEL void Serialize( CFileStore& fs, int zoneID );

public: // 

};

// 
class CType18Data : public CSubtypeData
{

public:

	//   
	_KERNEL void Serialize( CFileStore& fs, int zoneID );

public: // 

};

// 
class CType19Data : public CSubtypeData
{

public:

	//   
	_KERNEL void Serialize( CFileStore& fs, int zoneID );

public: // 

	short m_skill;   // 
	short m_power;   //  
	short m_maxUses; //  

};

// 
class CType20Data : public CSubtypeData
{

public:

	//   
	_KERNEL void Serialize( CFileStore& fs, int zoneID );

public: // 

	byte m_level;   //  
	bool m_player;  // /
	int  m_charID;  //  /

};

//  
class CObjRepopPlace
{

public: // 

	CObjRepopPlace( byte type, int id, byte perc = 0, byte slot = 0 ) :
		m_type( type ),
		m_source( id ),
		m_perc( perc ),
		m_slot( slot )
	{}

    //  
    _KERNEL const char* sourceName();

public: // 

	byte m_type; //  
	int m_source; // 
	byte m_slot; // 
	byte m_perc; // 

};

//  
class CObjPrototype
{

public: // 

	_KERNEL CObjPrototype();

public: //   

	//   
	_KERNEL void Serialize( CFileStore& fs, int zoneID );

	//  
	_KERNEL void Link();

public: // 

	//   
	_KERNEL CZoneInstance* baseInst() { return g_db.FindZone( ZoneId( m_id ) )->baseInst(); }

    //   
    _KERNEL void DeleteAffects();

	//  
	_KERNEL const char* subTypeMask();

	//  
	_KERNEL double getCount( bool lore = false );

	//   
	_KERNEL bool CheckObj( CSubject* obj );

	//    
	_KERNEL bool isInitLoad();

    //     
    _KERNEL bool isWeakenMove();

	//     
	_KERNEL bool inGame( CZoneInstance* zoneInst );

public: //   

	//   
	_KERNEL CShop* FindGlobalShop( int idx = 0 );

	//   
	_KERNEL CMobPrototype* FindLocalShop( int idx = 0 );

	//    
	_KERNEL CQuestInfo* FindQuestAward( int idx = 0 );

public: // 

	//   
	_KERNEL short GetAppraise( byte type );

	//  
	_KERNEL void CalcAppraise();

public: // 

	int m_id;           // 

	CString m_name[6];  //    
	CString m_mask;     // 
	CString m_text;     //  
	CString m_desc;     //  
	byte m_gender;      // 

	byte m_type;        //  

	CMaterial* m_material; // 
	int m_weight;          // 
	int m_hits;            //  

	byte m_maxFactor;    // -
	int m_timer;         // 

	byte m_objLevel;     //  

	// 
	byte m_minLevel;     //  
	byte m_maxLevel;     //  
	byte m_minStr;       // 
	byte m_minInt;       // 
	byte m_minWiz;       // 
	byte m_minDex;       // 
	byte m_minCon;       // 

	int m_alignFlags;    //  
	int m_profFlags;     //  
	int m_raceFlags;     //  

	int m_flags;        // 
	int m_lightTimer;   //  

	CObjAffectData* m_affects;     // 
	int m_affectCount;

	CObjModifierData* m_modifiers; // 
	int m_modifierCount;

	CSubtypeData* m_subData;  //  

	short* m_appraise;   //  

	int  m_inGame;       //      

	double m_price;      //     
	uint m_sellNum;      //  
	bool m_sellObj;      //  

	uint m_decayNum;     //    
	uint m_nodecayNum;   //    

	int m_handlerFlags;                         //  
	int (*m_handler)( CObjTriggerData* data );  // - 

	CTriggerHandler* m_trgs;  // 

	PArray<CQuestStatus*> m_questStats; //  

	PArray<CObjRepopPlace*> m_repopPlaces; //  

	PArray<CTimerObj*> m_objs; // 

};

