/*   

	Copyright (c) 2013. All Rights Reserved.
	: .
*/
#pragma once

#include "DB/Subject/ObjPrototype.h"

//  
class CObjTimeAffectData
{

public: // 

	CObjTimeAffectData( CAffect* affect = NULL, int grade = 0, uint pulse = 0, int mark = 0 ) :
		m_data( affect, grade ), m_pulse( pulse ), m_mark( mark )
	{}

	~CObjTimeAffectData() {}

public: // 

	//   
	_KERNEL void Serialize( CFileStore& fs );

public: // 

	CObjAffectData m_data; //  
	uint m_pulse;          // 
	int m_mark;            // 

};

//  
class CObjTimeModifierData
{

public: // 

	CObjTimeModifierData( CModifier* mod = NULL, int value = 0, uint pulse = 0, int mark = 0 ) :
		m_data( mod, value ), m_pulse( pulse ), m_mark( mark )
	{}

	~CObjTimeModifierData() {}

public: // 

	//   
	_KERNEL void Serialize( CFileStore& fs );

public: // 

	CObjModifierData m_data; //  
	uint m_pulse;            // 
	int m_mark;              // 

};

//  
class CObjVirtual
{

public: //   

	_KERNEL ~CObjVirtual();

public: // 

	//   
	_KERNEL void Serialize( CFileStore& fs );

    //  
    _KERNEL void AddAffect( int affId, int mark, int grade, uint pulses );

	//  
	_KERNEL CObjTimeModifierData* FindModifier( int id, int mark );

    //  
    _KERNEL void AddModifier( int modId, int mark, int value, uint pulses );

    //  
    _KERNEL void CheckAddModifier( int modId, int mark, int value, uint pulses, bool adding = true );

public: // 

	PArray<CObjTimeAffectData*> m_affects;     // 
	PArray<CObjTimeModifierData*> m_modifiers; // 

};
