/*   

	Copyright (c) 2012. All Rights Reserved.
	: 
*/
#pragma once

//     
_KERNEL int profToPriceType( int id );
//     
_KERNEL int priceTypeToProf( int type );
//    
_KERNEL const char* priceToColumn( int type );

//    
class CBonusParamNode
{

public: // 

	CBonusParamNode( PriceType id, short price ) :
		m_id( id ),
		m_price( price )
	{}

public: // 

	byte m_id;     // 
	short m_price; // 

};

//  
class CBonusParam
{

public: // 

	_KERNEL CBonusParam( short p0, short p1, short p2, short p3, short p4, short p5, short p6, short p7, short p8, short p9, short p10 );

public: // 

	//  
	_KERNEL short price( byte pt );

public: // 

	PArray<CBonusParamNode*> m_nodes;

};

//  
class CPriceBase
{

public: // 

	// 
	_KERNEL void Init();

	//   
	_KERNEL void PriceFormat( char* buffer, CObjPrototype* prot, CSubject* obj );

	//   
	_KERNEL int CalcWeaponPrice( int price, CObjPrototype* prot, int priceType );

	//    
	_KERNEL CAffect* FindAffect( int priceId );

	//    
	_KERNEL CModifier* FindModifier( int priceId );

public: // 

	CBonusParam* m_prices[PB_COUNT]; //  

};