/*  

	Copyright (c) 2001 - 2004. All Rights Reserved.
	:  ..
*/
#pragma once

#include "DB/Subject/ObjPrototype.h"
#include "DB/Subject/ObjUnique.h"
#include "DB/Subject/ObjSpecial.h"
#include "DB/Subject/ObjPlace.h"
#include "DB/Subject/ObjExtData.h"

//    
class CTimerObj
{

public: // 

	//  
	_KERNEL virtual double getCount( bool lore ) = 0;

public: // 

	byte m_timerObjType; //  

};

//  
class CDeletedObj : public CTimerObj
{

public: // 

	CDeletedObj( CSubject* obj = NULL );

	~CDeletedObj() {}

public: // 

	//   
	_KERNEL void Serialize( CFileStore& fs );

	//  
	_KERNEL double getCount( bool lore );

public: // 

	CObjPrototype* m_prot; // 
	int m_time;            //  
	int m_life;            //  

};


// 
class CSubject : public CTimerObj
{

protected: //  ,     

	CSubject( CObjPrototype* prot, CZoneInstance* zoneInst, CObjPopInRoomData* popData = NULL );

public: // 

	_KERNEL virtual ~CSubject();

public: //   

	//   
	_KERNEL virtual void InitNew( bool noUniq = false );

	//   
	_KERNEL virtual void Serialize( CFileStore& fs );

	//  
	_KERNEL virtual void Link();

public: // 

	//  
	_KERNEL double getCount( bool lore );

	//    
	_KERNEL void ClearReference();

	//   
	_KERNEL bool GenerateUnique( int level, int profID = 0, CCharPlayer* cp = NULL );

	//  
	_KERNEL bool GenerateRune();

    //     
    _KERNEL bool CanComplexSpecial();

    //    
    _KERNEL void GenerateComplexSpecial( byte lvl );

	//    
	_KERNEL void InitNewTimer();

    //    
    _KERNEL void ApplyObject( CChar* c, PkFlag pkFlag );

	//   
	_KERNEL void DeleteRuneSlot( ObjDeletePlace odp, void* target );

	//  
	bool CheckTimer( ObjDeletePlace odp, void* target );

	//  
	_KERNEL void LogDecey( CRoom* room, const char* reason );

    //  
    _KERNEL void LogObject( uint logId ) const;

	//   
	bool CheckInst( CZoneInstance* inst );

	//     
	bool needSave() const { return (m_life && !(m_prot->m_flags & OF_NO_RENT)) || (m_prot->m_id >= 10002 && m_prot->m_id <= 10005); }

	//   
	_KERNEL void setLife( uint pulse );

    //   
    _KERNEL bool rentLevel( byte& level ) const;

    //     
    _KERNEL uint unrentLife( bool forRune = false ) const;

	//    
	_KERNEL void Rent( int hotel );

	//    
	_KERNEL void UnRent( int hotel );

	//  !
	_KERNEL bool CheckNoRent( CCharPlayer* cp );

	//  !
	_KERNEL bool CheckNoReturn();

	//  
	_KERNEL virtual void Repop( bool withMob = false ) {}

	//  
	_KERNEL virtual void LoadObjs( bool repop = false, bool init = false ) {}

	//  
	_KERNEL CCharPlayer* owner() { return (objOwner() && ownerPulse() > g_db.m_pulse) ? objOwner() : NULL; }

	//   
	_KERNEL void SetOwner( CCharPlayer* cp, uint pulses = AGRO_TIME );

	//   
	_KERNEL void ClearOwner();

	//  
	_KERNEL bool CheckReturn( bool charOwner = true );

	//  
	_KERNEL void ClearReturn();

	//    
	void ClearCharReference( CCharPlayer* c );

	//    
	bool isInitLoad();

	//    
	_KERNEL void PutIntoContainer( CSubject* obj );

	//    
	_KERNEL void GetFromContainer( CSubject* obj );

    //   
    _KERNEL CSubject* GetTopmostCont() const;

    //  
    _KERNEL CRoom* GetObjectRoom();

	//    (  )
	_KERNEL void CheckTimers( CChar* owner = NULL );

	//   (    )
	_KERNEL void DeleteByTimer( ObjDeletePlace odp, void* target );

	//     
	_KERNEL void PlaceDeceyObject( CSubject* obj, ObjDeletePlace odp, void* target );

	//    
	_KERNEL void GetFromPlace();

	//  
	_KERNEL bool CanTrigger( int flag, void* param = NULL ) { return m_prot->m_trgs->CanTrigger( flag, this, param ); }

	//  
	_KERNEL int ProcessTrigger( CObjTriggerData* data ) { return m_prot->m_trgs->ProcessTrigger( data ); }

	//    
	const char* ConditionSubStr();

	//     
	const char* ConditionColorStr();

	//   
	_KERNEL short GetAppraise( byte type );

	//  
	_KERNEL void CalcAppraise();

	//  
	_KERNEL void TeleportTriggers( CChar* c, CRoom* fromRoom, CRoom* toRoom );

public: // -

	//  
	_KERNEL CObjPrototype* prot() const { return m_prot; }

	// Id 
	_KERNEL int id() const { return m_prot->m_id; }

	//   6 
	_KERNEL virtual const char* name( int i = 0, int num = 0 ) const;

	//   6    
	_KERNEL const char* nameI( CChar* c, int i = 0, int num = 0 );

	// 
	_KERNEL virtual const char* mask() { return m_runeSlot ? m_runeSlot->m_mask : m_prot->m_mask; }

	//  
	_KERNEL const char* subTypeMask() { return m_prot->subTypeMask(); }

	//  
	_KERNEL virtual const char* slot() { return ""; }

	//   
	_KERNEL virtual const char* msg() { return ""; }

	// 
	_KERNEL const char* text() { return m_prot->m_text; }

	// 
	_KERNEL const char* desc() { return newDesc() ? *newDesc() : m_prot->m_desc; }

	//    ( )
	_KERNEL const int timer() { return ( m_life > g_db.m_pulse ? (m_life - g_db.m_pulse) / 600 + 1 : 0 ); }
    //       
    _KERNEL uint unrentTimer( bool forRune = false ) const { return m_life > g_db.m_pulse ? unrentLife( forRune ) / 600 + 1 : 0; }

    //   
    _KERNEL bool abnormalTimer() const;

	// 
	_KERNEL Gender gender() { return (Gender)m_prot->m_gender; }

	//    
	_KERNEL Gender genderI( CChar* c );

	// 
	_KERNEL bool isUnique() const { return m_uniq != NULL; }

	// 
	_KERNEL bool isSpecial() const { return m_spec != NULL; }

    // 
    _KERNEL bool IsFlawer() const { return m_prot->m_id >= 20058 && m_prot->m_id <= 20097; }

	// 
	_KERNEL ObjType type() const { return (ObjType)m_prot->m_type; }

	// 
	_KERNEL int flags();

	//  
	_KERNEL virtual int profFlags() const { return m_uniq ? m_uniq->m_profFlags : m_prot->m_profFlags; }

	//  
	_KERNEL int raceFlags() const { return m_uniq ? m_uniq->m_raceFlags : m_prot->m_raceFlags; }

    //   
    _KERNEL bool IsStringEqual( CSubject* obj );

	//    
	_KERNEL virtual int minLevel() const { return ( m_runeSlot && m_runeSlot->m_level > m_prot->m_minLevel ) ? m_runeSlot->m_level : m_prot->m_minLevel; }

	//    
	_KERNEL int maxLevel() const { return m_prot->m_maxLevel; }

	//  
	_KERNEL bool noLocate() { return (flags() & OF_NO_LOCATE) != 0; }

	//  
	_KERNEL bool noDisarm() { return (flags() & OF_NO_DISARM) != 0; }

	//  
	_KERNEL bool noSteal() { return (flags() & OF_NO_STEAL) != 0; }

	// 
	_KERNEL int weight();

	//  
	_KERNEL int objWeight( bool look = false ) const;

	//  
	_KERNEL virtual int containerCount() const { return 0; }

	//   
	_KERNEL int inContainerCount() { return ListCount( contList() ); }

	// 
	_KERNEL virtual bool closed() const { return false; }
	_KERNEL virtual void setClosed( bool c ) {}

	// 
	_KERNEL virtual bool locked() const { return false; }
	_KERNEL virtual void setLocked( bool l ) {}

	//  
	_KERNEL virtual bool canLock() const { return false; }

	//  
	_KERNEL virtual CObjPrototype* keyProt() const { return NULL; }

	//  
	_KERNEL virtual int waterCount() const { return 0; }

	//  - 
	_KERNEL virtual int water() const { return 0; }
	_KERNEL virtual void setWater( int c ) {}

	//   
	_KERNEL virtual CWater* waterType() const { return NULL; }
	_KERNEL virtual void setWaterType( CWater* w ) {}

	// 
	_KERNEL virtual int foodPower() const { return 0; }

	//    
	_KERNEL virtual int throwAttackType() { return WTT_NONE; }

	//  
	_KERNEL virtual bool grinded() { return false; }

	//   
	_KERNEL int handlerFlags() { return m_prot->m_handlerFlags; }

	// - 
	_KERNEL int handler( CObjTriggerData* data ) { return m_prot->m_handler( data ); }

	//  
	_KERNEL CMaterial* material() const { return ( m_runeSlot && m_runeSlot->m_material ) ? m_runeSlot->m_material : m_prot->m_material; }

	//     
	_KERNEL int allHits() const;

	//    
    int hitPerc() { return ( m_prot->m_id != SOP_GUARD_CIRCLE && allHits() ) ? (m_hits*100/allHits()) : 100; }

    //  
    _KERNEL bool isBroken() const { return m_hits <= 0 && allHits() > 0; }

	//   
	_KERNEL bool hasAffect( CAffect* aff, int val );

	//   
	_KERNEL bool hasModifier( CModifier* mod, int val );

	//  
	_KERNEL CZoneInstance* zoneInst() { return m_zoneInst; }

	//  
	_KERNEL int instIdx() { return m_zoneInst ? m_zoneInst->m_idx : 0; }

	//   
	_KERNEL bool CheckId( int id, CZoneInstance* inst = NULL );

    //    
    void FindObject( int objId, CSubject*& obj );

    //   
    void GetExtData();

    //   
    void CheckExtData();

	//  
	_KERNEL CString* newDesc();
	_KERNEL void setNewDesc( const char* desc );

	//    
	_KERNEL uint landLife();
	_KERNEL void setLandLife( uint life );

	//  
	_KERNEL CSubject* contList();
	_KERNEL CSubject*& getContList();
	_KERNEL void setContList( CSubject* obj );

	//  -
	_KERNEL CCharPlayer* questOwner();
	_KERNEL void setQuestOwner( CCharPlayer* cp );

	// 
	_KERNEL CCharPlayer* objOwner();
	_KERNEL void setObjOwner( CCharPlayer* cp );

	//  
	_KERNEL uint ownerPulse();
	_KERNEL void setOwnerPulse( uint pulse );

	//  - 
	_KERNEL bool groupOwner();
	_KERNEL void setGroupOwner( bool group );

	//  
	_KERNEL uint cooldownPulse();
	_KERNEL void setCooldownPulse( uint pulse );

	//   
	_KERNEL CCharPlayer* ripReturnChar();
	_KERNEL void setRipReturnChar( CCharPlayer* cp );

	//  
	_KERNEL uint ripReturnPulse();
	_KERNEL void setRipReturnPulse( uint pulse );

    //  
    _KERNEL CCharPlayer* personalOwner();
    _KERNEL void setPersonalOwner( CCharPlayer* cp );

    //  
    _KERNEL int specNumber() const;
    _KERNEL void setSpecNumber( int nVal );

    //  
    _KERNEL void* customData();
    _KERNEL void setCustomData( void* pValue );

    //  
    _KERNEL int internalId() const;
    _KERNEL void setInternalId( int nVal );

public: // 

	CSubject* m_next;             //   

	CObjPrototype* m_prot;        //  
	CObjUnique* m_uniq;           //   
	CRuneSlot* m_runeSlot;        // 
    CObjSpecial* m_spec;          //  
	CObjPopInRoomData* m_popData; //     ,   NULL

    CObjExtData* m_extData;       //  

	short* m_appraise;     //  

	CString m_uniqChar;    //  

	uint m_life;           // ,      ()
	int m_light;           //  
	int m_hits;            //    

	PArray<CString*>* m_owners; //  

	CObjPlace m_place;     //  

	CZoneInstance* m_zoneInst; //  

    //    
    static char* m_names[3];

	//    
	friend class CDB;

};

// -
class CContainerSubject : public CSubject
{

protected: //  ,     

	CContainerSubject( CObjPrototype* prot, CZoneInstance* zoneInst, CObjPopInRoomData* popData = NULL ) :
		CSubject( prot, zoneInst, popData )
	{}

	~CContainerSubject() {}

public: //   

	//   
	_KERNEL void InitNew( bool noUniq = false );

	//   
	_KERNEL void Serialize( CFileStore& fs );

public: // 

	//  - 
	_KERNEL int water() const { return m_water; }
	_KERNEL void setWater( int c ) { m_water = c; }

	//   
	_KERNEL CWater* waterType() const { return m_waterType; }
	_KERNEL void setWaterType( CWater* w ) { m_waterType = w; }

public: // 

	int      m_water;      //  - 
	CWater*  m_waterType;  //   

};

// -
class CSimpleSubject : public CContainerSubject
{

protected: //  ,     

	CSimpleSubject( CObjPrototype* prot, CZoneInstance* zoneInst, CObjPopInRoomData* popData = NULL ) :
		CContainerSubject( prot, zoneInst, popData )
	{}

public: //   

	//   
	_KERNEL void InitNew( bool noUniq = false );

	//   
	_KERNEL void Serialize( CFileStore& fs );

	//  
	_KERNEL void Repop( bool withMob = false );

	//  
	_KERNEL void LoadObjs( bool repop = false, bool init = false );

public: // 

	//  
	_KERNEL int containerCount() const { return ( (CType1Data*)m_prot->m_subData )->m_containerCount; }

	//  
	_KERNEL int waterCount() const { return ( (CType1Data*)m_prot->m_subData )->m_waterCount; }

	// 
	_KERNEL bool closed() const { return m_closed; }
	_KERNEL void setClosed( bool c ) { m_closed = c; }

	// 
	_KERNEL bool locked() const { return m_locked; }
	_KERNEL void setLocked( bool l ) { m_locked = l; }

	//  
	_KERNEL bool canLock() const { return ( (CType1Data*)m_prot->m_subData )->m_key != NULL; }

	//  
	_KERNEL virtual CObjPrototype* keyProt() const { return ( (CType1Data*)m_prot->m_subData )->m_key; }

public: // 

	bool  m_closed;    //  
	bool  m_locked;    //  
	bool  m_unlocked;  //  

	//    
	friend class CDB;

};

// -
class CClothSubject : public CContainerSubject
{

protected: //  ,     

	CClothSubject( CObjPrototype* prot, CZoneInstance* zoneInst, CObjPopInRoomData* popData = NULL ) :
		CContainerSubject( prot, zoneInst, popData )
	{}

public: // 

	//  
	_KERNEL int containerCount() const { return ( (CType2Data*)m_prot->m_subData )->m_containerCount; }

	//  
	_KERNEL int waterCount() const { return ( (CType2Data*)m_prot->m_subData )->m_waterCount; }

	// 
	_KERNEL CObjSubType* subType() { return ( (CType2Data*)m_prot->m_subData )->m_subType; }

	//  
	_KERNEL const char* slot() { return ( (CType2Data*)m_prot->m_subData )->m_slot; }

	//   
	_KERNEL const char* msg() { return ( (CType2Data*)m_prot->m_subData )->m_msg; }

	//    
	friend class CDB;

};

// -
class CWeaponSubject : public CSubject
{

protected: //  ,     

	CWeaponSubject( CObjPrototype* prot, CZoneInstance* zoneInst, CObjPopInRoomData* popData = NULL ) :
		CSubject( prot, zoneInst, popData ),
		m_poison( 0 ), m_pkPoison( 0 ), m_poisonType( 0 ), m_grindDam( 0 ), m_grindHit( 0 ), m_grindPulse( 0 ),
		m_hitLegacy( 0 ), m_damLegacy( 0 )
	{}

public: // 

	//   
	_KERNEL void Serialize( CFileStore& fs );

	//  
	_KERNEL CWeaponSkill* weaponSkill() { return ( (CType3Data*)m_prot->m_subData )->m_weaponSkill; }

	//  
	_KERNEL CDamageStr* damStr() { return ( (CType3Data*)m_prot->m_subData )->m_damStr; }

	//  
	_KERNEL CDamageType* damType() { return ( (CType3Data*)m_prot->m_subData )->m_damType; }

	//  
	_KERNEL int damDice( int i ) { return ( (CType3Data*)m_prot->m_subData )->m_damDice[i]; }

	//  
	_KERNEL int ThrowDamageDice();

	//  
	_KERNEL int weaponFlags() { return ( (CType3Data*)m_prot->m_subData )->m_weaponFlags; }

	//   
	_KERNEL int canStun();

	//    
	_KERNEL int throwAttackType();

	//   
	_KERNEL bool CheckGrindTimer() { return m_grindPulse && m_grindPulse < g_db.m_pulse ? false : true; }

	//  
	_KERNEL bool grinded() { return m_grindPulse != 0; }

    // 
    _KERNEL void Grind( int power );

    // C
    _KERNEL void Ungrind( int power );

public: // 

	int m_poison;      //  
	int m_pkPoison;    // - 
	byte m_poisonType; //  

	// 
	byte m_grindDam;   // 
	byte m_grindHit;   // 
	uint m_grindPulse; //  

	//  
	byte m_hitLegacy;
	byte m_damLegacy;

	//    
	friend class CDB;

};

// -
class CFoodSubject : public CSubject
{

protected: //  ,     

	CFoodSubject( CObjPrototype* prot, CZoneInstance* zoneInst, CObjPopInRoomData* popData = NULL ) :
		CSubject( prot, zoneInst, popData )
	{}

public: // 

	// 
	_KERNEL int foodPower() const { return ( (CType8Data*)m_prot->m_subData )->m_power; }

	//    
	friend class CDB;

};

// -
class CScrollSubject : public CSubject
{

protected: //  ,     

	CScrollSubject( CObjPrototype* prot, CZoneInstance* zoneInst, CObjPopInRoomData* popData = NULL ) :
		CSubject( prot, zoneInst, popData )
		{ m_count = ((CType4Data*)prot->m_subData)->m_count; }

public: // 

	//   
	_KERNEL void Serialize( CFileStore& fs );

public: // 

	byte m_count; //  

	friend class CDB;

};

// -
class CPotionSubject : public CSubject
{

protected: //  ,     

	CPotionSubject( CObjPrototype* prot, CZoneInstance* zoneInst, CObjPopInRoomData* popData = NULL ) :
		CSubject( prot, zoneInst, popData )
		{ m_count = ((CType5Data*)prot->m_subData)->m_count; }

public: // 

	//   
	_KERNEL void Serialize( CFileStore& fs );

public: // 

	byte m_count; //  

	friend class CDB;

};

// -
class CSourceSubject : public CSubject
{

protected: //  ,     

	CSourceSubject( CObjPrototype* prot, CZoneInstance* zoneInst, CObjPopInRoomData* popData = NULL ) :
		CSubject( prot, zoneInst, popData )
	{}

public: // 

	//  - 
	_KERNEL int water() const { return INT_MAX; }

	//  
	_KERNEL int waterCount() const { return INT_MAX; }

	//   
	_KERNEL CWater* waterType() const  { return ( (CType10Data*)m_prot->m_subData )->m_water; }

	//    
	friend class CDB;

};

// -
class CLetterSubject : public CSubject
{

protected: //  ,     

	CLetterSubject( CObjPrototype* prot, CZoneInstance* zoneInst, CObjPopInRoomData* popData = NULL ) :
		CSubject( prot, zoneInst, popData )
	{}

public: //   

	//   
	_KERNEL void InitNew( bool noUniq = false );

	//   
	_KERNEL void Serialize( CFileStore& fs );

public: // 

	char m_author[CHAR_NAME_SIZE+1]; // 
	time_t m_time;    //  
	CString m_text;   // 

	//    
	friend class CDB;

};

// -
class CBoardSubject : public CSubject
{

protected: //  ,     

	CBoardSubject( CObjPrototype* prot, CZoneInstance* zoneInst, CObjPopInRoomData* popData = NULL ) :
		CSubject( prot, zoneInst, popData )
	{}

public: // 

	//  
	_KERNEL int boardID() { return ( (CType12Data*)m_prot->m_subData )->m_boardID; }

	//    
	friend class CDB;

};

// -
class CDoorSubject : public CSubject
{

protected: //  ,     

	CDoorSubject( CObjPrototype* prot, CZoneInstance* zoneInst, CObjPopInRoomData* popData = NULL ) :
		CSubject( prot, zoneInst, popData )
	{}

	//    
	friend class CDB;

};

// -  
class CHomeDoorSubject : public CDoorSubject
{

protected: //  ,     

	CHomeDoorSubject( CObjPrototype* prot, CZoneInstance* zoneInst ) :
		CDoorSubject( prot, zoneInst, NULL )
	{}

public: // 

	// 
	_KERNEL void InitNew( CCharPlayer* cp );

	//   6 
	_KERNEL const char* name( int i = 0, int num = 0 ) const { return m_name[i]; }

	// 
	_KERNEL const char* mask() { return m_mask; }

public: // 

	CString m_name[6];  //    
	CString m_mask;     // 

	//    
	friend class CDB;

};

// -
class CPortalSubject : public CSubject
{

protected: //  ,     

	CPortalSubject( CObjPrototype* prot, CZoneInstance* zoneInst, CObjPopInRoomData* popData = NULL );

public: // 

	// -
	_KERNEL CRoom* room() { return m_room; }
	//_KERNEL CRoom* room() { return ( (CType14Data*)m_prot->m_subData )->m_room; }

public: // 

	CRoom* m_room; // -

	//    
	friend class CDB;

};

// -
class CMoneySubject : public CSubject
{

protected: //  ,     

	CMoneySubject( CObjPrototype* prot, CZoneInstance* zoneInst, CObjPopInRoomData* popData = NULL  ) :
		CSubject( prot, zoneInst, popData )
	{}

public: // 

	//   
	_KERNEL void InitNew( bool noUniq = false );

	//   
	_KERNEL void Serialize( CFileStore& fs );

public: // 

	int m_money; //  

	//    
	friend class CDB;

};

// -
class CSymbolSubject : public CSubject
{

protected: //  ,     

	CSymbolSubject( CObjPrototype* prot, CZoneInstance* zoneInst, CObjPopInRoomData* popData = NULL ) :
		CSubject( prot, zoneInst, popData )
	{}

	~CSymbolSubject() {}

public: // 

	//   
	_KERNEL void InitNew( const CRuneInfo* rune, RuneNode node );

	//   
	_KERNEL void Serialize( CFileStore& fs );

	//  
	_KERNEL void UpdateSymbol();

	//   6 
	_KERNEL const char* name( int i = 0, int num = 0 ) const { return m_name[i]; }

	// 
	_KERNEL const char* mask() { return m_mask; }

    //   
    _KERNEL CRInfo* getRInfo();

public: // 

	const CRuneInfo* m_rune; // 
	byte m_node;             //  

	CString m_name[6];   //  
	CString m_mask;      //  

	CString m_runeLevel; //  
	CString m_runeInfo;  //  

	//    
	friend class CDB;

};

// -
class CRuneSubject : public CSubject
{

protected: //  ,     

	CRuneSubject( CObjPrototype* prot, CZoneInstance* zoneInst, CObjPopInRoomData* popData = NULL ) :
		CSubject( prot, zoneInst, popData )
	{}

	~CRuneSubject() {}

public: // 

	//   
	_KERNEL void InitNew( const CRuneInfo* rune, RuneNode node, uint life );

	//   
	_KERNEL void Serialize( CFileStore& fs );

	//  
	_KERNEL void UpdateRune();

	//   6 
	_KERNEL const char* name( int i = 0, int num = 0 ) const { return m_name[i]; }

	// 
	_KERNEL const char* mask() { return m_mask; }

    //   
    _KERNEL CRInfo* getRInfo();

public: // 

	const CRuneInfo* m_rune; // 
	byte m_node;             //  

	CString m_name[6];   //  
	CString m_mask;      //  

	CString m_runeLevel; //  

	//    
	friend class CDB;

};

// -
class CToolSubject : public CSubject
{

protected: //  ,     

	CToolSubject( CObjPrototype* prot, CZoneInstance* zoneInst, CObjPopInRoomData* popData = NULL  ) :
		CSubject( prot, zoneInst, popData )
	{}

public: // 

	//   
	_KERNEL void InitNew( bool noUniq = false );

	//   
	_KERNEL void Serialize( CFileStore& fs );

public: // 

	int m_uses; //  

	//    
	friend class CDB;

};

// -
class CCorpseSubject : public CSubject
{

protected: //  ,     

	CCorpseSubject( CObjPrototype* prot, CZoneInstance* zoneInst, CObjPopInRoomData* popData = NULL ) :
		CSubject( prot, zoneInst, popData )
	{}

public: // 

	//  
	_KERNEL int containerCount() const { return 100; }

	// 
	_KERNEL int level() { return ( (CType20Data*)m_prot->m_subData )->m_level; }

	// /
	_KERNEL bool player() { return ( (CType20Data*)m_prot->m_subData )->m_player; }

	//  /
	_KERNEL int charID() { return ( (CType20Data*)m_prot->m_subData )->m_charID; }

	//    
	friend class CDB;

};

//    
class LearnTry
{

public: // 

	LearnTry() {}

	LearnTry( CCharPlayer *player, int level ) :
		tChar( player ),
		tLevel( level )
	{}

	~LearnTry() {}

public: // 

	CCharPlayer *tChar; // 
	int tLevel;         // 

};

// -
class CBookSubject : public CSubject
{

protected: //  ,     

	CBookSubject( CObjPrototype* prot, CZoneInstance* zoneInst, CObjPopInRoomData* popData = NULL ) :
		CSubject( prot, zoneInst, popData )
	{}

public: // 

	// 
	~CBookSubject()
	{
		m_tries.Delete();
	}

	//   
	_KERNEL void InitNew( bool noUniq = false );

	//   
	_KERNEL void Serialize( CFileStore& fs );

	//  
	_KERNEL void Link();

	//  
	_KERNEL virtual BookType type() const { return (BookType)( (CType6Data*)m_prot->m_subData )->m_type; }

	//  
	_KERNEL virtual CWeaponSkill* weaponSkill() const { return ( (CType6Data*)m_prot->m_subData )->m_item.m_weapon; }

	// 
	_KERNEL virtual CSkill* skill() const { return ( (CType6Data*)m_prot->m_subData )->m_item.m_skill; }

	// 
	_KERNEL virtual CSpell* spell() const { return ( (CType6Data*)m_prot->m_subData )->m_item.m_spell; }

	//   
	_KERNEL virtual const char* typeStr() { return ( (CType6Data*)m_prot->m_subData )->typeStr(); }

	//   
	_KERNEL virtual const char* smallName() { return ( (CType6Data*)m_prot->m_subData )->smallName(); }

public: // 

	PArray<LearnTry*> m_tries;  //    

	//    
	friend class CDB;

};

//   
class COldBookSubject : public CBookSubject
{

protected: //  ,     

	COldBookSubject( CObjPrototype* prot, CZoneInstance* zoneInst, CObjPopInRoomData* popData = NULL ) :
		CBookSubject( prot, zoneInst, popData )
	{}

public: // 

	//   
	_KERNEL void InitNew( bool noUniq = false );

    //   
    _KERNEL void InitOldBook( COldBookItem* pBookItem, CProfession* pProf );

	//   
	_KERNEL void Serialize( CFileStore& fs );

	//  
	static _KERNEL void InitTable( PArray<COldBookItem*>& oldBooks );

public: // 

	//   
	_KERNEL int minLevel() const { return m_minLevel; }

	//  
	_KERNEL int profFlags() const { return m_profFlags; }

	//  
	_KERNEL BookType type() const { return (BookType)m_type; }

	//  
	_KERNEL CWeaponSkill* weaponSkill() const { return m_item.m_weapon; }

	// 
	_KERNEL CSkill* skill() const { return m_item.m_skill; }

	// 
	_KERNEL CSpell* spell() const { return m_item.m_spell; }

	//   
	_KERNEL const char* typeStr();

	//   
	_KERNEL const char* smallName();

    //    
    _KERNEL bool operator==( const COldBookItem& bookItem ) const;

public: // 

	byte m_minLevel;   // 
	int  m_profFlags;  //  

	byte m_type;   //  
	union
	{
		CWeaponSkill* m_weapon; //  
		CSpell*       m_spell;  // 
		CSkill*       m_skill;  // 
	} m_item;

	//    
	friend class CDB;

};

//    
class COldBookItem
{

public: // 

	byte m_minLevel; // 
	byte m_type;     //  
	int m_bookID;    //  
	double m_specK;  //  
	int m_hasProfs;  //   

};

// -
class CKeySubject : public CSubject
{

protected: //  ,     

	CKeySubject( CObjPrototype* prot, CZoneInstance* zoneInst, CObjPopInRoomData* popData = NULL ) :
		CSubject( prot, zoneInst, popData )
	{ m_binded = true; }

public: // 

	bool m_binded; //    

	//    
	friend class CDB;

};
