/*   

	Copyright (c) 2017. All Rights Reserved.
	:  ..
*/
#pragma once

//        
class CRareUniqDayInfo
{

public: // 

    CRareUniqDayInfo( CTime time = 0 ) :
        m_time( time ), m_nobot( 0 ), m_daily( 0 )
    {}

public: // 

    // 
    _KERNEL void Serialize( CFileStore& fs );

    // 
    bool Compare( void* pValue, uint uType )
    {
        switch( uType ) {
        case SCT_ID:
            return m_time == *(CTime*)pValue;
        default:
            break;
        };
        return false;
    }

public: // 

    CTime m_time; // 
    int m_nobot;  //   !
    int m_daily;  // 
};

//     
class CRareUniqAccInfo
{

public: // 

    CRareUniqAccInfo( int accId = 0 ) :
        m_accId( accId )
    {}

public: // 

    // 
    _KERNEL void Serialize( CFileStore& fs );

    // 
    bool Compare( int value, uint uType )
    {
        switch( uType ) {
        case SCT_ID:
            return m_accId == value;
        default:
            break;
        };
        return false;
    }

public: // 

    int m_accId;                        // 
    PArray<CRareUniqDayInfo*> m_days;   //   
    Array<int> m_nobots;                //   !
};

//     
class CRareUniqBase
{

public: // 

    // 
    _KERNEL void Serialize( CFileStore& fs );

    // / 
    _KERNEL bool ModifyAccount( int accId, bool isRemove = false );

    //     
    _KERNEL CRareUniqDayInfo* FindCurDay( int accId );

    //    
    _KERNEL void AddDaily( int accId );

    //     !
    _KERNEL void AddNobot( int accId, int taskId );

    //  
    _KERNEL void StartNewWeek();

public: // 

    CTime                       m_week; //  
    PArray<CRareUniqAccInfo*>   m_info; //  
};

//  
class CTempInfo
{

public: // 

    // 
    _KERNEL void Serialize( CFileStore& fs );

public: // 

    CRareUniqBase m_rareUniqs;  //    
};