/*    

	Copyright (c) 2009. All Rights Reserved.
	: .
*/
#pragma once

class CStable;
class CLoading;
class CTransportNet;
CRoom* CreateVehicleRoom( CStable* stable );

//  
enum TraceDir
{
	TD_FORWARD = 0,
	TD_BACKWARD
};

//  
enum TraceID
{
	TRACE_EG = 0, //  - 
	TRACE_GO,     //  - 
	TRACE_GF,     //  - 
	TRACE_FS,     //  - 
	TRACE_EA,     //  - 
	TRACE_AH,     //  - 
	TRACE_OH,     //  - 
	TRACE_VR,     //  - 
	TRACE_RL,     //  - 
	TRACE_VL,     //  - 
	TRACE_COUNT
};

//  
enum RouteID
{
	ROUTE_EG = 0, //  -
	ROUTE_GE,     //  - 
	ROUTE_GO,     //  -
	ROUTE_OG,     //  - 
	ROUTE_GF,     //  -
	ROUTE_FG,     //  - 
	ROUTE_FS,     //  -
	ROUTE_SF,     //  - 
	ROUTE_EA,     //  -
	ROUTE_AE,     //  - 
	ROUTE_AH,     //  -
	ROUTE_HA,     //  - 
	ROUTE_OH,     //  -
	ROUTE_HO,     //  - 
	ROUTE_VR,     //  -
	ROUTE_RV,     //  - 
	ROUTE_RL,     //  -
	ROUTE_LR,     //  - 
	ROUTE_VL,     //  -
	ROUTE_LV,     //  - 
	ROUTE_COUNT
};

//  
enum DriverID
{
	DRIVER_GLOOM = 0, // 
	DRIVER_FUNNY,     // 
	DRIVER_NEUTRAL,   // 
	DRIVER_SAILOR,    // 
	DRIVER_OFICIAL,   // 
	DRIVER_PILOT,     // 
	DRIVER_SKYRIDER,  //  
	DRIVER_CAPTAIN,   //  
	DRIVER_COUNT,
};

//  
enum VehicleID
{
	VEHICLE_ELEN,
	VEHICLE_ELENAIR,
	VEHICLE_GEO,
	VEHICLE_OGIS,
	VEHICLE_OGISAIR,
	VEHICLE_FELO,
	VEHICLE_STAD,
	VEHICLE_ARTUA,
	VEHICLE_ARTUAAIR,
	VEHICLE_SHIAR,
	VEHICLE_SHIARAIR,
	VEHICLE_ARGNAIR,
	VEHICLE_VIDRAIR,
	VEHICLE_GALENAIR,
	VEHICLE_COUNT
};

//  
enum DriveAct
{
	ACT_COLLECT, //  
	ACT_WAIT,    // 
};

// 
class CTrace
{

public: // 

	TraceID m_id;      // ID 
	int m_room1ID;     // ID  1
	int m_room2ID;     // ID  2
	CRoom* m_room1;    //  1
	CRoom* m_room2;    //  2
	int m_length;      //  
	const byte* m_way; //  

};

// 
class CRoute
{

public: // 

	RouteID m_id;         // ID
	const CTrace* m_trace; // 
	TraceDir m_dir;       // 

};

// 
class CTransportNode
{

public: // 

	CTransportNode( int price, const char* from, const char* to,
		RouteID route1 = ROUTE_COUNT, RouteID route2 = ROUTE_COUNT,
		RouteID route3 = ROUTE_COUNT, RouteID route4 = ROUTE_COUNT,
		RouteID route5 = ROUTE_COUNT, RouteID route6 = ROUTE_COUNT ) :
			m_price( price ),
			m_from( from ),
			m_to( to )
	{
		     if( route6 != ROUTE_COUNT ) m_routes.addsize( 6 );
		else if( route5 != ROUTE_COUNT ) m_routes.addsize( 5 );
		else if( route4 != ROUTE_COUNT ) m_routes.addsize( 4 );
		else if( route3 != ROUTE_COUNT ) m_routes.addsize( 3 );
		else if( route2 != ROUTE_COUNT ) m_routes.addsize( 2 );
		if( route1 != ROUTE_COUNT ) m_routes.add( route1 );
		if( route2 != ROUTE_COUNT ) m_routes.add( route2 );
		if( route3 != ROUTE_COUNT ) m_routes.add( route3 );
		if( route4 != ROUTE_COUNT ) m_routes.add( route4 );
		if( route5 != ROUTE_COUNT ) m_routes.add( route5 );
		if( route6 != ROUTE_COUNT ) m_routes.add( route6 );
	}

public: // 

	uint m_price;          // 
	CString m_from;        //  
	CString m_to;          //  
	PArray<int> m_routes;  //  

};

// 
class CVehicle
{

public: // 

	CVehicle( int id, int mobID );

public: // 

	int m_id;        // ID
	CCharMob* m_mob; // 
	CString m_start; //  
	CString m_out;   //  
	CString m_come;  //  
	CString m_move;  //  

	friend class CDB;
};

// -
class CDriver
{

public: // 

	CDriver()
	{}

	CDriver( DriverID id, int perc ) :
		m_id( id ),
		m_travelPerc( perc )
	{}

public: // 

	DriverID m_id; // ID
	PArray<char*> m_start;  //   
	PArray<char*> m_finish; //   
	PArray<char*> m_travel; //   
	int m_travelPerc;       //  

};

//  
class CStable
{

public: // 

	CStable( StableID id, int room, CDriver* driverType, int driverID, int vehicleID, bool vehicleType = true ) :
		m_id( id ),
		m_room( g_db.FindRoom( room ) ),
		m_driverType( driverType ),
		m_vehicle( NULL ),
		m_lag( 2 ),
		m_driverID( driverID ),
		m_vehicleID( vehicleID ),
		m_vehicleType( vehicleType ),
		m_exitID( 0 )
	{}

public: // 

	StableID m_id;         // ID
	CRoom* m_room;         // 

	int m_driverID;        // ID 
	CDriver* m_driverType; //  
	CCharMob* m_driver;    // 

	int m_vehicleID;       // ID 
	bool m_vehicleType;    //  
	CVehicle* m_vehicle;   // 

	int m_lag;             //  

	int m_exitID;          // ID 
	byte m_exitDir;        // 

	PArray<CTransportNode*> m_tickets; // 

	PArray<CLoading*> m_loadings; // 

};

//  
class CLoading
{

public: // 

	CLoading( CChar* owner, uint pulse, CTransportNode* node ) :
		m_owner( owner ),
		m_pulse( pulse ),
		m_act( ACT_COLLECT ),
		m_node( node )
	{
		m_chars.add( owner );
		if( owner->mentalChild() )
			m_chars.add( owner->mentalChild() );
	}

public: // 

	void AddPassenger( CChar* c );

public: // 

	uint m_pulse;           //   
	DriveAct m_act;         //  
	CTransportNode* m_node; // 
	CChar* m_owner;         // 
	PArray<CChar*> m_chars; // 

};

//  
class CDrivingGroup
{

public: // 

	CDrivingGroup( CLoading* load, CStable* stable );

public: // 

	void AddPassenger( CChar* c );

public: // 

	uint m_pulse;           //  
	CTransportNode* m_node; // 
	int m_routeNum;         //  
	int m_roomNum;          //  
	CRoom* m_curRoom;       //  
	CRoom* m_room;          //  
	CStable* m_stable;      // 
	CChar* m_owner;         //  
	bool m_talk;            //  

};

//  
class CTransportNet
{

public: // 

	CTransportNet();

public: // 

	// 
	_KERNEL void Init();

public: // 

	PArray<CDrivingGroup*> m_drivingGroups; // 
	CVehicle** m_vehicles;                  // 
	CDriver** m_drivers;                    // 
	CStable** m_stables;                    // 
	CZone* m_zone;                          //   

};
