/*  

	Copyright (c) 2001 - 2004. All Rights Reserved.
	:  ..
*/
#pragma once
#include "DB/Weather.h"

// 
class CWorld
{

public:

	//  
	_KERNEL static void InitTable( CWorld* worlds[] );

public: //   

	//  
	_KERNEL void Link();

	//  ,  
	_KERNEL void Link2();

	//   
	_KERNEL void Prepare();

	//  
	_KERNEL void PerformPulse();

	//  
	_KERNEL void Repop( bool init = false );

    // 
    _KERNEL void Weaken();

public: // 

	//  ( )
	_KERNEL char* name( int i = 0 ) const { return m_name[i]; }

public: //   

	//  
	_KERNEL int curYear();

	//  
	_KERNEL int curMonth();

	//   
	_KERNEL const char* curMonthName();

	//  
	_KERNEL int curDay();

	//  
	_KERNEL int curHour();

	//   
	_KERNEL DaysTime curDaysTime() { return daysTime( curHour() ); }

	//   
	_KERNEL YearsTime curYearsTime() { return yearsTime( curMonth() ); }

	//  
	_KERNEL virtual DaysTime daysTime( int hour ) = 0;

	//  
	_KERNEL virtual YearsTime yearsTime( int month ) = 0;

	//  
	_KERNEL void NatureMessage( const char* text );

	// 
	_KERNEL bool light() { return m_light; }

	//    
	_KERNEL virtual int spellMod( int power, MagicSphere ms, bool neg = false );

	//   
	_KERNEL virtual void UpdateLight() = 0;

public: //   

	//     
	_KERNEL CCharMob* FindMob( int id, int instIdx = 0 );

	//     
	_KERNEL CMobPrototype* FindMobPrototype( CMaskManager& mm );

	//     
	_KERNEL CObjPrototype* FindObjPrototype( CMaskManager& mm, bool full = false );

	//     
	_KERNEL CSubject* FindObject( int id );

	//     
	_KERNEL void ClearFromMobMemory( CCharPlayer* cp );

	//      
	_KERNEL void ClearCharReference( CCharPlayer* cp );

	//      
	_KERNEL void ClearInstReference( CZoneInstance* inst );

public: // 

	int m_id;        //  
	char* m_name[6]; // 

	// 
	int m_firstYear; //     
	int m_months;    //  
	int m_days;      //    
	int m_hours;     //    
	char** m_monthNames;  //  

	CWeather m_weather; // 

	bool m_light; //  

	PArray<CZone*> m_zones; //  

};
