/*   

	Copyright (c) 2018. All Rights Reserved.
	: .
*/
#pragma once

struct CRoomMoveInfo
{
    CRoomMoveInfo( CRoomBaseData* room = nullptr, byte exit = RE_NONE ) :
        m_room( room ), m_exit( exit )
    {}

    CRoomBaseData* m_room;
    byte m_exit;
};

struct CRoomPathInfo
{
    CRoomPathInfo( CRoomBaseData* room = nullptr ) :
        m_curRoom( room )
    {}

    CRoomPathInfo( CRoomPathInfo* pFromPath, byte exit );
    ~CRoomPathInfo();

    CRoomBaseData* m_curRoom;
    PArray<CRoomMoveInfo*> m_path;
};


struct CalcWalkPointRoom
{
    int m_roomId;
    const char* m_names[10];
};


class CSWRoomInfo
{

public:

    CSWRoomInfo( byte size ) :
        m_size( size )
    {
        m_dirs = new byte[size];
        ::memset( m_dirs, RE_COUNT, size );
    }

public:

    byte m_size;
    byte* m_dirs;
};


class CSWEndPointInfo
{

public:

    CSWEndPointInfo( CalcWalkPointRoom& initInfo, byte pointId, int zoneId, bool evade );

public:
    byte            m_id;   // 
    CRoomBaseData*  m_room; // 
    PArray<const char*>* m_names; // 
    bool            m_evade; //   
};


class CSWZoneInfo
{

public:

    CSWZoneInfo( int id ) :
        m_id( id )
    {}

    CSWEndPointInfo* FindPoint( char* mask, const char** pFoundName );

public:

    int m_id;           // 
    PArray<CSWEndPointInfo*> m_points; //  
    PArray<CRoomBaseData*> m_evadeRooms; //  
};


class CSpeedWalker
{

public:

    CSpeedWalker( CCharPlayer* cp, CSWEndPointInfo* point, const char* pPointName );

public:

    CCharPlayer*        m_char;         // 
    CRoomBaseData*      m_room;         // 
    int                 m_instIdx;      // 
    CSWEndPointInfo*    m_point;        //  
    const char*         m_pointName;    //   
};


class CSWBase
{

public:

    void Init();

    CSWZoneInfo* FindZone( int zoneId );
    void FindPath( CSWZoneInfo* pSWZoneInfo, CRoomBaseData* pFromRoom, CSWEndPointInfo* pPoint );
    void PerformPulse();

    void AddWalker( CCharPlayer* cp, CSWEndPointInfo* point, const char* pPointName );

    PArray<CSWZoneInfo*> m_zones;
    PArray<CSpeedWalker*> m_walkers;

};

