/*   
	Copyright (c) 2013. All Rights Reserved.
	: 
*/
#pragma once

//  
class CInstLib
{

public: // 

	CInstLib( HINSTANCE lib, const char* path ) :
		m_lib( lib ), m_path( path )
	{}

public: // 

	HINSTANCE m_lib; // 
	CString m_path;  //   

};

//  
class CInstanceTrigger
{

public: // 

	CInstanceTrigger( CTriggerHandler* handler, CTriggerEntry* entry ) :
		m_handler( handler ), m_entry( entry )
	{}

	~CInstanceTrigger() {}

public: // 

	CTriggerHandler* m_handler; //  
	CTriggerEntry* m_entry;     //  

};

//  
class CInstanceTriggers
{

public: // 

	PArray<CInstanceTrigger*> m_triggers; //  
	PArray<void (*)()> m_pulses;          //  

};

//  
class CZoneInstance
{

public: //   

	// 
	_KERNEL CZoneInstance();

	// 
	_KERNEL ~CZoneInstance();

public: // 

	// 
	_KERNEL void Link();

	//  
	_KERNEL void Prepare();

	//  
	_KERNEL void PerformPulse();

	//  
	_KERNEL void Repop( bool init = false );

	//   
	_KERNEL void ZoneMessage( const char* text, ... );

	//  
	_KERNEL void NatureMessage( const char* text );

	//     
	_KERNEL void ClearFromMobMemory( CCharPlayer* cp );

	//      
	_KERNEL void ClearCharReference( CCharPlayer* cp );

	//      
	_KERNEL void ClearInstReference( CZoneInstance* inst );

    _KERNEL void AddRoomCopy( int roomId, CRoom*& pNewRoom );

	//   
	_KERNEL void RemoveTracks( CCharMob* mob );

	//   
	_KERNEL bool CanDelete( bool manual = false );

	//    
	_KERNEL CRoom* FindRoom( int id );

	//    
	_KERNEL CCharMob* FindMob( int id );

	//    
	_KERNEL CSubject* FindObject( int id );

	//  
	_KERNEL void CreateUser( CCharPlayer* cp );

	//  
	_KERNEL void AddUser( CCharPlayer* cp );

	//   
	_KERNEL void BaseUser( CCharPlayer* cp );

	//  
	_KERNEL CZoneUser* GetOwner();

	//   
	_KERNEL void CreateInstLibs();

	//   
	_KERNEL void LoadMobFactories();

	//  
	_KERNEL void LoadTriggers();

	//   
	_KERNEL void DeleteInstLibs();

	//     
	_KERNEL void CheckNoBot( PArray<CCharPlayer*>* chars );

	//    
	_KERNEL void ClearNoBot();

    //  !
    _KERNEL BOOL CheckNoBotRankNew();

public: // 

	CZone* m_zone;                     // 
	int m_idx;                         //  
	uint m_pulse;                      //  
	bool m_checkDelete;                //  
	int m_noBot;                       //     
    byte m_complex;                    //  

	PArray<CRoom*> m_rooms;            // 
	
	PArray<CInstLib*> m_libs;          // 
	CInstanceTriggers m_triggers;      //  

    CComplexMobPrototype** m_complexProts; //   

    static BOOL m_curNoBot;

};
