/*     
	Copyright (c) 2013. All Rights Reserved.
	: 
*/
#pragma once
#include "World/SpeedWalk.h"

class CRoomBaseData;

//    
class CObjPopInContBaseData
{

public: // 

	//   
	_KERNEL void Serialize( CFileStore& fs, int zoneID );

	//  
	_KERNEL void Link();

public: // 

	CObjPrototype* m_objProt; //  
	byte m_percent;           //  

};

//    
class CObjPopInRoomBaseData
{

public: //   

	_KERNEL CObjPopInRoomBaseData() :
		m_room( NULL ), m_objProt( NULL ), m_objs( NULL )/*, m_dailyTasks( NULL )*/
	{}
	_KERNEL ~CObjPopInRoomBaseData();

public: // 

	//   
	_KERNEL void Serialize( CFileStore& fs, int zoneID );

	//  
	_KERNEL void Link();

public: // 

	CRoomBaseData* m_room;          // 

	CObjPrototype* m_objProt;       //  
	CObjPopInContBaseData** m_objs; //     

	//PArray<CDailyTaskInfoNode*>* m_dailyTasks; //  

};

//   
class CDoorLinkLoadData
{

public: // 

	int m_roomId; // 
	byte m_exit;  // 

};

//    
class CObjPopOnMobBaseData
{

public: // 

	//   
	_KERNEL void Serialize( CFileStore& fs, int zoneID );

	//  
	_KERNEL void Link();

public: // 

	CObjPrototype* m_objProt; //  
	byte m_slot;              // 
	byte m_percent;           //  

};

//    
class CMobPopBaseData
{

public: //   

	_KERNEL CMobPopBaseData() :
		m_mobProt( NULL ),
        m_time( 0 ),
        m_objs( NULL ),
        m_doorLinks( NULL ),
		m_objLinks( NULL ),
        m_objLinkCount( 0 ),
        m_roomData( NULL ),
        m_weakened( false ),
        m_noWeaken( false ),
        m_weakenPriority( 0 ),
        m_weakenNoMoveLoad( false ),
        m_weakenLoadTargetMob( NULL )
	{};
	_KERNEL ~CMobPopBaseData();

public: // 

	//   
	_KERNEL void Serialize( CFileStore& fs, int zoneID );

	//  
	_KERNEL void Link();

	//    
	_KERNEL void Link2();

	//  
	//_KERNEL void CreateInstance( CMobPopData* popData, int instIdx );

public: // 

	CRoomBaseData* m_roomData;          //  

	CMobPrototype* m_mobProt;           //  
	byte m_time;                        //     
    bool m_noMultiply;                  // 

    bool m_weakened;                    //    
    bool m_noWeaken;                    //    
    int m_weakenPriority;               //    
    bool m_weakenNoMoveLoad;            //     
    Pair<ushort,byte>* m_weakenLoadTargetMob; //    

	CObjPopOnMobBaseData** m_objs;      //     
	CDoorLinkBaseData* m_doorLinks;     //   

	CObjPopInRoomBaseData** m_objLinks; //   
	int m_objLinkCount;                 //  

	//PArray<CDailyTaskInfoNode*>* m_dailyTasks; //  

};

//  
class CDescAddon
{

public: //   

	//   
	_KERNEL void Serialize( CFileStore& fs );

public: // 

	CString m_mask;   // 
	CString m_desc;   // 

};

//    
class CExitBaseAddData
{

public: // 

	CExitBaseAddData() :
		m_flags( 0 ), m_doorObj( NULL ), m_keyProt( NULL )
	{}

public: // 

	int m_flags;               // 
	CDoorSubject* m_doorObj;   // 
	CObjPrototype* m_keyProt;  // 
	PArray<int> m_walkers;     //  

};

//   
class CExitBaseData
{

public: // 

	CExitBaseData() :
		m_room( NULL ), m_add( NULL )
	{}

public: // 

	//   
	_KERNEL void Serialize( CFileStore& fs, int zoneID );

	//  
	_KERNEL void Link( CRoomBaseData* room );

	//  ,  
	_KERNEL void Link2();

	//   
	_KERNEL void CreateInstance( CRoom* room, int dir );

public: //   

	// 
	_KERNEL int flags() { return m_add ? m_add->m_flags : EXIT_STANDARD_FLAGS; }

	//  
	_KERNEL CDoorSubject* doorObj() { return m_add ? m_add->m_doorObj : NULL; }

	//  
	_KERNEL CObjPrototype* keyProt() { return m_add ? m_add->m_keyProt : NULL; }

	//  
	_KERNEL PArray<int>* walkers() { return m_add ? &m_add->m_walkers : NULL; }

public: // 

	CRoomBaseData* m_room;     // 
	CExitBaseAddData* m_add;   //  

};

//    
class CPointListNodeLoadData
{

public: // 

	_KERNEL CPointListNodeLoadData( int fractionId = 0, int squadId = 0 ) :
		m_fractionId( fractionId ), m_squadId( squadId )
	{}

public: // 

	// 
	_KERNEL void Serialize( CFileStore& fs );

public: // 

	int m_fractionId; // 
	int m_squadId;    // 

};

//   
class CPointModeLoadData
{

public: // 

	// 
	_KERNEL void Serialize( CFileStore& fs );

	//  
	_KERNEL bool CheckChar( CPointListNodeLoadData* node, PArray<int>* numbers );

public: // 

	int m_type;                             //  
	int m_fraction;                         // 
	PArray<CPointListNodeLoadData*> m_list; // 

};

//    
class CTrnRoomLoadData
{

public: // 

	_KERNEL CTrnRoomLoadData();

public: // 

	// 
	_KERNEL void Serialize( CFileStore& fs );

	//     
	_KERNEL bool CheckCharGather( CPointListNodeLoadData* node, PArray<int>* numbers );

	//     
	_KERNEL bool CheckCharEnter( CPointListNodeLoadData* node, PArray<int>* numbers );

public: // 

	bool m_beginFlag;                 //  

	bool m_gatherFlag;                //  
	bool m_noEnterPortal;             //    
	bool m_noExitPortal;              //    
	CPointModeLoadData* m_gatherMode; //   

	bool m_enterFlag;                 //  
	CPointModeLoadData* m_enterMode;  //   

};

//   
class CRoomBaseAddData
{

public: // 

	CRoomBaseAddData() :
		m_guilds( 0 ), m_hotel( 0 ), m_descAddons( NULL ), m_trnRoom( 0 )
	{}

public: // 

	int m_guilds;                // 
	byte m_hotel;                //  

	CDescAddon** m_descAddons;   //  

	PArray<int> m_walkers;       //  

	CTrnRoomLoadData* m_trnRoom; //   

};

//   
class CRoomBaseData
{

public: //   

	_KERNEL CRoomBaseData();
	_KERNEL CRoomBaseData( const CRoomBaseData& other );
	_KERNEL ~CRoomBaseData();

public: // 

	//   
	_KERNEL void Serialize( CFileStore& fs, int zoneID );

	//  
	_KERNEL void Link();

	//  ,  
	_KERNEL void Link2();

	//   
	_KERNEL CRoom* CreateInstance( CZoneInstance* inst );

	//   
	_KERNEL CRoom* inst( int idx );

    // 
    _KERNEL void Weaken();

    //  
    _KERNEL void WeakenMoveLoad( PArray<CMobPopBaseData*>* arrExcludedMobs, PArray<CMobPopBaseData*>* arrRemainedMobs, int idx );

public: //   

	//   
	_KERNEL CRoom* baseInst() { return m_insts[0]; }

	// 
	_KERNEL int guilds() { return m_add ? m_add->m_guilds : 0; }

	// 
	_KERNEL byte hotel() { return m_add ? m_add->m_hotel : 0; }

	//  
	_KERNEL CDescAddon** descAddons() { return m_add ? m_add->m_descAddons : NULL; }

	//  
	_KERNEL PArray<int>* walkers() { return m_add ? &m_add->m_walkers : NULL; }

	//  
	_KERNEL CTrnRoomLoadData* trnRoom() { return m_add ? m_add->m_trnRoom : NULL; }

public: // 

	int     m_id;                           // 
	CString m_title;                            // 
	CString m_desc;                              // 

	CZone* m_zone;                                   // 

	CRoomBaseAddData* m_add;        //  

	CExitBaseData m_exits[6];                      // 
	int m_flags;                                    // 
	byte m_landType;                        //  

	/*
	int m_mapX;                              //  X
	int m_mapY;                              //  Y
	int m_mapZ;                              //  Z
	int m_mapId;                    //  
	*/

	CMobPopBaseData* m_mobPopDatas; //    
	int m_mobPopDataCount;

	CObjPopInRoomBaseData* m_objPopDatas; //    
	int m_objPopDataCount;

	CTriggerHandler* m_trgs;                     // 

	PArray<CQuestStatus*> m_questStats; //  

	PArray<CRoom*> m_insts;        //    

    bool m_noWeaken;              //   
    byte m_weakenMobNum;     //    

    CSWRoomInfo* m_swData;  //   

};
