/*   

	Copyright (c) 2001 - 2004. All Rights Reserved.
	:  ..
*/
#pragma once

//   
class CCommandInfo
{

public: //  

	bool operator==( const CCommandInfo& ci ) const { return strcmp( m_name, ci.m_name ) == 0; }
	bool operator!=( const CCommandInfo& ci ) const { return strcmp( m_name, ci.m_name ) != 0; }
	bool operator>=( const CCommandInfo& ci ) const;
	bool operator<=( const CCommandInfo& ci ) const;
	bool operator> ( const CCommandInfo& ci ) const;
	bool operator< ( const CCommandInfo& ci ) const;

public: // 

	const char* m_name; // 
	bool m_noLag;       //    
	byte m_minPos;      //  
	bool m_fighting;    //     
	bool m_meditation;  //     
	bool m_hide;        //    

	// -
	void	(CChar::*m_handler) ( const char* args );

	int m_id;            //   ()
	int m_len;           //  
	int m_handlerID;     //  

};

//  
class CSocialForm
{

public: // 

	char* m_text;  //  
	//int m_form1;   //   
	//int m_form2;   //   

};

//   
class CSocialInfo
{

public: // 

	CSocialInfo( const char* name ) : m_name( name ) {}

public: // 

	// 
	void InitNew() { /*::memset( m_forms, 0, sizeof(m_forms) );*/ }

public: // 

	bool operator==( const CSocialInfo& si ) const { return strcmp( m_name, si.m_name ) == 0; }
	bool operator>=( const CSocialInfo& si ) const { return strcmp( m_name, si.m_name ) >= 0; }

public: // 

	const char* m_name;       // 
	//CSocialForm m_forms[20];  // 
	//CSocialForm m_forms[8];  // 
	CString m_forms[8];  // 

};

//  
class CCommandManager
{

public: // 

	// 
	_KERNEL void Init();

	//  
	_KERNEL void LoadSocials();

	//     
	_KERNEL CCommandInfo* FindCommand( const char* text );

	//     
	_KERNEL CSocialInfo* FindSocial( const char* text );

	//  
	_KERNEL static int ParseCommand( const char* text, char* cmd );

public: // 

	Set<CCommandInfo> m_commands[3]; //    
	SPSet<CSocialInfo*> m_socials;   // 

	Array<CCommandInfo*> m_allCommands; //   
	Array<CCommandInfo*> m_handlers;    // - 

};
