/*  

	Copyright (c) 2001 - 2004. All Rights Reserved.
	:  ..
*/
#pragma once
#include "zlib/zlib.h"
#include "Tools/Socket.h"
#include "System/CmdQuery.h"
#include "DB/Account.h"

//    (4)
const int EDITOR_BUFSIZE = 1024*4;

// 
enum CharSet
{
	CS_NONE = 0,   //  
	CS_ZMUD,       // Windows zMUD
	CS_JMC,        // Windows JMC, Telnet
	CS_JMC_SINGLE, // Windows JMC (#IAC send single)
	CS_KOI8        // KOI-8
};

//  
enum ConnMode
{
	MODE_SIMPLE,       //   
	MODE_PAGES,        //    

	MODE_CHARSET,      //  
	MODE_ACCOUNT,      //    (1.  2. )

	MODE_NEWACCOUNT,   //   
	MODE_ACCOUNTMENU,  //   
	MODE_CHANGEPASS,   //  
	// MODE_DELACCOUNT,   //  

	MODE_NEWCHARACTER, //   
	MODE_DELCHARACTER, //  
	MODE_SELCHARACTER, //    

	MODE_EDITOR,       //  

	MODE_SELECTPLAYER, //    
	MODE_PLAYER,       //  
	MODE_CHOOSEINCARNATE //  
};

/*
//   
class CExchangeFilter
{

public: // 

	CExchangeFilter()
		{ ::memset( this, 0, sizeof(*this) ); }

public: // 

	//   
	_KERNEL void Reset();

	//   
	_KERNEL void AddNameMask( const char* args );

	//   
	_KERNEL void AddTypeMask( const char* args );

	//  
	_KERNEL bool Accept( COffer* offer, CConnection* conn );

public: // 

	byte m_type;              //  

	int m_idx;                //   

	bool m_byName;            //   
	char* m_nameMask;         //  
	CMaskManager m_nameMM;    //  

	bool m_byType[2];         //   
	char* m_typeMask[2];      //  
	CMaskManager m_typeMM[2]; //  

	/*
	bool m_byType1;                   //   
	char* m_exchangeType1Mask;        //  
	CMaskManager m_exchangeType1MM;   //  

	bool m_byType2;                   //   
	char* m_exchangeType2Mask;        //  
	CMaskManager m_exchangeType2MM;   //  
	*/

	/*
	int m_hours;              //   

	int m_appraise;           //   

	PriceType m_priceType;    //  
	bool m_byRestrict;        //   
	CCharRestrict m_restrict; //   

};
*/

// 
class CConnection
{

public: //   

	CConnection( CSocket* s );
	~CConnection();

public: // 

	//    
	void AddCommand( const char* text );

	//  
	bool ProcessInput();

	//     ,   
	void ProcessStatus();

	//  
	void ProcessOutput();

	//     
	void Write( const char* text );

	//      ()
	void WriteFormat( const char* text, ... );

	//     
	void WriteWithPages( char* text, bool autoDelete, bool color = true );

	//    
	//void WriteOffersList( ObjType type, const char* nameMask, const char* type1Mask, const char* type2Mask, int appraise, int hours, CCharRestrict* restr );
	void WriteOffersList();

	//    
	void SendCompressOffer( int version );

	//  
	void ExecuteCommand( char* text );

	//  
	bool SelectProcessor( const char* text );

	//  
	bool ChannelProcessor( const char* text );

	//   
	void ShowNextPage();

	//  
	void SetMode( ConnMode mode, int step = 0 ) { m_mode = mode; m_step = step; }
	void NextStep() { m_step++; }
	void PrevStep() { m_step--; }

	//  
	bool CanAccess( int mask );

	//    
	bool CanLogin();

	//   
	void ProcessLogin();

	// 
	void Editor( const char* srcText, const char* args, void (CCharPlayer::*complite) ( const char* text, const char* args ) );

public: //  

	//     
	bool HasInput() { return m_hasInput; }

	//     
	bool HasOutput() { return m_outputCount != 0; }

	//   IP
	IpAddr ip() { return m_ip; }

public: //  

	//   
	void CharSetMenu();

	//  
	void MainMenu();

	//  : /
	int YesNoParser( const char* text );

	//   
	void EnterIntoGame();

	//   
	void ShowStatus();

public:

	CConnection* m_next;  //   

	CSocket* m_socket; // 
	IpAddr m_ip;       // IP
	bool m_close;      //   
	bool m_closeNoLog; //     

	z_stream* m_zStream;  //  
	bool m_mccpNegotiations; //   MCCP

	char m_input[SOCK_RCV_BUFSIZE];  //  
	int m_inputCount;                //    
	CCmdQuery m_inQuery;             //  
	CCmdQuery m_inQueryNoLag;        //    
	bool m_hasInput;                 //     
	uint m_lastCmdPulse;             //   

	char m_output[SOCK_SND_BUFSIZE]; //  
	int m_outputCount;               //    
	bool m_forseStatus;              //   
	bool m_overflow;                 //   .

	//  
	byte m_pagesType;          //   
	bool m_pagesColor;         //     

	// CPT_TEXT
	char* m_pageOutput;        //    
	char* m_currentPage;       //  
	bool m_deletePageOutput;   //    

	//CExchangeFilter m_exchangeFilter; //  

	CObjFilter* m_exchangeFilter; //  

	// CPT_OFFERS & CPT_DEMANDS
	/*
	byte m_exchangeType;        //  

	int m_exchangeIdx;          //   

	bool m_byName;                 //   
	char* m_exchangeNameMask;      //  
	CMaskManager m_exchangeNameMM; //  

	bool m_byType1;                 //   
	char* m_exchangeType1Mask;      //  
	CMaskManager m_exchangeType1MM; //  

	bool m_byType2;                 //   
	char* m_exchangeType2Mask;      //  
	CMaskManager m_exchangeType2MM; //  

	int m_exchangeHours;           //   

	int m_exchangeAppraise;        //   

	bool m_byRestrict;                //   
	CCharRestrict m_exchangeRestrict; //   
	*/

	// 
	char* m_editBuf;          //   
	char* m_editArgs;         //  

	//   
	void (CCharPlayer::*m_compliteEdit)( const char* text, const char* args );

	CharSet m_charSet;       // 

	ConnMode m_mode;         // 
	int m_step;              //   

	CAccount* m_account;     // 
	CAccount* m_newAccount;  //    

	CAccount* m_loginAccount;       //   
	char m_newPass[MAX_PASSWORD+1]; //  ,   

	CCharPlayer* m_char;     // 
	CCharPlayer* m_newChar;  //    

	CAccount*    m_child;    // ,    
	CCharPlayer* m_channel;  //      

	static int m_onlineCount; //   On-line
	static int m_maxCount;    //   On-line ()

	CCharPlayer* m_incarnate; // ,    

};
