/*   

	Copyright (c) 2001 - 2004. All Rights Reserved.
	:  ..
*/
#pragma once

//   
class CLogInfo
{

public: // 

	const char* m_name; // 
	bool m_active;      // 
	bool m_toLog;       //  
	CFile* m_file;      //  
};

//  
class CSystemLog
{

public: // , 

	_KERNEL CSystemLog();
	_KERNEL ~CSystemLog();

public: // 

	//   
	_KERNEL bool InitSystemLog();

	//   
	_KERNEL void ResetBaseLog();

	//   
	_KERNEL bool InitCommandLog();

	//   rand
	_KERNEL bool InitRandLog();

	//   
	_KERNEL bool InitPlayer();

	//   
	_KERNEL bool InitCustomLogs();

	//    
	_KERNEL void Flush();

	// 
	_KERNEL void Shutdown();

	//     
	_KERNEL void SystemLog( const char* msg, ... );

	//     
	_KERNEL void CommandLog( uint pulse, int accountID, const char* cmdText );

	//  IP   
	_KERNEL void CommandLogIP( IpAddr ip );

	//     
	_KERNEL void TellLog( const char* text, ... );

	//     rand
	_KERNEL void RandLog( const char* context, long value );

	//    
	_KERNEL bool hasCustomLog( int logId );

	//     
	_KERNEL void setCustomLog( int logId, bool set );

	//     
	_KERNEL void CustomLog( int logId, const char* text );

	//   
	_KERNEL void deleteCustomLogs();

	//     
	_KERNEL bool ReadCommandLog( uint& pulse, int& accountID, char* cmdText, byte& checkValue );

	//   IP  
	_KERNEL bool ReadCommandLogIP( IpAddr& ip );

	// 
	_KERNEL void LogBug( CCharPlayer* cp, const char* text );

	// 
	_KERNEL void LogMisprint( CCharPlayer* cp, const char* text );

	// 
	_KERNEL void LogIdea( CCharPlayer* cp, const char* text );

protected:

	//    
	void InitDir();

public: // 

	char  m_dirName[_MAX_PATH+1]; //   

	CFile m_systemFile;   //   
	CFile m_commandFile;  //   
	uint  m_lastPulse;    //     /  

	CFile m_bugFile;      //   
	CFile m_misprintFile; //   
	CFile m_ideaFile;     //   

	CFile m_tellFile;     //   
	CFile m_randFile;     //    rand()

	CFile m_baseLog;       //  
	CFile m_baseBeginLog;  //   
	CString m_baseLogFile; //    
	CLogInfo *m_customLogs; //  
};
