/*    

	Copyright (c) 2017. All Rights Reserved.
	:  ..
*/
#pragma once

class CByteStore
{

public:

    _KERNEL CByteStore( byte*& buffer, bool store, int version ) :
        m_buffer( buffer ),
        m_store( store ),
        m_version( version )
    {}

    template <typename T>
	void operator<<( const T& t ) { *(T*)m_buffer = t; m_buffer += sizeof( t ); }
    template <typename T>
	void operator>>( T& t ) { t = *(T*)m_buffer; m_buffer += sizeof( t ); }
    template <typename T>
    void operator%( T& t ) { if( IsStoring() ) operator<<( t ); else operator>>( t ); }

    bool IsStoring() { return m_store; }
    int version() { return m_version; }

    void Reserve( int size )
    {
        if( m_buffer )
            delete m_buffer;
        m_buffer = new byte[size];
    }

private:

    byte*&  m_buffer;
    bool    m_store;
    int     m_version;

};