/*     

	Copyright (c) 2015. All Rights Reserved.
	: 
*/
#pragma once

template <class T>
class MemoryArray
{

public: //   

    MemoryArray( int size = 0 );

    ~MemoryArray();

public: // 

    //  
    T* GetNode();

    //  
    void IncreaseSize();

    //  
    void SetSize( int size, int delta = 0 );

    //  
    void FreeNode( T* node );

public: // 

    int m_total;  //  
    int m_occupy; //  
    int m_delta;  //  

    T** m_array;  //  

};

// 
template <class T>
MemoryArray<T>::MemoryArray( int size )
{
    // 
    m_total = size;
    m_occupy = 0;

    // 
    if( m_total )
    {
        //  
        m_array = new T*[m_total];

        //  
        T* memory = new T[m_total];

        //  
        int i; for( i = 0; i < m_total; i++ )
        {
            m_array[i] = &memory[i];
            m_array[i]->m_id = i;
        }

        //SLog( 10, " array ids:\n" );
        //for( i = 0; i < m_total; i++ )
            //SLog( 10, " %d", m_array[i]->m_id );
        //SLog( 10, "\n" );
    }
    else
        m_array = 0;
}

// 
template <class T>
MemoryArray<T>::~MemoryArray()
{
    //  
    int i; for( i = 0; i < m_total; i++ )
        delete m_array[i];

    //  
    delete[] m_array;
}

//  
template <class T>
T* MemoryArray<T>::GetNode()
{
    //SLog( 10, ">> MemoryArray<T>::GetNode\n" );
    //SLog( 10, " total %d, occupy %d\n", m_total, m_occupy );

    //SLog( 10, " 1\n" );

    //  
    if( m_occupy >= m_total )
        IncreaseSize();

    //SLog( 10, " 2\n" );

    //SLog( 10, " array ids: %d %d %d\n", m_occupy <= 0 ? 0 : m_array[m_occupy-1]->m_id, m_array[m_occupy]->m_id, m_occupy+1 >= m_total ? 0 : m_array[m_occupy+1]->m_id );

    //SLog( 10, "<< MemoryArray<T>::GetNode\n" );

    //  
    return m_array[m_occupy++];
}

//  
template <class T>
void MemoryArray<T>::IncreaseSize()
{
    //   
    SetSize( m_total + m_delta );
}

//  
template <class T>
void MemoryArray<T>::FreeNode( T* node )
{
    //SLog( 10, ">> MemoryArray<T>::FreeNode\n" );
    //SLog( 10, " total %d, occupy %d, id %d\n", m_total, m_occupy, node->m_id );

    //   
    if( m_occupy > 0 && m_occupy != node->m_id )
    {
        int free = node->m_id;
        int last = m_occupy-1;
        //SLog( 10, " switch %d <-> %d\n", free, last );

        T* tmp = m_array[free];
        m_array[free] = m_array[last];
        m_array[free]->m_id = free;
        m_array[last] = tmp;
        m_array[last]->m_id = last;

        //SLog( 10, " %d id = %d, %d id = %d\n", free, m_array[free]->m_id, last, m_array[last]->m_id );
    }

    //  
    m_occupy--;

    //SLog( 10, " new occupy %d\n", m_occupy );

    //SLog( 10, "<< MemoryArray<T>::FreeNode\n" );
}

//  
template <class T>
void MemoryArray<T>::SetSize( int size, int delta )
{
    //SLog( 10, ">> MemoryArray<T>::SetSize\n" );
    //SLog( 10, " size %d, total %d, occupy %d\n", size, m_total, m_occupy );
    //SLog( 10, " old delta %d, new delta %d\n", m_delta, delta );

    //  
    if( delta != 0 )
        m_delta = delta;

    //  
    if( size <= m_total )
        return;

    //  
    T** newArray = new T*[size];

    //SLog( 10, " newArray: %d, copy memory %d\n", sizeof(newArray), m_total * sizeof(T*) );

    //   
    if( m_total > 0 )
        ::memcpy( newArray, m_array, m_total * sizeof(T*) );

    //SLog( 10, " add size: %d\n", size-m_total );

    T* memory;

	try {

    //   
    memory = new T[size-m_total];

	} catch(...) { g_log.SystemLog( "Catch: ClassArray::SetSize 1 size %d, newSize %d", m_total, size ); throw; }

    //SLog( 10, " 2\n" );

    //   
    int i; for( i = m_total; i < size; i++ )
    {
        newArray[i] = &memory[i-m_total];
        newArray[i]->m_id = i;
    }
    m_total = size;

    //SLog( 10, " 3\n" );

    //  
    if( m_array )
        delete[] m_array;
    m_array = newArray;

    //SLog( 10, "<< MemoryArray<T>::SetSize\n" );
}
