/*  

	Copyright (c) 2001 - 2004. All Rights Reserved.
	:  ..
*/
#pragma once

// 
class CFile
{

public: // , 

	_KERNEL CFile();
	_KERNEL ~CFile();

public: // 

	//  
	_KERNEL bool Open( const char* name, const char* mode );

	//  
	_KERNEL void Close();

	//    
	_KERNEL void Flush();

	//    
	_KERNEL void Write( const void* data, int size ) { ::fwrite( data, 1, size, m_file ); }

	//    
	_KERNEL int Read( void* data, int size ) { return ::fread( data, 1, size, m_file ); }

	//     
	_KERNEL bool Format( const char* format, ... );

	//  
	_KERNEL void Seek( int pos );

	//   ( 4)
	_KERNEL int Size();

	//  
	_KERNEL bool Eof();

	//   ( )
	_KERNEL bool ReadStr( char* buf, int maxLen ) { return m_file ? ::fgets( buf, maxLen, m_file ) != NULL : false; }

	//  
	_KERNEL void NotCache() { ::setvbuf( m_file, NULL, _IONBF, 0 ); }

	//   
	_KERNEL bool SetBufferSize( size_t size ) { return ::setvbuf( m_file, NULL, _IOFBF, size ) == 0; }

public: // 

	//  
	_KERNEL const char* FileName() const { return m_fileName; }

	//  
	_KERNEL bool IsOpen() const { return m_file != NULL; }

public: // 

	// bool
	_KERNEL void operator<<( bool b ) { Write( &b, sizeof(b) ); }
	_KERNEL void operator>>( bool& b ) { Read( &b, sizeof(b) ); }

	// byte
	_KERNEL void operator<<( byte b ) { Write( &b, sizeof(b) ); }
	_KERNEL void operator>>( byte& b ) { Read( &b, sizeof(b) ); }

	// char
	_KERNEL void operator<<( char ch ) { Write( &ch, sizeof(ch) ); }
	_KERNEL void operator>>( char& ch ) { Read( &ch, sizeof(ch) ); }

	// ushort
	_KERNEL void operator<<( ushort i ) { Write( &i, sizeof(i) ); }
	_KERNEL void operator>>( ushort& i ) { Read( &i, sizeof(i) ); }

	// short
	_KERNEL void operator<<( short i ) { Write( &i, sizeof(i) ); }
	_KERNEL void operator>>( short& i ) { Read( &i, sizeof(i) ); }

	// uint
	_KERNEL void operator<<( uint i ) { Write( &i, sizeof(i) ); }
	_KERNEL void operator>>( uint& i ) { Read( &i, sizeof(i) ); }

	// unsigned long
	_KERNEL void operator<<( unsigned long i ) { Write( &i, sizeof(i) ); }
	_KERNEL void operator>>( unsigned long& i ) { Read( &i, sizeof(i) ); }

	// int
	_KERNEL void operator<<( int i ) { Write( &i, sizeof(i) ); }
	_KERNEL void operator>>( int& i ) { Read( &i, sizeof(i) ); }

	// double
	_KERNEL void operator<<( double i ) { Write( &i, sizeof(i) ); }
	_KERNEL void operator>>( double& i ) { Read( &i, sizeof(i) ); }

	// int64
	_KERNEL void operator<<( int64 i ) { Write( &i, sizeof(i) ); }
	_KERNEL void operator>>( int64& i ) { Read( &i, sizeof(i) ); }

	// uint64
	_KERNEL void operator<<( uint64 i ) { Write( &i, sizeof(i) ); }
	_KERNEL void operator>>( uint64& i ) { Read( &i, sizeof(i) ); }

	//  
	_KERNEL void operator<<( const char* str ) { Write( str, strlen( str ) ); }

protected: // 

	CString m_fileName; //  
	FILE*   m_file;     // 

};
