/*   

	Copyright (c) 2010. All Rights Reserved.
	: .
*/
#pragma once

#include "DB/Char/Char.h"

//   
enum FormType
{
	FT_NAME = 0,
	FT_GENDER,
	FT_COUNT
};

//    
class MessStr
{

public: // 

	MessStr( FormType type, CChar* c, bool invis, bool remove ) :
		m_type( type ),
		m_char( c ),
		m_invis( invis ),
		m_remove( remove )
	{}

public: // 

	FormType m_type; //  
	CChar* m_char;   // 
	bool m_invis;    //   
	bool m_remove;   //   

};

//    
class GenderStr : public MessStr
{

public: // 

	GenderStr() :
		MessStr( FT_GENDER, NULL, false, false ),
		m_male( NULL ), m_female( NULL ), m_neutral( NULL ), m_multiple( NULL )
	{}

	GenderStr( CChar* c, char* male, char* female, char* neutral, char* multiple, bool invis = true ) :
		MessStr( FT_GENDER, c, invis, true ),
		m_male( male ),
		m_female( female ),
		m_neutral( neutral ),
		m_multiple( multiple )
	{}

	GenderStr( CChar* c, SwitchType type, bool invis = true ) :
		MessStr( FT_GENDER, c, invis, true )
	{
		m_male     = GenderSwitch( GENDER_MALE,     type );
		m_female   = GenderSwitch( GENDER_FEMALE,   type );
		m_neutral  = GenderSwitch( GENDER_NEUTRAL,  type );
		m_multiple = GenderSwitch( GENDER_MULTIPLE, type );
	}

public: // 

	char* m_male;     //  
	char* m_female;   //  
	char* m_neutral;  //  
	char* m_multiple; //  

};

//    
class NameStr : public MessStr
{

public: // 

	NameStr() :
		MessStr( FT_NAME, NULL, false, false ),
		m_case( 0 )
	{}

	NameStr( CChar* c, CaseType cas = CT_IMEN, bool invis = true ) :
		MessStr( FT_NAME, c, invis, true ),
		m_case( cas )
	{}

public: // 

	byte m_case; // 

};

//     
_KERNEL int __cdecl msprintf( CChar* c, char *buf, const char *fmt, va_list args );
