/*  

	Copyright (c) 2011. All Rights Reserved.
	: .
*/
#pragma once

//  
class CFormulaSubdata
{

public: // 

	_KERNEL virtual int getData( int num = 1 ) { return 0; } //  
	_KERNEL virtual double getValue() { return 0; }          //  

};



//  
class CFormulaValueSubdata : public CFormulaSubdata
{

public: // 

	_KERNEL CFormulaValueSubdata( double value ) :
		m_value( value )
	{}

public: // 

	//  
	_KERNEL double getValue() { return m_value; }

public:

	double m_value; // 

};



//  
class CFormulaActionSubdata : public CFormulaSubdata
{

public: // 

	_KERNEL CFormulaActionSubdata( FormulaAction act ) :
		m_action( act )
	{}

public: // 

	//  
	_KERNEL int getData( int num = 1 ) { return m_action; }

public:

	byte m_action; // 

};



//  
class CFormulaVarSubdata : public CFormulaSubdata
{

public: // 

	_KERNEL CFormulaVarSubdata( FormulaCharType ch, FormulaVarType var, int abilId = -1 ) :
		m_char( ch ), m_var( var ), m_ability( abilId )
	{}

public: // 

	//  
	_KERNEL int getData( int num = 1 ) { return num == 1 ? m_var : ( num == 2 ? m_char : m_ability ); }

public: // 

	byte m_char;   //  
	byte m_var;    //  
	int m_ability; //  

};



//  
class CFormulaBracketSubdata : public CFormulaSubdata
{

public: // 

	_KERNEL CFormulaBracketSubdata( bool open ) :
		m_open( open )
	{}

public: // 

	//  
	int getData( int num = 1 ) { return m_open; }

public: // 

	bool m_open; //  

};



//  
class CFormulaNode
{

public: // 

	CFormulaNode() {};

	CFormulaNode( FormulaNodeType type ) :
		m_type( type )
	{}

public:

	_KERNEL double value( CChar* c1, CChar* c2 ); //  
	_KERNEL bool checkPerc( CChar* c1, CChar* c2 ); //  
	_KERNEL bool check( CChar* c1, CChar* c2 ); //  
	_KERNEL void logNode( int level ); //   

	_KERNEL void Null(); //   
	_KERNEL void Clone( CFormulaNode* node ); //  

	_KERNEL void Parse( const char* text ); //    
	_KERNEL void Parse( PArray<CFormulaNode*>* nodes, int ind1, int ind2 ); //    

public:

	byte m_type;                // 
	CFormulaSubdata* m_subData; // 
	CFormulaNode* m_left;       //  
	CFormulaNode* m_right;      //  

};



//    
class CFormulaCheck
{

public: // 

	_KERNEL CFormulaCheck( const char* txtVal = 0, const char* txtCheck = 0 );

public: // 

	//   
	_KERNEL void Serialize( CFileStore& fs );

public: // 

	CFormulaNode* m_check; //  
	CFormulaNode* m_value; //  

};



//    
class CFormulaBranch
{

public: // 

	_KERNEL CFormulaBranch();

public: // 

	//   
	_KERNEL void Serialize( CFileStore& fs );

    //  
    _KERNEL void AddNode( const char* txtVal, const char* txtCheck = 0 );

	//  
	_KERNEL double value( CChar* c1, CChar* c2 );

	//  
	_KERNEL bool checkPerc( CChar* c1, CChar* c2 );

public: // 

	PArray<CFormulaCheck*> m_nodes;  // 

};
