/*    - 

	Copyright  2016. All Rights Reserved.
	:  ..
*/

#pragma once

template <class T1, class T2>
class Pair
{

public: // 

    Pair( T1 val1, T2 val2 ) :
        m_val1( val1 ),
        m_val2( val2 )
    {}

    Pair() :
        m_val1( 0 ),
        m_val2( 0 )
    {}

public: // 

    // 
    void Serialize( CFileStore& fs );

    //  
    T1 val1() { return m_val1; }
    T2 val2() { return m_val2; }

    //  
    void setVal1( T1 val ) { m_val1 = val; }
    void setVal2( T2 val ) { m_val2 = val; }

private: // 

    T1 m_val1; //  
    T2 m_val2; //  

};

// 
template <class T1, class T2>
void Pair<T1,T2>::Serialize( CFileStore& fs )
{
    if( fs.IsStoring() )
    {
        fs << m_val1;
        fs << m_val2;
    }
    else
    {
        fs >> m_val1;
        fs >> m_val2;
    }
}
