/*  

	Copyright (c) 2001 - 2004. All Rights Reserved.
	:  ..
*/
#pragma once

// 
const int SOCK_RCV_BUFSIZE = 512;      //    512 
const int SOCK_SND_BUFSIZE = 1024*8;   //    8 

struct sockAddrIn
{
	short          sin_family;
	unsigned short sin_port;
	IpAddr         sin_addr;
	char           sin_zero[8];
};

// 
class CSocket
{

public: //   

	_KERNEL CSocket( unsigned int s = 0 );
	_KERNEL ~CSocket();

public: // 

	//  
	_KERNEL int Open( unsigned int port );

	//  
	_KERNEL CSocket* Accept();

	//    
	_KERNEL bool Write( const char* txt, int len = -1 );

	//    
	_KERNEL int Read( char* txt, int len ) { return PerformSocketRead( txt, len ); }

	//  
	_KERNEL int PerformSocketWrite( const char *txt, int len );

	//  
	_KERNEL int PerformSocketRead( char *buffer, int len );

	// IP   
	_KERNEL const char* ipText() const { return IPAsStr( m_ip ); }

public:

	unsigned int m_socket;  // 
	IpAddr m_ip;     //   IP

public:  //   

	static int64 m_inPackets;   //  
	static int64 m_inBytes;     //  
	static int64 m_outPackets;  //  
	static int64 m_outBytes;    //  

};
