/*    
	Copyright (c) 2012. All Rights Reserved.
	: .
*/
#pragma once

//   
class CMobUnitTrace
{

public: //   

	_KERNEL CMobUnitTrace( CMobUnit* mobUnit );

	_KERNEL ~CMobUnitTrace();

public: // 

	//  
	_KERNEL CCharMob* mob() { return m_mobUnit ? m_mobUnit->m_mob : NULL; }

	// 
	_KERNEL bool Init( CZoneInstance* zoneInst = NULL );

	//  
	_KERNEL void Trace();

public: // 

	CMobUnit* m_mobUnit; //  
	CRoom* m_traceRoom;  //  

};

// -
class CMobAssister
{

public: //   

	_KERNEL CMobAssister( int roomId, int mobId, int count, int pulse, bool fromFight = false, const char* hi = NULL, const char* ho = NULL, const char* ti = NULL, const char* to = NULL, CRoomUnit* specRoom = NULL );

	_KERNEL ~CMobAssister();

public: // 

	// 
	_KERNEL bool Init( CZoneInstance* zoneInst = NULL );

	//  
	_KERNEL CCharMob* mob() { return m_mobTrace ? m_mobTrace->mob() : NULL; }

public: // 

	CMobUnitTrace* m_mobTrace; //  
	uint m_pulse;              //  

	bool m_fromFight;          //   

	const char* m_hereIn;      //  : 
	const char* m_hereOut;     //  :  
	const char* m_thereIn;     //  : 
	const char* m_thereOut;    //  : 

	CRoomUnit* m_specRoom;     //  

	bool m_summoned;           //  

};

//  -
class CMobAssistTable
{

public: //   

	_KERNEL CMobAssistTable( CZoneInstance* zoneInst, int roomId, int mobId, int count, int cooldown, const char* msgIn = NULL, const char* msgOut = NULL, int addPulse = 600 );

	_KERNEL ~CMobAssistTable();

public: // 

	// 
	_KERNEL void Init();

	//  
	_KERNEL void AddAssister( CMobAssister* assister );

	//  
	_KERNEL CCharMob* mob() { return m_mobTrace ? m_mobTrace->mob() : NULL; }

public: // 

	CZoneInstance* m_zoneInst;  //  

	CMobUnitTrace* m_mobTrace;  //  
	int m_cooldown;             // 
	int m_addPulse;             //  

	const char* m_msgIn;        //  
	const char* m_msgOut;       //  

	PArray<CMobAssister*> m_assisters; // 

	byte m_action;              //  
	uint m_agroPulse;           // 
	int m_agroCount;            //  
	uint m_waitPulse;           //  
	uint m_shiftPulse;          //  

};

//  
class CCustomTriggerBase
{

public: // 

	_KERNEL CCustomTriggerBase();

public: // 

	//  
	_KERNEL void PerformPulse();

	//   -
	_KERNEL void AddAssistTable( CMobAssistTable* at );

	//   -
	_KERNEL void RemoveAssistTable( CMobAssistTable* at );

	//   -
	_KERNEL CMobAssistTable* FindAssistTable( CCharMob* mob );

	//   
	_KERNEL void UpdateAssistExist();

    //   
    _KERNEL void LogTables();

public: // 

	PArray<CMobAssistTable*> m_assistTables;
	bool m_assistExist;

};
