/*    

	Copyright (c) 2001 - 2004. All Rights Reserved.
	:  ..
*/
#pragma once
#define WIN_SET
#define FD_SETSIZE 1001 //    +   
#define _USE_32BIT_TIME_T 1
#define _MAX_PATH 260

#include <stdio.h>
#include <io.h>
#include <errno.h>
#include <time.h>
#include <math.h>

#ifdef WIN_SET
	#include <winsock.h>
#else
	#include <windef.h>
	#include <sys/socket.h>
	#include <string.h>
	#include <stdlib.h>
	#include <stdarg.h>
	#include <winbase.h>
	#include <signal.h>
	#include <wctype.h>
	#include <unistd.h>
	#include <fcntl.h>
#endif

//#define MINIMAL

#ifdef BUILD_KERNEL
#define _KERNEL _declspec(dllexport)
#else
#define _KERNEL _declspec(dllimport)
#endif

// 
const int APP_VERSION = 476;

//   types.h
//  -  
#ifdef WIN_SET

#define isalpha(ch) ( ::IsCharAlpha( ch ) || (ch) == '_' )

#else

#define isalpha(ch) ( iswalpha( ch ) != 0 || (ch) == '_' )

#endif

#define isspace(ch) ( (ch) == ' ' || (ch) == '\t' || (ch) == '\n' || (ch) == '\r' )
#define isdigit(ch) ( (ch) >= '0' && (ch) <= '9' )

//   (   )
#define isralpha(ch) ( (unsigned char)ch >= (unsigned char)'' )

//  
typedef signed char sbyte;
typedef unsigned char byte;
typedef unsigned int uint;
typedef unsigned short ushort;
typedef __int64 int64;
typedef unsigned __int64 uint64;

// 
class CConnection;

class CAccount;
class IpAddr;
class CChar;
class CCharMob;
class CCharPlayer;
class CCharRestrict;
class CObjFilter;
class CAbilValue;
class CCustomAbility;
class CNameInfo;
class CClan;
class CFraction;
class CTrnZone;
class CTrnGroup;
class CPointListNode;
class CStoreNode;
class PkInfo;
class CCharAddon;
class CInvisibleEyeMob;
class CObjExtData;
class CSubject;
class CLetterSubject;
class CDoorSubject;
class CPortalSubject;
class CCorpseSubject;
class CWeaponSubject;
class CBookSubject;
class COldBookSubject;
class COldBookItem;
class CObjPlace;
class FightSituation;
class CDeletedObj;
class CTimerObj;

class CModifier;
class CMobFactory;
class CMobPrototype;
class CObjPrototype;
class CObjSubType;
class CObjSellData;

class CProfession;
class CRace;
class CMaterial;
class CWater;
class CResistInfo;

class CSkill;
class CSpell;
class CAffect;
class CAffectGrade;
class CColumn;

class CWeaponSkill;
class CDamageStr;
class CDamageType;
class CIngrColor;
class CSlot;
class CHotel;
class CWalkMethod;

class CWorld;
class CZone;
class CZoneUser;
class CZoneInstance;
class CRoom;
class CMobPopData;
class CObjPopInRoomData;
class CObjPopOnMobData;

class CPointListNodeLoadData;
class CRoomBaseData;
class CDoorLinkBaseData;

class CQuestStatus;
class CDailyTaskInfoNode;

class CTriggerEntry;
class CTriggerHandler;
class CTriggerData;
class CTriggerFileInfo;
class CBan;
class CBoard;
class CJournal;
class CAnnounce;

class COffer;
class CAuctionOffer;
class CCommodity;
class CShop;
class CTopic;
class CTopicKey;

class CDBObject;
class CDBClass;

class CTransportNet;

class CGradeBase;
class CGloryBase;
class NameStr;
class GenderStr;
class CFormulaBranch;
class CBaseMobPrototype;
class CComplexMobPrototype;
class CTempInfo;

#include "DB/Types.h"
#include "Tools/Tools.h"
#include "Tools/FileEntry.h"
#include "Tools/Mask.h"
#include "Tools/Network.h"
#include "System/SystemLog.h"
#include "System/CmdLine.h"
#include "System/Resources.h"

#include "System/CommandMng.h"
#include "System/TriggerMng.h"

#include "App.h"
#include "DB/DB.h"

//  
extern _KERNEL CSystemLog      g_log;
extern _KERNEL CCommandLine    g_cmdLine;
extern _KERNEL CApp            g_app;
extern _KERNEL CDB             g_db;
extern _KERNEL CCommandManager g_cmdMng;
extern _KERNEL CTriggerManager g_trgMng;
extern _KERNEL CResources      g_res;

//    
extern _KERNEL CFile g_debug;
extern _KERNEL bool g_toLog;

//  Ctrl+Break
_KERNEL BOOL _stdcall CtrlBreakHandler( DWORD dwCtrlType );
